asm_comma
	LD A,','
	LD [asmc.A.],A
	CALL asmc
	RET
asm_open
	LD A,'['
	LD [asmc.A.],A
	CALL asmc
	RET
asm_close
	LD A,']'
	LD [asmc.A.],A
	CALL asmc
	RET
asm_rname
	LD HL,_RNAME
	LD A,[asm_rname.r]
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD A,[HL]
	INC HL
	LD H,[HL]
	LD L,A
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_mrgname
	CALL asm_open
	LD A,[asm_mrgname.r]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL asm_close
	RET
asm_rlow
	LD HL,_RLOW
	LD A,[asm_rlow.r]
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD A,[HL]
	INC HL
	LD H,[HL]
	LD L,A
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_rhigh
	LD HL,_RHIGH
	LD A,[asm_rhigh.r]
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD A,[HL]
	INC HL
	LD H,[HL]
	LD L,A
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_close_eol
	CALL asm_close
	CALL endasm
	RET
asm_a
	LD A,'A'
	LD [asmc.A.],A
	CALL asmc
	RET
asm_hl
	LD A,_RFAST
	LD [asm_rname.A.],A
	CALL asm_rname
	RET
asm_mhl
	LD A,_RFAST
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	RET
var_db
	LD HL,var_db.A.
	LD [varstr.A.],HL
	CALL varstr
	RET
var_dw
	LD HL,var_dw.A.
	LD [varstr.A.],HL
	CALL varstr
	RET
var_dl
	LD HL,var_dl.A.
	LD [varstr.A.],HL
	CALL varstr
	RET
asm_and
	LD HL,asm_and.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_or
	LD HL,asm_or.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_xor
	LD HL,asm_xor.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_sub
	LD HL,asm_sub.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_sbc
	LD HL,asm_sbc.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_add
	LD HL,asm_add.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_adc
	LD HL,asm_adc.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_inc
	LD HL,asm_inc.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_dec
	LD HL,asm_dec.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_ld
	LD HL,asm_ld.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_jp
	LD HL,asm_jp.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_ex
	LD HL,asm_ex.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_push
	LD HL,asm_push.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_pop
	LD HL,asm_pop.A.
	LD [asmstr.A.],HL
	CALL asmstr
	RET
asm_lda_comma
	CALL asm_ld
	CALL asm_a
	CALL asm_comma
	RET
asm_ldmhl_comma
	CALL asm_ld
	CALL asm_mhl
	CALL asm_comma
	RET
asm_comma_a_eol
	CALL asm_comma
	CALL asm_a
	CALL endasm
	RET
asm_comma_mhl_eol
	CALL asm_comma
	CALL asm_mhl
	CALL endasm
	RET
asm_inchl_eol
	CALL asm_inc
	LD A,_RFAST
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	RET
asm_exa_eol
	CALL asm_ex
	LD HL,asm_exa_eol.A.
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	RET
asm_exd_eol
	CALL asm_ex
	LD HL,asm_exd_eol.A.
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	RET
asm_ccf_eol
	LD HL,asm_ccf_eol.A.
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	RET
asm_call_eol
	LD HL,asm_call_eol.B.
	LD [asmstr.A.],HL
	CALL asmstr
	LD HL,[asm_call_eol.s]
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	RET
unproxy
	LD A,[_rproxy]
	SUB 0x00
	JP Z,unproxy.A.
	CALL asm_ld
	LD A,[_rproxy]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
	LD A,0x00
	LD [_rproxy],A
unproxy.A.
	RET
proxy
	LD A,[_rproxy]
	LD L,A
	LD A,[proxy.r]
	SUB L
	JP Z,proxy.B.
	CALL unproxy
	CALL asm_lda_comma
	LD A,[proxy.r]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	LD A,[proxy.r]
	LD [_rproxy],A
proxy.B.
	RET
emitpushrg
	CALL unproxy
	CALL asm_push
	LD A,[emitpushrg.rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	LD HL,[_funcstkdepth]
	INC HL
	LD [_funcstkdepth],HL
	RET
emitpoprg
	CALL asm_pop
	LD A,[emitpoprg.rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	LD HL,[_funcstkdepth]
	DEC HL
	LD [_funcstkdepth],HL
	RET
emitmovrg
	LD A,[emitmovrg.rsrc]
	LD L,A
	LD A,[emitmovrg.rdest]
	SUB L
	JP Z,emitmovrg.C.
	LD A,[emitmovrg.rdest]
	SUB _RFAST4
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[emitmovrg.rsrc]
	SUB _RFAST
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	AND E
	LD L,A
	LD A,[emitmovrg.rdest]
	SUB _RFAST
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,[emitmovrg.rsrc]
	SUB _RFAST4
	LD C,0
	JR NZ,$+3
	DEC C
	LD A,E
	AND C
	OR L
	JP Z,emitmovrg.E.
	CALL asm_push
	LD A,[emitmovrg.rsrc]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	CALL asm_pop
	LD A,[emitmovrg.rdest]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	JP emitmovrg.F.
emitmovrg.E.
	CALL asm_ld
	LD A,[emitmovrg.rdest]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma
	LD A,[emitmovrg.rsrc]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_ld
	LD A,[emitmovrg.rdest]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma
	LD A,[emitmovrg.rsrc]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
emitmovrg.F.
emitmovrg.C.
	RET
emitjpmainrg
	CALL unproxy
	CALL getnothing
	CALL asm_jp
	CALL asm_mhl
	CALL endasm
	RET
emitcallmainrg
	CALL unproxy
	CALL getnothing
	LD HL,emitcallmainrg.A.
	LD [asm_call_eol.A.],HL
	CALL asm_call_eol
	LD A,FALSE
	LD [_fused],A
	RET
emitjp
	CALL unproxy
	CALL getnothing
	CALL asm_jp
	LD HL,[_joined]
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	RET
emitbtoz
	LD A,[_fused]
	CPL
	OR A
	JP Z,emitbtoz.A.
	LD A,[_rnew]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_or
	CALL asm_a
	CALL endasm
emitbtoz.A.
	LD A,0x00
	LD [_rproxy],A
	RET
emitjpiffalse
	CALL getnothing
	CALL asm_jp
	LD A,[_jpflag]
	SUB 0x02
	JP NZ,emitjpiffalse.A.
	LD HL,emitjpiffalse.C.
	LD [asmstr.A.],HL
	CALL asmstr
	JP emitjpiffalse.B.
emitjpiffalse.A.
	LD A,[_jpflag]
	SUB 0x03
	JP NZ,emitjpiffalse.D.
	LD HL,emitjpiffalse.F.
	LD [asmstr.A.],HL
	CALL asmstr
	JP emitjpiffalse.E.
emitjpiffalse.D.
	LD A,[_jpflag]
	SUB 0x04
	JP NZ,emitjpiffalse.G.
	LD A,'C'
	LD [asmc.A.],A
	CALL asmc
	JP emitjpiffalse.H.
emitjpiffalse.G.
	LD A,'Z'
	LD [asmc.A.],A
	CALL asmc
emitjpiffalse.H.
emitjpiffalse.E.
emitjpiffalse.B.
	CALL asm_comma
	LD HL,[_joined]
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	LD A,FALSE
	LD [_fused],A
	LD A,0x00
	LD [_jpflag],A
	RET
emitret
	LD HL,emitret.A.
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	RET
emitcall2rgs
	CALL unproxy
	CALL getmain2rgs
	CALL initrgs
	LD HL,[emitcall2rgs.s]
	LD [asm_call_eol.A.],HL
	CALL asm_call_eol
	CALL setmainrg
	RET
emitcall4rgs
	CALL unproxy
	CALL getmain4rgs
	CALL initrgs
	LD HL,[emitcall4rgs.s]
	LD [asm_call_eol.A.],HL
	CALL asm_call_eol
	CALL setmain2rgs
	RET
emitcallproc
	LD HL,[_callee]
	LD [asm_call_eol.A.],HL
	CALL asm_call_eol
	RET
emitloadrg
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL asm_comma
	LD HL,[_const]
	LD [asmstr.A.],HL
	CALL asmstr
	LD A,[emitloadrg.high]
	OR A
	JP Z,emitloadrg.B.
	LD HL,emitloadrg.D.
	LD [asmstr.A.],HL
	CALL asmstr
emitloadrg.B.
	CALL endasm
	LD A,FALSE
	LD [_fused],A
	RET
emitloadrg0
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL asm_comma
	LD A,'0'
	LD [asmc.A.],A
	CALL asmc
	CALL endasm
	RET
emitloadb
	LD A,[_rproxy]
	SUB 0x00
	JP NZ,emitloadb.A.
	LD A,[_rnew]
	LD [_rproxy],A
	CALL asm_lda_comma
	JP emitloadb.B.
emitloadb.A.
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma
emitloadb.B.
	LD HL,[_const]
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	LD A,FALSE
	LD [_fused],A
	RET
emitgetrg
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL asm_comma
	CALL asm_open
	LD HL,[_joined]
	LD [asmstr.A.],HL
	CALL asmstr
	LD A,[emitgetrg.high]
	OR A
	JP Z,emitgetrg.B.
	LD A,'+'
	LD [asmc.A.],A
	CALL asmc
	LD A,'2'
	LD [asmc.A.],A
	CALL asmc
emitgetrg.B.
	CALL asm_close
	CALL endasm
	RET
emitgetb
	CALL unproxy
	LD A,[_rnew]
	LD [_rproxy],A
	CALL asm_lda_comma
	CALL asm_open
	LD HL,[_joined]
	LD [asmstr.A.],HL
	CALL asmstr
	CALL asm_close
	CALL endasm
	RET
emitputrg
	CALL asm_ld
	CALL asm_open
	LD HL,[_joined]
	LD [asmstr.A.],HL
	CALL asmstr
	LD A,[emitputrg.high]
	OR A
	JP Z,emitputrg.B.
	LD A,'+'
	LD [asmc.A.],A
	CALL asmc
	LD A,'2'
	LD [asmc.A.],A
	CALL asmc
emitputrg.B.
	CALL asm_close
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	LD A,FALSE
	LD [_fused],A
	RET
emitputb
	LD A,[_rnew]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_ld
	CALL asm_open
	LD HL,[_joined]
	LD [asmstr.A.],HL
	CALL asmstr
	CALL asm_close
	CALL asm_comma_a_eol
	LD A,0x00
	LD [_rproxy],A
	LD A,FALSE
	LD [_fused],A
	RET
emitshl1rg
	LD A,[_rnew]
	SUB _RFAST
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	JP Z,emitshl1rg.A.
	CALL asm_add
	CALL asm_hl
	CALL asm_comma
	CALL asm_hl
	CALL endasm
	JP emitshl1rg.B.
emitshl1rg.A.
	LD HL,emitshl1rg.C.
	LD [asmstr.A.],HL
	CALL asmstr
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	LD HL,emitshl1rg.D.
	LD [asmstr.A.],HL
	CALL asmstr
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
emitshl1rg.B.
	RET
emitshl1b
	LD A,[_rnew]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_add
	CALL asm_a
	CALL asm_comma_a_eol
	RET
emitinvb
	LD A,[_rnew]
	LD [proxy.A.],A
	CALL proxy
	LD HL,emitinvb.A.
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	LD A,FALSE
	LD [_fused],A
	RET
emitinvrg
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	LD HL,emitinvrg.A.
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
	CALL emitinvb
	RET
emitnegrg
	CALL unproxy
	CALL asm_xor
	CALL asm_a
	CALL endasm
	CALL asm_sub
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
	CALL asm_sbc
	CALL asm_a
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_sub
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
	RET
emitSxorVtocy
	LD HL,emitSxorVtocy.A.
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	CALL asm_jp
	LD HL,emitSxorVtocy.B.
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	CALL asm_ccf_eol
	RET
emitinvSxorVtocy
	LD HL,emitinvSxorVtocy.A.
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	CALL asm_jp
	LD HL,emitinvSxorVtocy.B.
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	CALL asm_ccf_eol
	RET
emitxorrg
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_xor
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_xor
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
	RET
getxorb
	LD A,[_rproxy]
	LD L,A
	LD A,[_rnew]
	SUB L
	JP NZ,getxorb.A.
	CALL asm_xor
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	LD A,[_rold]
	LD [_rproxy],A
	JP getxorb.B.
getxorb.A.
	LD A,[_rold]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_xor
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
getxorb.B.
	CALL endasm
	LD A,TRUE
	LD [_fused],A
	RET
emitorrg
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_or
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_or
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
	RET
getorb
	LD A,[_rproxy]
	LD L,A
	LD A,[_rnew]
	SUB L
	JP NZ,getorb.A.
	CALL asm_or
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	LD A,[_rold]
	LD [_rproxy],A
	JP getorb.B.
getorb.A.
	LD A,[_rold]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_or
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
getorb.B.
	CALL endasm
	LD A,TRUE
	LD [_fused],A
	RET
emitandrg
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_and
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_and
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
	RET
getandb
	LD A,[_rproxy]
	LD L,A
	LD A,[_rnew]
	SUB L
	JP NZ,getandb.A.
	CALL asm_and
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	LD A,[_rold]
	LD [_rproxy],A
	JP getandb.B.
getandb.A.
	LD A,[_rold]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_and
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
getandb.B.
	CALL endasm
	LD A,TRUE
	LD [_fused],A
	RET
emitaddrg
	LD A,[_rold]
	SUB _RFAST
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitaddrg.A.
	CALL asm_add
	CALL asm_hl
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	JP emitaddrg.B.
emitaddrg.A.
	LD A,[_rold]
	SUB _RFAST2
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitaddrg.C.
	CALL asm_exd_eol
	CALL asm_add
	CALL asm_hl
	CALL asm_comma
	LD A,[_rnew]
	SUB _RFAST
	JP NZ,emitaddrg.E.
	LD A,_RFAST2
	LD [asm_rname.A.],A
	CALL asm_rname
	JP emitaddrg.F.
emitaddrg.E.
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
emitaddrg.F.
	CALL endasm
	CALL asm_exd_eol
	JP emitaddrg.D.
emitaddrg.C.
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_add
	CALL asm_a
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_adc
	CALL asm_a
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
emitaddrg.D.
emitaddrg.B.
	RET
emitadcrg
	LD A,[_rold]
	SUB _RFAST
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitadcrg.A.
	CALL asm_adc
	CALL asm_hl
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	JP emitadcrg.B.
emitadcrg.A.
	LD A,[_rold]
	SUB _RFAST2
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitadcrg.C.
	CALL asm_exd_eol
	CALL asm_adc
	CALL asm_hl
	CALL asm_comma
	LD A,[_rnew]
	SUB _RFAST
	JP NZ,emitadcrg.E.
	LD A,_RFAST2
	LD [asm_rname.A.],A
	CALL asm_rname
	JP emitadcrg.F.
emitadcrg.E.
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
emitadcrg.F.
	CALL endasm
	CALL asm_exd_eol
	JP emitadcrg.D.
emitadcrg.C.
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_adc
	CALL asm_a
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_adc
	CALL asm_a
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
emitadcrg.D.
emitadcrg.B.
	RET
emitaddb
	LD A,[_rproxy]
	LD L,A
	LD A,[_rnew]
	SUB L
	JP NZ,emitaddb.A.
	CALL asm_add
	CALL asm_a
	CALL asm_comma
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	LD A,[_rold]
	LD [_rproxy],A
	JP emitaddb.B.
emitaddb.A.
	LD A,[_rold]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_add
	CALL asm_a
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
emitaddb.B.
	RET
emitaddbconst
	LD A,[_rnew]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_add
	CALL asm_a
	CALL asm_comma
	LD HL,[_const]
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	RET
emitsubrg
	LD A,[_rold]
	SUB _RFAST
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitsubrg.A.
	CALL asm_or
	CALL asm_a
	CALL endasm
	CALL asm_sbc
	CALL asm_hl
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	JP emitsubrg.B.
emitsubrg.A.
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_sub
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_sbc
	CALL asm_a
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
emitsubrg.B.
	RET
emitsbcrg
	LD A,[_rold]
	SUB _RFAST
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitsbcrg.A.
	CALL asm_sbc
	CALL asm_hl
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	JP emitsbcrg.B.
emitsbcrg.A.
	LD A,[_rold]
	SUB _RFAST2
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitsbcrg.C.
	CALL asm_exd_eol
	CALL asm_sbc
	CALL asm_hl
	CALL asm_comma
	LD A,[_rnew]
	SUB _RFAST
	JP NZ,emitsbcrg.E.
	LD A,_RFAST2
	LD [asm_rname.A.],A
	CALL asm_rname
	JP emitsbcrg.F.
emitsbcrg.E.
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
emitsbcrg.F.
	CALL endasm
	CALL asm_exd_eol
	JP emitsbcrg.D.
emitsbcrg.C.
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_sbc
	CALL asm_a
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_sbc
	CALL asm_a
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
emitsbcrg.D.
emitsbcrg.B.
	RET
emitsubb
	LD A,[_rold]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_sub
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	RET
emitsubflags
	CALL unproxy
	CALL asm_lda_comma
	LD A,[emitsubflags.rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_sub
	LD A,[emitsubflags.rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_lda_comma
	LD A,[emitsubflags.rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_sbc
	CALL asm_a
	CALL asm_comma
	LD A,[emitsubflags.rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	LD A,TRUE
	LD [_fused],A
	RET
emitsubbflags
	LD A,[emitsubbflags.aold]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_sub
	LD A,[emitsubbflags.anew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	LD A,0x00
	LD [_rproxy],A
	LD A,TRUE
	LD [_fused],A
	RET
emitsubz
	LD A,[_rold]
	SUB _RFAST
	JP NZ,emitsubz.A.
	CALL emitsubrg
	JP emitsubz.B.
emitsubz.A.
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_sub
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	LD A,[_rold]
	SUB _RFAST4
	LD L,0
	JR Z,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitsubz.C.
	LD HL,emitsubz.E.
	LD [asmstr.A.],HL
	CALL asmstr
	JP emitsubz.D.
emitsubz.C.
	LD HL,emitsubz.F.
	LD [asmstr.A.],HL
	CALL asmstr
emitsubz.D.
	CALL endasm
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_sub
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
emitsubz.B.
	LD A,TRUE
	LD [_fused],A
	RET
emitsubbz
	LD A,[_rproxy]
	LD L,A
	LD A,[_rnew]
	SUB L
	JP NZ,emitsubbz.A.
	CALL asm_sub
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	JP emitsubbz.B.
emitsubbz.A.
	LD A,[_rold]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_sub
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
emitsubbz.B.
	CALL endasm
	LD A,0x00
	LD [_rproxy],A
	LD A,TRUE
	LD [_fused],A
	RET
emitsubbzconst
	LD A,[_rnew]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_sub
	LD HL,[_const]
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	LD A,0x00
	LD [_rproxy],A
	LD A,TRUE
	LD [_fused],A
	RET
emitsublongz
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rold2]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_sub
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	LD A,[_rold3]
	SUB _RFAST4
	LD L,0
	JR Z,$+3
	DEC L
	LD A,[_rold]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitsublongz.A.
	LD HL,emitsublongz.C.
	LD [asmstr.A.],HL
	CALL asmstr
	JP emitsublongz.B.
emitsublongz.A.
	LD HL,emitsublongz.D.
	LD [asmstr.A.],HL
	CALL asmstr
emitsublongz.B.
	CALL endasm
	CALL asm_lda_comma
	LD A,[_rold2]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_sub
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	LD A,[_rold3]
	SUB _RFAST4
	LD L,0
	JR Z,$+3
	DEC L
	LD A,[_rold]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitsublongz.E.
	LD HL,emitsublongz.G.
	LD [asmstr.A.],HL
	CALL asmstr
	JP emitsublongz.F.
emitsublongz.E.
	LD HL,emitsublongz.H.
	LD [asmstr.A.],HL
	CALL asmstr
emitsublongz.F.
	CALL endasm
	CALL asm_lda_comma
	LD A,[_rold3]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_sub
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	LD A,[_rold3]
	SUB _RFAST4
	LD L,0
	JR Z,$+3
	DEC L
	LD A,[_rold]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitsublongz.I.
	LD HL,emitsublongz.K.
	LD [asmstr.A.],HL
	CALL asmstr
	JP emitsublongz.J.
emitsublongz.I.
	LD HL,emitsublongz.L.
	LD [asmstr.A.],HL
	CALL asmstr
emitsublongz.J.
	CALL endasm
	CALL asm_lda_comma
	LD A,[_rold3]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_sub
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	LD A,TRUE
	LD [_fused],A
	RET
emitpokerg
	LD A,[_rold]
	SUB _RFAST
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitpokerg.A.
	CALL asm_ldmhl_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_inchl_eol
	CALL asm_ldmhl_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	JP emitpokerg.B.
emitpokerg.A.
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL asm_comma_a_eol
	CALL asm_inc
	LD A,[_rold]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL asm_comma_a_eol
emitpokerg.B.
	LD A,FALSE
	LD [_fused],A
	RET
emitpokeb
	LD A,[_rold]
	SUB _RFAST
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	LD L,A
	LD A,[_rproxy]
	LD E,A
	LD A,[_rnew]
	SUB E
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitpokeb.A.
	CALL asm_ld
	CALL asm_mhl
	CALL asm_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	JP emitpokeb.B.
emitpokeb.A.
	LD A,[_rnew]
	LD [proxy.A.],A
	CALL proxy
	CALL asm_ld
	LD A,[_rold]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL asm_comma_a_eol
emitpokeb.B.
	LD A,0x00
	LD [_rproxy],A
	LD A,FALSE
	LD [_fused],A
	RET
emitpokelong
	LD A,[_rold2]
	SUB _RFAST
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitpokelong.A.
	CALL asm_ldmhl_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_inchl_eol
	CALL asm_ldmhl_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_inchl_eol
	CALL asm_ldmhl_comma
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_inchl_eol
	CALL asm_ldmhl_comma
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	JP emitpokelong.B.
emitpokelong.A.
	CALL unproxy
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rold2]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL asm_comma_a_eol
	CALL asm_inc
	LD A,[_rold2]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_ld
	LD A,[_rold2]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL asm_comma_a_eol
	CALL asm_inc
	LD A,[_rold2]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	CALL asm_ld
	LD A,[_rold2]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL asm_comma_a_eol
	CALL asm_inc
	LD A,[_rold2]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL endasm
	CALL asm_ld
	LD A,[_rold2]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL asm_comma_a_eol
emitpokelong.B.
	LD A,FALSE
	LD [_fused],A
	RET
emitpeekrg
	CALL unproxy
	LD A,[_rnew]
	SUB _RFAST
	JP NZ,emitpeekrg.A.
	CALL asm_lda_comma
	CALL asm_mhl
	CALL endasm
	CALL asm_inchl_eol
	CALL asm_ld
	LD A,'H'
	LD [asmc.A.],A
	CALL asmc
	CALL asm_comma_mhl_eol
	CALL asm_ld
	LD A,'L'
	LD [asmc.A.],A
	CALL asmc
	CALL asm_comma_a_eol
	JP emitpeekrg.B.
emitpeekrg.A.
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL endasm
	CALL asm_inc
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	CALL asm_exa_eol
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL endasm
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
	CALL asm_exa_eol
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
emitpeekrg.B.
	RET
emitpeekb
	CALL unproxy
	LD A,[_rnew]
	LD [_rproxy],A
	CALL asm_lda_comma
	LD A,[_rnew]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL endasm
	RET
emitpeeklong
	CALL unproxy
	LD A,[_rold]
	SUB _RFAST
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_rnew]
	SUB _RFAST4
	LD E,0
	JR Z,$+3
	DEC E
	LD A,L
	AND E
	JP Z,emitpeeklong.A.
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_mhl_eol
	CALL asm_inchl_eol
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_mhl_eol
	CALL asm_inchl_eol
	CALL asm_lda_comma
	CALL asm_mhl
	CALL endasm
	CALL asm_inchl_eol
	CALL asm_ld
	LD A,'H'
	LD [asmc.A.],A
	CALL asmc
	CALL asm_comma_mhl_eol
	CALL asm_ld
	LD A,'L'
	LD [asmc.A.],A
	CALL asmc
	CALL asm_comma_a_eol
	JP emitpeeklong.B.
emitpeeklong.A.
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL endasm
	CALL asm_inc
	LD A,[_rold]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL endasm
	CALL asm_inc
	LD A,[_rold]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL endasm
	CALL asm_inc
	LD A,[_rold]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	CALL asm_exa_eol
	CALL asm_lda_comma
	LD A,[_rold]
	LD [asm_mrgname.A.],A
	CALL asm_mrgname
	CALL endasm
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma_a_eol
	CALL asm_exa_eol
	CALL asm_ld
	LD A,[_rold]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma_a_eol
emitpeeklong.B.
	RET
emitztob
	LD A,[_exprlvl]
	SUB 0x01
	JP Z,emitztob.A.
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma
	LD A,'0'
	LD [asmc.A.],A
	CALL asmc
	CALL endasm
	LD A,[_rnew]
	SUB _RFAST4
	JP Z,emitztob.C.
	LD HL,emitztob.E.
	LD [asmstr.A.],HL
	CALL asmstr
	JP emitztob.D.
emitztob.C.
	LD HL,emitztob.F.
	LD [asmstr.A.],HL
	CALL asmstr
emitztob.D.
	CALL endasm
	CALL asm_dec
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	LD A,FALSE
	LD [_fused],A
	JP emitztob.B.
emitztob.A.
	LD A,0x02
	LD [_jpflag],A
emitztob.B.
	RET
emitinvztob
	LD A,[_exprlvl]
	SUB 0x01
	JP Z,emitinvztob.A.
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL asm_comma
	LD A,'0'
	LD [asmc.A.],A
	CALL asmc
	CALL endasm
	LD A,[_rnew]
	SUB _RFAST4
	JP Z,emitinvztob.C.
	LD HL,emitinvztob.E.
	LD [asmstr.A.],HL
	CALL asmstr
	JP emitinvztob.D.
emitinvztob.C.
	LD HL,emitinvztob.F.
	LD [asmstr.A.],HL
	CALL asmstr
emitinvztob.D.
	CALL endasm
	CALL asm_dec
	LD A,[_rnew]
	LD [asm_rlow.A.],A
	CALL asm_rlow
	CALL endasm
	LD A,FALSE
	LD [_fused],A
	JP emitinvztob.B.
emitinvztob.A.
	LD A,0x01
	LD [_jpflag],A
emitinvztob.B.
	RET
emitcytob
	LD A,[_exprlvl]
	SUB 0x01
	JP Z,emitcytob.A.
	CALL unproxy
	CALL asm_sbc
	CALL asm_a
	CALL asm_comma_a_eol
	LD A,[_rnew]
	LD [_rproxy],A
	JP emitcytob.B.
emitcytob.A.
	LD A,0x03
	LD [_jpflag],A
emitcytob.B.
	RET
emitinvcytob
	LD A,[_exprlvl]
	SUB 0x01
	JP Z,emitinvcytob.A.
	CALL asm_ccf_eol
	CALL unproxy
	CALL asm_sbc
	CALL asm_a
	CALL asm_comma_a_eol
	LD A,[_rnew]
	LD [_rproxy],A
	JP emitinvcytob.B.
emitinvcytob.A.
	LD A,0x04
	LD [_jpflag],A
emitinvcytob.B.
	RET
emitrgtob
	RET
emitbtorg
	CALL unproxy
	CALL asm_ld
	LD A,[_rnew]
	LD [asm_rhigh.A.],A
	CALL asm_rhigh
	CALL asm_comma
	LD A,'0'
	LD [asmc.A.],A
	CALL asmc
	CALL endasm
	RET
emitincrg
	CALL asm_inc
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	LD A,FALSE
	LD [_fused],A
	RET
emitincb_bypoi
	CALL asm_inc
	CALL asm_open
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL asm_close
	CALL endasm
	LD A,FALSE
	LD [_fused],A
	RET
emitdecrg
	CALL asm_dec
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL endasm
	LD A,FALSE
	LD [_fused],A
	RET
emitdecb_bypoi
	CALL asm_dec
	CALL asm_open
	LD A,[_rnew]
	LD [asm_rname.A.],A
	CALL asm_rname
	CALL asm_close
	CALL endasm
	LD A,FALSE
	LD [_fused],A
	RET
initcode
	LD HL,_RNAME
	LD A,_RFAST
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.A.
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_RNAME
	LD A,_RFAST2
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.B.
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_RNAME
	LD A,_RFAST3
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.C.
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_RNAME
	LD A,_RFAST4
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.D.
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_RHIGH
	LD A,_RFAST
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.E.
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_RHIGH
	LD A,_RFAST2
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.F.
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_RHIGH
	LD A,_RFAST3
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.G.
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_RHIGH
	LD A,_RFAST4
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.H.
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_RLOW
	LD A,_RFAST
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.I.
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_RLOW
	LD A,_RFAST2
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.J.
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_RLOW
	LD A,_RFAST3
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.K.
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_RLOW
	LD A,_RFAST4
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,initcode.L.
	LD [HL],E
	INC HL
	LD [HL],D
	LD A,0x00
	LD [_jpflag],A
	RET
initrgs
	CALL rgs_initrgs
	LD A,FALSE
	LD [_fused],A
	LD A,0x00
	LD [_rproxy],A
	RET
