errtype
	LD HL,errtype.C.
	LD [errstr.A.],HL
	CALL errstr
	LD HL,[errtype.msg]
	LD [errstr.A.],HL
	CALL errstr
	LD HL,errtype.D.
	LD [errstr.A.],HL
	CALL errstr
	LD A,[errtype.t]
	LD L,A
	LD H,0
	LD [erruint.A.],HL
	CALL erruint
	CALL enderr
	RET
strpush
	LD HL,[_lenstrstk]
	LD DE,[strpush.len]
	ADD HL,DE
	LD DE,2
	ADD HL,DE
	LD DE,_STRSTKMAX
	LD A,E
	SUB L
	LD A,D
	SBC A,H
	JP NC,strpush.C.
	LD HL,strpush.E.
	LD [errstr.A.],HL
	CALL errstr
	CALL enderr
	JP strpush.D.
strpush.C.
	LD HL,[strpush.s]
	LD [strcopy.A.],HL
	LD HL,[strpush.len]
	LD [strcopy.B.],HL
	LD HL,_strstk
	LD DE,[_lenstrstk]
	ADD HL,DE
	LD [strcopy.C.],HL
	CALL strcopy
	LD HL,[_lenstrstk]
	LD DE,[strpush.len]
	ADD HL,DE
	LD DE,1
	ADD HL,DE
	LD [_lenstrstk],HL
	LD HL,_strstk
	LD DE,[_lenstrstk]
	ADD HL,DE
	LD DE,[strpush.len]
	LD [HL],E
	LD HL,[_lenstrstk]
	INC HL
	LD [_lenstrstk],HL
strpush.D.
	RET
strpop
	LD HL,[_lenstrstk]
	DEC HL
	LD [_lenstrstk],HL
	LD HL,_strstk
	LD DE,[_lenstrstk]
	ADD HL,DE
	LD A,[HL]
	LD L,A
	LD H,0
	LD [strpop.len],HL
	LD HL,[_lenstrstk]
	LD DE,[strpop.len]
	OR A
	SBC HL,DE
	LD DE,1
	OR A
	SBC HL,DE
	LD [_lenstrstk],HL
	LD HL,_strstk
	LD DE,[_lenstrstk]
	ADD HL,DE
	LD [strcopy.A.],HL
	LD HL,[strpop.len]
	LD [strcopy.B.],HL
	LD HL,[strpop.s]
	LD [strcopy.C.],HL
	CALL strcopy
	LD HL,[strpop.len]
	RET
initlblbuf
	LD A,0x00
	LD [_lblhash],A
initlblbuf.A.
	LD HL,_lblshift
	LD A,[_lblhash]
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,_LBLBUFEOF
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_lblhash
	INC [HL]
	LD A,[_lblhash]
	SUB 0x00
	JP NZ,initlblbuf.A.
initlblbuf.B.
	LD HL,0
	LD [_lblbuffreestart],HL
	RET
lbltype
	LD A,_T_UNKNOWN
	LD [lbltype.t],A
	LD HL,[_name]
	LD [hash.A.],HL
	CALL hash
	LD A,L
	LD [_lblhash],A
	LD HL,_lblshift
	LD A,[_lblhash]
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD A,[HL]
	INC HL
	LD H,[HL]
	LD L,A
	LD [lbltype.plbl_idx],HL
lbltype.A.
	LD HL,[lbltype.plbl_idx]
	LD DE,_LBLBUFEOF
	OR A
	SBC HL,DE
	JP Z,lbltype.B.
	LD HL,_lbls
	LD DE,[lbltype.plbl_idx]
	ADD HL,DE
	LD [lbltype.plbl],HL
	LD HL,[lbltype.plbl]
	LD A,[HL]
	INC HL
	LD H,[HL]
	LD L,A
	LD [lbltype.plbl_idx],HL
	LD HL,[lbltype.plbl]
	LD DE,_SIZEOF_UINT
	ADD HL,DE
	LD [lbltype.plbl],HL
	LD HL,[_name]
	LD [strcp.A.],HL
	LD HL,[lbltype.plbl]
	LD [strcp.B.],HL
	CALL strcp
	OR A
	JP Z,lbltype.C.
	LD HL,[lbltype.plbl]
	LD DE,[_lenname]
	LD BC,1
	EX DE,HL
	ADD HL,BC
	EX DE,HL
	ADD HL,DE
	LD [lbltype.plbl],HL
	LD HL,[lbltype.plbl]
	LD A,[HL]
	LD [lbltype.t],A
	LD HL,[lbltype.plbl]
	INC HL
	LD [lbltype.plbl],HL
	LD HL,[lbltype.plbl]
	LD A,[HL]
	LD [_islocal],A
	JP lbltype.B.
lbltype.C.
	JP lbltype.A.
lbltype.B.
	LD A,[lbltype.t]
	RET
addvar
	CALL lbltype
	LD [addvar.oldt],A
	LD A,[addvar.oldt]
	SUB _T_UNKNOWN
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[addvar.islocal]
	LD E,A
	LD A,[_islocal]
	CPL
	AND E
	OR L
	JP Z,addvar.C.
	LD HL,[_lblbuffreestart]
	LD [addvar.freestart_idx],HL
	LD HL,[addvar.freestart_idx]
	LD DE,_LBLBUFMAXSHIFT
	LD A,L
	SUB E
	LD A,H
	SBC A,D
	JP NC,addvar.E.
	LD HL,[addvar.freestart_idx]
	LD [addvar.plbl_idx],HL
	LD HL,_lbls
	LD DE,[addvar.plbl_idx]
	ADD HL,DE
	LD [addvar.plbl],HL
	LD HL,[addvar.plbl]
	LD DE,_lblshift
	LD A,[_lblhash]
	LD C,A
	LD B,0
	EX DE,HL
	ADD HL,BC
	EX DE,HL
	EX DE,HL
	ADD HL,BC
	EX DE,HL
	LD A,[DE]
	INC DE
	EX AF,AF'
	LD A,[DE]
	LD D,A
	EX AF,AF'
	LD E,A
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,[addvar.plbl]
	LD DE,_SIZEOF_UINT
	ADD HL,DE
	LD [addvar.plbl],HL
	LD HL,[_name]
	LD [strcopy.A.],HL
	LD HL,[_lenname]
	LD [strcopy.B.],HL
	LD HL,[addvar.plbl]
	LD [strcopy.C.],HL
	CALL strcopy
	LD HL,[addvar.plbl]
	LD DE,[_lenname]
	LD BC,1
	EX DE,HL
	ADD HL,BC
	EX DE,HL
	ADD HL,DE
	LD [addvar.plbl],HL
	LD HL,[addvar.plbl]
	LD A,[addvar.t]
	LD [HL],A
	LD HL,[addvar.plbl]
	INC HL
	LD [addvar.plbl],HL
	LD HL,[addvar.plbl]
	LD A,[addvar.islocal]
	LD [HL],A
	LD HL,[addvar.plbl]
	INC HL
	LD [addvar.plbl],HL
	LD HL,[addvar.plbl]
	LD DE,_lbls
	OR A
	SBC HL,DE
	LD DE,_SIZEOF_UINT
	ADD HL,DE
	LD [addvar.plbl_idx],HL
	LD HL,_lblshift
	LD A,[_lblhash]
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,[addvar.freestart_idx]
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,[addvar.plbl_idx]
	LD [_lblbuffreestart],HL
	JP addvar.F.
addvar.E.
	LD HL,addvar.G.
	LD [errstr.A.],HL
	CALL errstr
	CALL enderr
addvar.F.
	JP addvar.D.
addvar.C.
	LD A,[addvar.oldt]
	LD L,A
	LD A,[addvar.t]
	SUB L
	JP Z,addvar.H.
	LD HL,addvar.J.
	LD [errstr.A.],HL
	CALL errstr
	CALL enderr
addvar.H.
addvar.D.
	RET
memorizevars
	LD HL,_lblshift
	LD [memcopy.A.],HL
	LD HL,_SIZEOF_UINT
	LD DE,0x100
	CALL _MUL.
	LD [memcopy.B.],HL
	LD HL,_oldlblshift
	LD [memcopy.C.],HL
	CALL memcopy
	LD HL,[_lblbuffreestart]
	LD [_oldlblbuffreestart],HL
	RET
restorevars
	LD HL,_oldlblshift
	LD [memcopy.A.],HL
	LD HL,_SIZEOF_UINT
	LD DE,0x100
	CALL _MUL.
	LD [memcopy.B.],HL
	LD HL,_lblshift
	LD [memcopy.C.],HL
	CALL memcopy
	LD HL,[_oldlblbuffreestart]
	LD [_lblbuffreestart],HL
	RET
pushconst
	LD HL,_typesz
	LD A,[_wast]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,pushconst.A.
	CALL getrfree
	CALL emitloadb
	JP pushconst.B.
pushconst.A.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,pushconst.C.
	CALL getrfree
	LD A,FALSE
	LD [emitloadrg.A.],A
	CALL emitloadrg
	JP pushconst.D.
pushconst.C.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,pushconst.E.
	CALL getrfree
	LD A,TRUE
	LD [emitloadrg.A.],A
	CALL emitloadrg
	CALL getrfree
	LD A,FALSE
	LD [emitloadrg.A.],A
	CALL emitloadrg
	JP pushconst.F.
pushconst.E.
	LD HL,pushconst.G.
	LD [errtype.A.],HL
	LD A,[_wast]
	LD [errtype.B.],A
	CALL errtype
pushconst.F.
pushconst.D.
pushconst.B.
	LD A,FALSE
	LD [_wasconst],A
	RET
cmdpushnum
	LD A,[_wasconst]
	OR A
	JP Z,cmdpushnum.A.
	CALL pushconst
cmdpushnum.A.
	LD HL,[_joined]
	LD [strcopy.A.],HL
	LD HL,[_lenjoined]
	LD [strcopy.B.],HL
	LD HL,[_const]
	LD [strcopy.C.],HL
	CALL strcopy
	LD [_lenconst],HL
	LD A,[_t]
	LD [_wast],A
	LD A,TRUE
	LD [_wasconst],A
	RET
cmdpushvar
	LD A,[_wasconst]
	OR A
	JP Z,cmdpushvar.A.
	CALL pushconst
cmdpushvar.A.
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,cmdpushvar.C.
	CALL getrfree
	CALL emitgetb
	JP cmdpushvar.D.
cmdpushvar.C.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,cmdpushvar.E.
	CALL getrfree
	LD A,FALSE
	LD [emitgetrg.A.],A
	CALL emitgetrg
	JP cmdpushvar.F.
cmdpushvar.E.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,cmdpushvar.G.
	CALL getrfree
	LD A,TRUE
	LD [emitgetrg.A.],A
	CALL emitgetrg
	CALL getrfree
	LD A,FALSE
	LD [emitgetrg.A.],A
	CALL emitgetrg
	JP cmdpushvar.H.
cmdpushvar.G.
	LD HL,cmdpushvar.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdpushvar.H.
cmdpushvar.F.
cmdpushvar.D.
	RET
cmdpopvar
	LD A,[_wasconst]
	OR A
	JP Z,cmdpopvar.A.
	CALL pushconst
cmdpopvar.A.
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,cmdpopvar.C.
	CALL getrnew
	CALL emitputb
	CALL freernew
	JP cmdpopvar.D.
cmdpopvar.C.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,cmdpopvar.E.
	CALL getrnew
	LD A,FALSE
	LD [emitputrg.A.],A
	CALL emitputrg
	CALL freernew
	JP cmdpopvar.F.
cmdpopvar.E.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,cmdpopvar.G.
	CALL getrnew
	LD A,FALSE
	LD [emitputrg.A.],A
	CALL emitputrg
	CALL freernew
	CALL getrnew
	LD A,TRUE
	LD [emitputrg.A.],A
	CALL emitputrg
	CALL freernew
	JP cmdpopvar.H.
cmdpopvar.G.
	LD HL,cmdpopvar.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdpopvar.H.
cmdpopvar.F.
cmdpopvar.D.
	RET
cmdcastto
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [cmdcastto.tsz],A
	LD HL,_typesz
	LD A,[cmdcastto.t2]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [cmdcastto.t2sz],A
	LD A,[cmdcastto.tsz]
	LD L,A
	LD A,[cmdcastto.t2sz]
	SUB L
	JP NZ,cmdcastto.B.
	JP cmdcastto.C.
cmdcastto.B.
	LD A,[_wasconst]
	OR A
	JP Z,cmdcastto.D.
	CALL pushconst
cmdcastto.D.
	LD A,[cmdcastto.tsz]
	SUB _SZ_BYTE
	JP NZ,cmdcastto.F.
	LD A,[cmdcastto.t2sz]
	SUB _SZ_REG
	JP NZ,cmdcastto.H.
	CALL getrnew
	CALL emitbtorg
	JP cmdcastto.I.
cmdcastto.H.
	LD A,[cmdcastto.t2sz]
	SUB _SZ_LONG
	JP NZ,cmdcastto.J.
	CALL getrnew
	CALL emitbtorg
	CALL getrfree
	CALL emitloadrg0
	CALL swaptop
	JP cmdcastto.K.
cmdcastto.J.
	JP cmdcastto.bad
cmdcastto.K.
cmdcastto.I.
	JP cmdcastto.G.
cmdcastto.F.
	LD A,[cmdcastto.tsz]
	SUB _SZ_REG
	JP NZ,cmdcastto.L.
	LD A,[cmdcastto.t2sz]
	SUB _SZ_BYTE
	JP NZ,cmdcastto.N.
	CALL getrnew
	CALL emitrgtob
	JP cmdcastto.O.
cmdcastto.N.
	LD A,[cmdcastto.t2sz]
	SUB _SZ_LONG
	JP NZ,cmdcastto.P.
	CALL getrfree
	CALL emitloadrg0
	CALL swaptop
	JP cmdcastto.Q.
cmdcastto.P.
	JP cmdcastto.bad
cmdcastto.Q.
cmdcastto.O.
	JP cmdcastto.M.
cmdcastto.L.
	LD A,[cmdcastto.tsz]
	SUB _SZ_LONG
	JP NZ,cmdcastto.R.
	LD A,[cmdcastto.t2sz]
	SUB _SZ_REG
	JP NZ,cmdcastto.T.
	CALL swaptop
	CALL freernew
	JP cmdcastto.U.
cmdcastto.T.
	LD A,[cmdcastto.t2sz]
	SUB _SZ_BYTE
	JP NZ,cmdcastto.V.
	CALL swaptop
	CALL freernew
	CALL getrnew
	CALL emitrgtob
	JP cmdcastto.W.
cmdcastto.V.
	JP cmdcastto.bad
cmdcastto.W.
cmdcastto.U.
	JP cmdcastto.S.
cmdcastto.R.
cmdcastto.bad
	LD HL,cmdcastto.X.
	LD [errstr.A.],HL
	CALL errstr
	LD A,[_t]
	LD L,A
	LD H,0
	LD [erruint.A.],HL
	CALL erruint
	LD A,'>'
	LD [err.A.],A
	CALL err
	LD A,[cmdcastto.t2]
	LD L,A
	LD H,0
	LD [erruint.A.],HL
	CALL erruint
	CALL enderr
cmdcastto.S.
cmdcastto.M.
cmdcastto.G.
cmdcastto.C.
	LD A,[cmdcastto.t2]
	LD [_t],A
	RET
cmdadd
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdadd.A.
	LD A,[_wasconst]
	OR A
	JP Z,cmdadd.C.
	CALL getrnew
	CALL emitaddbconst
	LD A,FALSE
	LD [_wasconst],A
	JP cmdadd.D.
cmdadd.C.
	CALL getrnew
	CALL getrold
	CALL emitaddb
	CALL freernew
cmdadd.D.
	JP cmdadd.B.
cmdadd.A.
	LD A,[_wasconst]
	OR A
	JP Z,cmdadd.E.
	CALL pushconst
cmdadd.E.
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	SUB _SZ_REG
	JP NZ,cmdadd.G.
	CALL getrold
	CALL getrnew
	CALL emitaddrg
	CALL freernew
	JP cmdadd.H.
cmdadd.G.
	LD A,[_t]
	SUB _T_LONG
	JP NZ,cmdadd.I.
	CALL getrold2
	CALL getrnew
	CALL emitaddrg
	CALL freernew
	CALL getrold2
	CALL getrnew
	CALL emitadcrg
	CALL freernew
	JP cmdadd.J.
cmdadd.I.
	LD HL,cmdadd.K.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdadd.J.
cmdadd.H.
cmdadd.B.
	RET
cmdsub
	LD A,[_wasconst]
	OR A
	JP Z,cmdsub.A.
	CALL pushconst
cmdsub.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdsub.C.
	CALL getrnew
	CALL getrold
	CALL emitsubb
	CALL freernew
	JP cmdsub.D.
cmdsub.C.
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	SUB _SZ_REG
	JP NZ,cmdsub.E.
	CALL getrold
	CALL getrnew
	CALL emitsubrg
	CALL freernew
	JP cmdsub.F.
cmdsub.E.
	LD A,[_t]
	SUB _T_LONG
	JP NZ,cmdsub.G.
	CALL getrold2
	CALL getrnew
	CALL emitsubrg
	CALL freernew
	CALL getrold2
	CALL getrnew
	CALL emitsbcrg
	CALL freernew
	JP cmdsub.H.
cmdsub.G.
	LD HL,cmdsub.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdsub.H.
cmdsub.F.
cmdsub.D.
	RET
cmdaddpoi
	LD A,[_wasconst]
	OR A
	JP Z,cmdaddpoi.A.
	CALL pushconst
cmdaddpoi.A.
	CALL getrold
	CALL getrnew
	LD HL,_typesz
	LD A,[_t]
	LD C,_TYPEMASK
	AND C
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [cmdaddpoi.i],A
cmdaddpoi.C.
	LD A,[cmdaddpoi.i]
	SUB 0x00
	JP Z,cmdaddpoi.D.
	CALL emitaddrg
	LD HL,cmdaddpoi.i
	DEC [HL]
	JP cmdaddpoi.C.
cmdaddpoi.D.
	CALL freernew
	RET
cmdmul
	LD A,[_wasconst]
	OR A
	JP Z,cmdmul.A.
	CALL pushconst
cmdmul.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdmul.C.
	LD HL,cmdmul.E.
	LD [emitcall2rgs.A.],HL
	CALL emitcall2rgs
	JP cmdmul.D.
cmdmul.C.
	LD A,[_t]
	SUB _T_UINT
	JP NZ,cmdmul.F.
	LD HL,cmdmul.H.
	LD [emitcall2rgs.A.],HL
	CALL emitcall2rgs
	JP cmdmul.G.
cmdmul.F.
	LD A,[_t]
	SUB _T_INT
	JP NZ,cmdmul.I.
	LD HL,cmdmul.K.
	LD [emitcall2rgs.A.],HL
	CALL emitcall2rgs
	JP cmdmul.J.
cmdmul.I.
	LD A,[_t]
	SUB _T_LONG
	JP NZ,cmdmul.L.
	LD HL,cmdmul.N.
	LD [emitcall4rgs.A.],HL
	CALL emitcall4rgs
	JP cmdmul.M.
cmdmul.L.
	LD HL,cmdmul.O.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdmul.M.
cmdmul.J.
cmdmul.G.
cmdmul.D.
	RET
cmddiv
	LD A,[_wasconst]
	OR A
	JP Z,cmddiv.A.
	CALL pushconst
cmddiv.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmddiv.C.
	LD HL,cmddiv.E.
	LD [emitcall2rgs.A.],HL
	CALL emitcall2rgs
	JP cmddiv.D.
cmddiv.C.
	LD A,[_t]
	SUB _T_UINT
	JP NZ,cmddiv.F.
	LD HL,cmddiv.H.
	LD [emitcall2rgs.A.],HL
	CALL emitcall2rgs
	JP cmddiv.G.
cmddiv.F.
	LD A,[_t]
	SUB _T_INT
	JP NZ,cmddiv.I.
	LD HL,cmddiv.K.
	LD [emitcall2rgs.A.],HL
	CALL emitcall2rgs
	JP cmddiv.J.
cmddiv.I.
	LD A,[_t]
	SUB _T_LONG
	JP NZ,cmddiv.L.
	LD HL,cmddiv.N.
	LD [emitcall4rgs.A.],HL
	CALL emitcall4rgs
	JP cmddiv.M.
cmddiv.L.
	LD HL,cmddiv.O.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmddiv.M.
cmddiv.J.
cmddiv.G.
cmddiv.D.
	RET
cmdshl
	LD A,[_wasconst]
	OR A
	JP Z,cmdshl.A.
	CALL pushconst
cmdshl.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdshl.C.
	LD HL,cmdshl.E.
	LD [emitcall2rgs.A.],HL
	CALL emitcall2rgs
	JP cmdshl.D.
cmdshl.C.
	LD A,[_t]
	SUB _T_INT
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_t]
	SUB _T_UINT
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	JP Z,cmdshl.F.
	LD HL,cmdshl.H.
	LD [emitcall2rgs.A.],HL
	CALL emitcall2rgs
	JP cmdshl.G.
cmdshl.F.
	LD A,[_t]
	SUB _T_LONG
	JP NZ,cmdshl.I.
	LD HL,cmdshl.K.
	LD [emitcall4rgs.A.],HL
	CALL emitcall4rgs
	JP cmdshl.J.
cmdshl.I.
	LD HL,cmdshl.L.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdshl.J.
cmdshl.G.
cmdshl.D.
	RET
cmdshr
	LD A,[_wasconst]
	OR A
	JP Z,cmdshr.A.
	CALL pushconst
cmdshr.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdshr.C.
	LD HL,cmdshr.E.
	LD [emitcall2rgs.A.],HL
	CALL emitcall2rgs
	JP cmdshr.D.
cmdshr.C.
	LD A,[_t]
	SUB _T_UINT
	JP NZ,cmdshr.F.
	LD HL,cmdshr.H.
	LD [emitcall2rgs.A.],HL
	CALL emitcall2rgs
	JP cmdshr.G.
cmdshr.F.
	LD A,[_t]
	SUB _T_INT
	JP NZ,cmdshr.I.
	LD HL,cmdshr.K.
	LD [emitcall2rgs.A.],HL
	CALL emitcall2rgs
	JP cmdshr.J.
cmdshr.I.
	LD A,[_t]
	SUB _T_LONG
	JP NZ,cmdshr.L.
	LD HL,cmdshr.N.
	LD [emitcall4rgs.A.],HL
	CALL emitcall4rgs
	JP cmdshr.M.
cmdshr.L.
	LD HL,cmdshr.O.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdshr.M.
cmdshr.J.
cmdshr.G.
cmdshr.D.
	RET
cmdshl1
	LD A,[_wasconst]
	OR A
	JP Z,cmdshl1.A.
	CALL pushconst
cmdshl1.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdshl1.C.
	CALL getrnew
	CALL emitshl1b
	JP cmdshl1.D.
cmdshl1.C.
	LD A,[_t]
	SUB _T_INT
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_t]
	SUB _T_UINT
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	JP Z,cmdshl1.E.
	CALL getrnew
	CALL emitshl1rg
	JP cmdshl1.F.
cmdshl1.E.
	LD HL,cmdshl1.G.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdshl1.F.
cmdshl1.D.
	RET
cmdand
	LD A,[_wasconst]
	OR A
	JP Z,cmdand.A.
	CALL pushconst
cmdand.A.
	LD A,[_t]
	SUB _T_BYTE
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_t]
	SUB _T_BOOL
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	JP Z,cmdand.C.
	CALL getrnew
	CALL getrold
	CALL getandb
	CALL freernew
	JP cmdand.D.
cmdand.C.
	LD A,[_t]
	SUB _T_UINT
	JP NZ,cmdand.E.
	CALL getrnew
	CALL getrold
	CALL emitandrg
	CALL freernew
	JP cmdand.F.
cmdand.E.
	LD A,[_t]
	SUB _T_LONG
	JP NZ,cmdand.G.
	CALL getrnew
	CALL getrold2
	CALL emitandrg
	CALL freernew
	CALL getrnew
	CALL getrold2
	CALL emitandrg
	CALL freernew
	JP cmdand.H.
cmdand.G.
	LD HL,cmdand.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdand.H.
cmdand.F.
cmdand.D.
	RET
cmdor
	LD A,[_wasconst]
	OR A
	JP Z,cmdor.A.
	CALL pushconst
cmdor.A.
	LD A,[_t]
	SUB _T_BYTE
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_t]
	SUB _T_BOOL
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	JP Z,cmdor.C.
	CALL getrnew
	CALL getrold
	CALL getorb
	CALL freernew
	JP cmdor.D.
cmdor.C.
	LD A,[_t]
	SUB _T_UINT
	JP NZ,cmdor.E.
	CALL getrnew
	CALL getrold
	CALL emitorrg
	CALL freernew
	JP cmdor.F.
cmdor.E.
	LD A,[_t]
	SUB _T_LONG
	JP NZ,cmdor.G.
	CALL getrnew
	CALL getrold2
	CALL emitorrg
	CALL freernew
	CALL getrnew
	CALL getrold2
	CALL emitorrg
	CALL freernew
	JP cmdor.H.
cmdor.G.
	LD HL,cmdor.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdor.H.
cmdor.F.
cmdor.D.
	RET
cmdxor
	LD A,[_wasconst]
	OR A
	JP Z,cmdxor.A.
	CALL pushconst
cmdxor.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdxor.C.
	CALL getrnew
	CALL getrold
	CALL getxorb
	CALL freernew
	JP cmdxor.D.
cmdxor.C.
	LD A,[_t]
	SUB _T_UINT
	JP NZ,cmdxor.E.
	CALL getrnew
	CALL getrold
	CALL emitxorrg
	CALL freernew
	JP cmdxor.F.
cmdxor.E.
	LD A,[_t]
	SUB _T_LONG
	JP NZ,cmdxor.G.
	CALL getrnew
	CALL getrold2
	CALL emitxorrg
	CALL freernew
	CALL getrnew
	CALL getrold2
	CALL emitxorrg
	CALL freernew
	JP cmdxor.H.
cmdxor.G.
	LD HL,cmdxor.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdxor.H.
cmdxor.F.
cmdxor.D.
	RET
cmdpoke
	LD A,[_wasconst]
	OR A
	JP Z,cmdpoke.A.
	CALL pushconst
cmdpoke.A.
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,cmdpoke.C.
	CALL getrnew
	CALL getrold
	CALL emitpokeb
	CALL freernew
	CALL freernew
	JP cmdpoke.D.
cmdpoke.C.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,cmdpoke.E.
	CALL getrnew
	CALL getrold
	CALL emitpokerg
	CALL freernew
	CALL freernew
	JP cmdpoke.F.
cmdpoke.E.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,cmdpoke.G.
	CALL getrnew
	CALL getrold2
	LD A,[_rold]
	LD [_rold2],A
	CALL getrold
	CALL emitpokelong
	CALL freernew
	CALL freernew
	CALL freernew
	JP cmdpoke.H.
cmdpoke.G.
	LD HL,cmdpoke.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdpoke.H.
cmdpoke.F.
cmdpoke.D.
	RET
cmdpeek
	LD A,[_wasconst]
	OR A
	JP Z,cmdpeek.A.
	CALL pushconst
cmdpeek.A.
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,cmdpeek.C.
	CALL getrnew
	CALL emitpeekb
	JP cmdpeek.D.
cmdpeek.C.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,cmdpeek.E.
	CALL getrnew
	CALL emitpeekrg
	JP cmdpeek.F.
cmdpeek.E.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,cmdpeek.G.
	CALL getrfree
	CALL getrnew
	CALL getrold
	CALL emitpeeklong
	JP cmdpeek.H.
cmdpeek.G.
	LD HL,cmdpeek.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdpeek.H.
cmdpeek.F.
cmdpeek.D.
	RET
cmdneg
	LD A,[_wasconst]
	OR A
	JP Z,cmdneg.A.
	CALL pushconst
cmdneg.A.
	LD A,[_t]
	SUB _T_INT
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_t]
	SUB _T_UINT
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	JP Z,cmdneg.C.
	CALL getrnew
	CALL emitnegrg
	JP cmdneg.D.
cmdneg.C.
	LD HL,cmdneg.E.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdneg.D.
	RET
cmdinv
	LD A,[_wasconst]
	OR A
	JP Z,cmdinv.A.
	CALL pushconst
cmdinv.A.
	LD A,[_t]
	SUB _T_BYTE
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_t]
	SUB _T_BOOL
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	JP Z,cmdinv.C.
	CALL getrnew
	CALL emitinvb
	JP cmdinv.D.
cmdinv.C.
	LD A,[_t]
	SUB _T_INT
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_t]
	SUB _T_UINT
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	JP Z,cmdinv.E.
	CALL getrnew
	CALL emitinvrg
	JP cmdinv.F.
cmdinv.E.
	LD A,[_t]
	SUB _T_LONG
	JP NZ,cmdinv.G.
	CALL getrnew
	CALL emitinvrg
	CALL getrold
	LD A,[_rold]
	LD [_rnew],A
	CALL emitinvrg
	JP cmdinv.H.
cmdinv.G.
	LD HL,cmdinv.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdinv.H.
cmdinv.F.
cmdinv.D.
	RET
cmdinc
	LD A,[_wasconst]
	OR A
	JP Z,cmdinc.A.
	CALL pushconst
cmdinc.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdinc.C.
	CALL getnothing
	LD A,_T_POI
	LD E,_T_BYTE
	OR E
	LD [_t],A
	CALL cmdpushnum
	LD A,[_wasconst]
	OR A
	JP Z,cmdinc.E.
	CALL pushconst
cmdinc.E.
	CALL getrnew
	CALL emitincb_bypoi
	CALL freernew
	JP cmdinc.D.
cmdinc.C.
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	SUB _SZ_REG
	JP NZ,cmdinc.G.
	CALL getrfree
	LD A,FALSE
	LD [emitgetrg.A.],A
	CALL emitgetrg
	CALL emitincrg
	LD A,FALSE
	LD [emitputrg.A.],A
	CALL emitputrg
	CALL freernew
	JP cmdinc.H.
cmdinc.G.
	LD HL,cmdinc.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdinc.H.
cmdinc.D.
	RET
cmddec
	LD A,[_wasconst]
	OR A
	JP Z,cmddec.A.
	CALL pushconst
cmddec.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmddec.C.
	CALL getnothing
	LD A,_T_POI
	LD E,_T_BYTE
	OR E
	LD [_t],A
	CALL cmdpushnum
	LD A,[_wasconst]
	OR A
	JP Z,cmddec.E.
	CALL pushconst
cmddec.E.
	CALL getrnew
	CALL emitdecb_bypoi
	CALL freernew
	JP cmddec.D.
cmddec.C.
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	SUB _SZ_REG
	JP NZ,cmddec.G.
	CALL getrfree
	LD A,FALSE
	LD [emitgetrg.A.],A
	CALL emitgetrg
	CALL emitdecrg
	LD A,FALSE
	LD [emitputrg.A.],A
	CALL emitputrg
	CALL freernew
	JP cmddec.H.
cmddec.G.
	LD HL,cmddec.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmddec.H.
cmddec.D.
	RET
cmdless
	LD A,[_wasconst]
	OR A
	JP Z,cmdless.A.
	CALL pushconst
cmdless.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdless.C.
	CALL getrnew
	CALL getrold
	LD A,[_rnew]
	LD [emitsubbflags.A.],A
	LD A,[_rold]
	LD [emitsubbflags.B.],A
	CALL emitsubbflags
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitcytob
	JP cmdless.D.
cmdless.C.
	LD A,[_t]
	SUB _T_UINT
	JP NZ,cmdless.E.
	CALL getrnew
	CALL getrold
	LD A,[_rnew]
	LD [emitsubflags.A.],A
	LD A,[_rold]
	LD [emitsubflags.B.],A
	CALL emitsubflags
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitcytob
	JP cmdless.F.
cmdless.E.
	LD A,[_t]
	SUB _T_INT
	JP NZ,cmdless.G.
	CALL getrnew
	CALL getrold
	LD A,[_rnew]
	LD [emitsubflags.A.],A
	LD A,[_rold]
	LD [emitsubflags.B.],A
	CALL emitsubflags
	CALL freernew
	CALL freernew
	CALL emitSxorVtocy
	CALL getrfree
	CALL emitcytob
	JP cmdless.H.
cmdless.G.
	LD HL,cmdless.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdless.H.
cmdless.F.
cmdless.D.
	LD A,_T_BOOL
	LD [_t],A
	RET
cmdmore
	LD A,[_wasconst]
	OR A
	JP Z,cmdmore.A.
	CALL pushconst
cmdmore.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdmore.C.
	CALL getrold
	CALL getrnew
	LD A,[_rold]
	LD [emitsubbflags.A.],A
	LD A,[_rnew]
	LD [emitsubbflags.B.],A
	CALL emitsubbflags
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitcytob
	JP cmdmore.D.
cmdmore.C.
	LD A,[_t]
	SUB _T_UINT
	JP NZ,cmdmore.E.
	CALL getrold
	CALL getrnew
	LD A,[_rold]
	LD [emitsubflags.A.],A
	LD A,[_rnew]
	LD [emitsubflags.B.],A
	CALL emitsubflags
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitcytob
	JP cmdmore.F.
cmdmore.E.
	LD A,[_t]
	SUB _T_INT
	JP NZ,cmdmore.G.
	CALL getrold
	CALL getrnew
	LD A,[_rold]
	LD [emitsubflags.A.],A
	LD A,[_rnew]
	LD [emitsubflags.B.],A
	CALL emitsubflags
	CALL freernew
	CALL freernew
	CALL emitSxorVtocy
	CALL getrfree
	CALL emitcytob
	JP cmdmore.H.
cmdmore.G.
	LD HL,cmdmore.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdmore.H.
cmdmore.F.
cmdmore.D.
	LD A,_T_BOOL
	LD [_t],A
	RET
cmdlesseq
	LD A,[_wasconst]
	OR A
	JP Z,cmdlesseq.A.
	CALL pushconst
cmdlesseq.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdlesseq.C.
	CALL getrold
	CALL getrnew
	LD A,[_rold]
	LD [emitsubbflags.A.],A
	LD A,[_rnew]
	LD [emitsubbflags.B.],A
	CALL emitsubbflags
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitinvcytob
	JP cmdlesseq.D.
cmdlesseq.C.
	LD A,[_t]
	SUB _T_UINT
	JP NZ,cmdlesseq.E.
	CALL getrold
	CALL getrnew
	LD A,[_rold]
	LD [emitsubflags.A.],A
	LD A,[_rnew]
	LD [emitsubflags.B.],A
	CALL emitsubflags
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitinvcytob
	JP cmdlesseq.F.
cmdlesseq.E.
	LD A,[_t]
	SUB _T_INT
	JP NZ,cmdlesseq.G.
	CALL getrold
	CALL getrnew
	LD A,[_rold]
	LD [emitsubflags.A.],A
	LD A,[_rnew]
	LD [emitsubflags.B.],A
	CALL emitsubflags
	CALL freernew
	CALL freernew
	CALL emitinvSxorVtocy
	CALL getrfree
	CALL emitcytob
	JP cmdlesseq.H.
cmdlesseq.G.
	LD HL,cmdlesseq.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdlesseq.H.
cmdlesseq.F.
cmdlesseq.D.
	LD A,_T_BOOL
	LD [_t],A
	RET
cmdmoreeq
	LD A,[_wasconst]
	OR A
	JP Z,cmdmoreeq.A.
	CALL pushconst
cmdmoreeq.A.
	LD A,[_t]
	SUB _T_BYTE
	JP NZ,cmdmoreeq.C.
	CALL getrnew
	CALL getrold
	LD A,[_rnew]
	LD [emitsubbflags.A.],A
	LD A,[_rold]
	LD [emitsubbflags.B.],A
	CALL emitsubbflags
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitinvcytob
	JP cmdmoreeq.D.
cmdmoreeq.C.
	LD A,[_t]
	SUB _T_UINT
	JP NZ,cmdmoreeq.E.
	CALL getrnew
	CALL getrold
	LD A,[_rnew]
	LD [emitsubflags.A.],A
	LD A,[_rold]
	LD [emitsubflags.B.],A
	CALL emitsubflags
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitinvcytob
	JP cmdmoreeq.F.
cmdmoreeq.E.
	LD A,[_t]
	SUB _T_INT
	JP NZ,cmdmoreeq.G.
	CALL getrnew
	CALL getrold
	LD A,[_rnew]
	LD [emitsubflags.A.],A
	LD A,[_rold]
	LD [emitsubflags.B.],A
	CALL emitsubflags
	CALL freernew
	CALL freernew
	CALL emitinvSxorVtocy
	CALL getrfree
	CALL emitcytob
	JP cmdmoreeq.H.
cmdmoreeq.G.
	LD HL,cmdmoreeq.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdmoreeq.H.
cmdmoreeq.F.
cmdmoreeq.D.
	LD A,_T_BOOL
	LD [_t],A
	RET
cmdeq
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,cmdeq.A.
	LD A,[_wasconst]
	OR A
	JP Z,cmdeq.C.
	CALL getrnew
	CALL emitsubbzconst
	LD A,FALSE
	LD [_wasconst],A
	CALL freernew
	JP cmdeq.D.
cmdeq.C.
	CALL getrnew
	CALL getrold
	CALL emitsubbz
	CALL freernew
	CALL freernew
cmdeq.D.
	CALL getrfree
	CALL emitztob
	JP cmdeq.B.
cmdeq.A.
	LD A,[_wasconst]
	OR A
	JP Z,cmdeq.E.
	CALL pushconst
cmdeq.E.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,cmdeq.G.
	CALL getrnew
	CALL getrold
	CALL emitsubz
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitztob
	JP cmdeq.H.
cmdeq.G.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,cmdeq.I.
	CALL getrold2
	LD A,[_rold]
	LD [_rold2],A
	CALL getrold3
	LD A,[_rold]
	LD [_rold3],A
	CALL getrnew
	CALL getrold
	CALL emitsublongz
	CALL freernew
	CALL freernew
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitztob
	JP cmdeq.J.
cmdeq.I.
	LD HL,cmdeq.K.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdeq.J.
cmdeq.H.
cmdeq.B.
	LD A,_T_BOOL
	LD [_t],A
	RET
cmdnoteq
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,cmdnoteq.A.
	LD A,[_wasconst]
	OR A
	JP Z,cmdnoteq.C.
	CALL getrnew
	CALL emitsubbzconst
	LD A,FALSE
	LD [_wasconst],A
	CALL freernew
	JP cmdnoteq.D.
cmdnoteq.C.
	CALL getrnew
	CALL getrold
	CALL emitsubbz
	CALL freernew
	CALL freernew
cmdnoteq.D.
	CALL getrfree
	CALL emitinvztob
	JP cmdnoteq.B.
cmdnoteq.A.
	LD A,[_wasconst]
	OR A
	JP Z,cmdnoteq.E.
	CALL pushconst
cmdnoteq.E.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,cmdnoteq.G.
	CALL getrnew
	CALL getrold
	CALL emitsubz
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitinvztob
	JP cmdnoteq.H.
cmdnoteq.G.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,cmdnoteq.I.
	CALL getrold2
	LD A,[_rold]
	LD [_rold2],A
	CALL getrold3
	LD A,[_rold]
	LD [_rold3],A
	CALL getrnew
	CALL getrold
	CALL emitsublongz
	CALL freernew
	CALL freernew
	CALL freernew
	CALL freernew
	CALL getrfree
	CALL emitinvztob
	JP cmdnoteq.J.
cmdnoteq.I.
	LD HL,cmdnoteq.K.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdnoteq.J.
cmdnoteq.H.
cmdnoteq.B.
	LD A,_T_BOOL
	LD [_t],A
	RET
cmdlabel
	CALL getnothing
	LD HL,[_joined]
	LD [asmstr.A.],HL
	CALL asmstr
	CALL endasm
	RET
cmdjpval
	CALL getmainrg
	CALL freernew
	CALL emitjpmainrg
	RET
cmdcallval
	LD A,[_wasconst]
	OR A
	JP Z,cmdcallval.A.
	CALL pushconst
cmdcallval.A.
	CALL getmainrg
	CALL freernew
	CALL emitcallmainrg
	RET
cmdjp
	CALL emitjp
	RET
cmdjpiffalse
	LD A,[_wasconst]
	OR A
	JP Z,cmdjpiffalse.A.
	CALL pushconst
cmdjpiffalse.A.
	CALL getrnew
	CALL emitbtoz
	CALL freernew
	CALL emitjpiffalse
	RET
cmdcall
	CALL unproxy
	CALL getnothing
	CALL emitcallproc
	LD A,[_t]
	SUB _T_PROC
	JP Z,cmdcall.A.
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,cmdcall.C.
	CALL setmainrg
	LD A,_RMAIN
	LD [_rproxy],A
	JP cmdcall.D.
cmdcall.C.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,cmdcall.E.
	CALL setmainrg
	JP cmdcall.F.
cmdcall.E.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,cmdcall.G.
	CALL setmain2rgs
	JP cmdcall.H.
cmdcall.G.
	LD HL,cmdcall.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdcall.H.
cmdcall.F.
cmdcall.D.
cmdcall.A.
	RET
cmdfunc
	LD HL,0
	LD [_funcstkdepth],HL
	CALL initrgs
	RET
cmdstorergs
	CALL getnothing
	RET
cmdpushpar
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,cmdpushpar.A.
	CALL getnothing
	CALL getrfree
	CALL emitgetb
	JP cmdpushpar.B.
cmdpushpar.A.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,cmdpushpar.C.
	CALL getnothing
	CALL getrfree
	LD A,FALSE
	LD [emitgetrg.A.],A
	CALL emitgetrg
	JP cmdpushpar.D.
cmdpushpar.C.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,cmdpushpar.E.
	CALL getnothing
	CALL getrfree
	LD A,TRUE
	LD [emitgetrg.A.],A
	CALL emitgetrg
	CALL getnothing
	CALL getrfree
	LD A,FALSE
	LD [emitgetrg.A.],A
	CALL emitgetrg
	JP cmdpushpar.F.
cmdpushpar.E.
	LD HL,cmdpushpar.G.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdpushpar.F.
cmdpushpar.D.
cmdpushpar.B.
	RET
cmdpoppar
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,cmdpoppar.A.
	CALL getrfree
	LD A,[_rnew]
	LD [emitpoprg.A.],A
	CALL emitpoprg
	CALL emitputb
	CALL freernew
	JP cmdpoppar.B.
cmdpoppar.A.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,cmdpoppar.C.
	CALL getrfree
	LD A,[_rnew]
	LD [emitpoprg.A.],A
	CALL emitpoprg
	LD A,FALSE
	LD [emitputrg.A.],A
	CALL emitputrg
	CALL freernew
	JP cmdpoppar.D.
cmdpoppar.C.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,cmdpoppar.E.
	CALL getrfree
	LD A,[_rnew]
	LD [emitpoprg.A.],A
	CALL emitpoprg
	LD A,FALSE
	LD [emitputrg.A.],A
	CALL emitputrg
	CALL freernew
	CALL getrfree
	LD A,[_rnew]
	LD [emitpoprg.A.],A
	CALL emitpoprg
	LD A,TRUE
	LD [emitputrg.A.],A
	CALL emitputrg
	CALL freernew
	JP cmdpoppar.F.
cmdpoppar.E.
	LD HL,cmdpoppar.G.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdpoppar.F.
cmdpoppar.D.
cmdpoppar.B.
	RET
cmdresult
	LD A,[_wasconst]
	OR A
	JP Z,cmdresult.A.
	CALL pushconst
cmdresult.A.
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,cmdresult.C.
	JP cmdresult.D.
cmdresult.C.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,cmdresult.E.
	CALL getmainrg
	JP cmdresult.F.
cmdresult.E.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,cmdresult.G.
	CALL getmain2rgs
	JP cmdresult.H.
cmdresult.G.
	LD HL,cmdresult.I.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdresult.H.
cmdresult.F.
cmdresult.D.
	RET
cmdendfunc
	LD A,[cmdendfunc.isfunc]
	OR A
	JP Z,cmdendfunc.B.
	LD HL,_typesz
	LD A,[_t]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD [_sz],A
	LD A,[_sz]
	SUB _SZ_BYTE
	JP NZ,cmdendfunc.D.
	CALL getrnew
	LD A,[_rnew]
	LD [proxy.A.],A
	CALL proxy
	JP cmdendfunc.E.
cmdendfunc.D.
	LD A,[_sz]
	SUB _SZ_REG
	JP NZ,cmdendfunc.F.
	CALL getmainrg
	JP cmdendfunc.G.
cmdendfunc.F.
	LD A,[_sz]
	SUB _SZ_LONG
	JP NZ,cmdendfunc.H.
	CALL getmain2rgs
	JP cmdendfunc.I.
cmdendfunc.H.
	LD HL,cmdendfunc.J.
	LD [errtype.A.],HL
	LD A,[_t]
	LD [errtype.B.],A
	CALL errtype
cmdendfunc.I.
cmdendfunc.G.
cmdendfunc.E.
cmdendfunc.B.
	CALL emitret
	LD HL,[_funcstkdepth]
	LD DE,0
	OR A
	SBC HL,DE
	JP Z,cmdendfunc.K.
	LD HL,cmdendfunc.M.
	LD [errstr.A.],HL
	CALL errstr
	LD HL,[_funcstkdepth]
	LD [erruint.A.],HL
	CALL erruint
	CALL enderr
cmdendfunc.K.
	CALL initrgs
	RET
initcmd
	LD HL,_sc
	LD [_const],HL
	LD HL,_sw
	LD [_wastword],HL
	LD A,FALSE
	LD [_wasconst],A
	RET
