rdaddwordall
	LD HL,0
	LD [_spcsize],HL
	LD HL,0
	LD [_waseols],HL
	LD HL,[_curline]
	LD [_curlnbeg],HL
	LD HL,_isalphanum
	LD A,[_cnext]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	OR A
	JP Z,rdaddwordall.A.
rdaddwordall.C.
	LD HL,[_lentword]
	LD DE,_STRMAX
	LD A,L
	SUB E
	LD A,H
	SBC A,D
	JP NC,rdaddwordall.E.
	LD HL,[_tword]
	LD DE,[_lentword]
	ADD HL,DE
	LD A,[_cnext]
	LD [HL],A
	LD HL,[_lentword]
	INC HL
	LD [_lentword],HL
rdaddwordall.E.
	CALL readfin
	LD [_cnext],A
	LD HL,_isalphanum
	LD A,[_cnext]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	CPL
	OR A
	JP Z,rdaddwordall.C.
rdaddwordall.D.
	JP rdaddwordall.B.
rdaddwordall.A.
	LD HL,[_lentword]
	LD DE,_STRMAX
	LD A,L
	SUB E
	LD A,H
	SBC A,D
	JP NC,rdaddwordall.G.
	LD HL,[_tword]
	LD DE,[_lentword]
	ADD HL,DE
	LD A,[_cnext]
	LD [HL],A
	LD HL,[_lentword]
	INC HL
	LD [_lentword],HL
rdaddwordall.G.
	CALL readfin
	LD [_cnext],A
rdaddwordall.B.
	JP rdaddwordall.loopgo
rdaddwordall.loop
	CALL readfin
	LD [_cnext],A
rdaddwordall.loopgo
	LD A,[_cnext]
	LD E,'!'
	SUB E
	JP NC,rdaddwordall.I.
	LD HL,[_spcsize]
	INC HL
	LD [_spcsize],HL
	LD A,[_cnext]
	SUB 0x0a
	JP NZ,rdaddwordall.K.
	LD HL,[_curline]
	INC HL
	LD [_curline],HL
	LD HL,0
	LD [_spcsize],HL
	LD HL,[_waseols]
	INC HL
	LD [_waseols],HL
	JP rdaddwordall.L.
rdaddwordall.K.
	LD A,[_cnext]
	SUB 0x09
	JP NZ,rdaddwordall.M.
	LD HL,[_spcsize]
	LD DE,7
	ADD HL,DE
	LD [_spcsize],HL
rdaddwordall.M.
rdaddwordall.L.
	LD A,[_waseof]
	CPL
	OR A
	JP Z,rdaddwordall.O.
	JP rdaddwordall.loop
rdaddwordall.O.
rdaddwordall.I.
	LD HL,[_tword]
	LD DE,[_lentword]
	ADD HL,DE
	LD A,'\0'
	LD [HL],A
	RET
asmtoken
	LD HL,[_fout]
	LD [writebyte.A.],HL
	LD A,[asmtoken.token]
	LD [writebyte.B.],A
	CALL writebyte
	RET
tok_spc
tok_spc.A.
	LD HL,[_asmspcsize]
	LD A,_ASMMAXSPC
	LD E,A
	LD D,0
	LD A,E
	SUB L
	LD A,D
	SBC A,H
	JP NC,tok_spc.B.
	LD A,_TOKSPC0
	ADD A,_ASMMAXSPC
	LD [asmtoken.A.],A
	CALL asmtoken
	LD HL,[_asmspcsize]
	LD A,_ASMMAXSPC
	LD E,A
	LD D,0
	OR A
	SBC HL,DE
	LD [_asmspcsize],HL
	JP tok_spc.A.
tok_spc.B.
	LD HL,[_asmspcsize]
	LD DE,0
	OR A
	SBC HL,DE
	JP Z,tok_spc.C.
	LD A,_TOKSPC0
	LD DE,[_asmspcsize]
	ADD A,E
	LD [asmtoken.A.],A
	CALL asmtoken
tok_spc.C.
	RET
asmrdword_tok_spc
	LD A,[_waseof]
	LD [_asmwaseof],A
	LD HL,[_waseols]
	LD [_asmwaseols],HL
	LD HL,[_spcsize]
	LD [_asmspcsize],HL
	LD HL,[_waseols]
	LD DE,0
	OR A
	SBC HL,DE
	JP NZ,asmrdword_tok_spc.A.
	CALL tok_spc
asmrdword_tok_spc.A.
	LD HL,0
	LD [_lentword],HL
	CALL rdaddwordall
	LD HL,[_tword]
	LD A,[HL]
	LD E,0x20
	OR E
	LD [_c1small],A
	LD HL,[_tword]
	LD DE,1
	ADD HL,DE
	LD A,[HL]
	LD E,0x20
	OR E
	LD [_c2small],A
	RET
tok_text
	LD A,_TOKTEXT
	LD [asmtoken.A.],A
	CALL asmtoken
	LD HL,[_tword]
	LD [fputs.A.],HL
	LD HL,[_fout]
	LD [fputs.B.],HL
	CALL fputs
	LD A,_TOKENDTEXT
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tok_err
	LD A,_ERR
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,[tok_err.token]
	LD [asmtoken.A.],A
	CALL asmtoken
tok_err.B.
	LD A,TRUE
	OR A
	JP Z,tok_err.C.
	CALL tok_text
	LD HL,[_waseols]
	LD DE,0
	OR A
	SBC HL,DE
	LD L,0
	JR Z,$+3
	DEC L
	LD A,[_waseof]
	OR L
	LD DE,[_tword]
	LD L,A
	LD A,[DE]
	SUB ':'
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	JP Z,tok_err.D.
	JP tok_err.C.
tok_err.D.
	CALL asmrdword_tok_spc
	JP tok_err.B.
tok_err.C.
	LD A,_TOKENDERR
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	RET
tok_errcmd
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tokinitlblbuf
	LD A,0x00
	LD [_toklblhash],A
tokinitlblbuf.A.
	LD HL,_toklblshift
	LD A,[_toklblhash]
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,_TOKLBLBUFEOF
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_toklblhash
	INC [HL]
	LD A,[_toklblhash]
	SUB 0x00
	JP NZ,tokinitlblbuf.A.
tokinitlblbuf.B.
	LD HL,0
	LD [_toklblbuffreestart],HL
	RET
tokcalllbl
	LD HL,[_tword]
	LD [hash.A.],HL
	CALL hash
	LD A,L
	LD [_toklblhash],A
	LD HL,_toklblshift
	LD A,[_toklblhash]
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD A,[HL]
	INC HL
	LD H,[HL]
	LD L,A
	LD [tokcalllbl.plbl_idx],HL
tokcalllbl.A.
	LD HL,[tokcalllbl.plbl_idx]
	LD DE,_TOKLBLBUFEOF
	OR A
	SBC HL,DE
	JP Z,tokcalllbl.B.
	LD HL,_toklbls
	LD DE,[tokcalllbl.plbl_idx]
	ADD HL,DE
	LD [tokcalllbl.plbl],HL
	LD HL,[tokcalllbl.plbl]
	LD A,[HL]
	INC HL
	LD H,[HL]
	LD L,A
	LD [tokcalllbl.plbl_idx],HL
	LD HL,[tokcalllbl.plbl]
	LD DE,2
	ADD HL,DE
	LD [tokcalllbl.plbl],HL
	LD HL,[_tword]
	LD [strcp.A.],HL
	LD HL,[tokcalllbl.plbl]
	LD [strcp.B.],HL
	CALL strcp
	OR A
	JP Z,tokcalllbl.C.
	LD HL,[tokcalllbl.plbl]
	LD DE,11
	ADD HL,DE
	LD [tokcalllbl.plbl],HL
	LD HL,[tokcalllbl.plbl]
	LD E,[HL]
	INC HL
	LD D,[HL]
	INC HL
	LD A,[HL]
	INC HL
	LD H,[HL]
	LD L,A
	LD [tokcalllbl.calladdr],DE
	LD HL,[tokcalllbl.plbl]
	LD DE,4
	ADD HL,DE
	LD [tokcalllbl.plbl],HL
	LD HL,[tokcalllbl.plbl]
	LD A,[HL]
	LD [_temppar],A
	LD HL,[tokcalllbl.calladdr]
	CALL _JPHL.
	JP tokcalllbl.e
tokcalllbl.C.
	JP tokcalllbl.A.
tokcalllbl.B.
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
tokcalllbl.e
	RET
tokaddlbl1
	LD HL,[tokaddlbl1.txt]
	LD [hash.A.],HL
	CALL hash
	LD A,L
	LD [_toklblhash],A
	LD HL,_toklbls
	LD DE,[_toklblbuffreestart]
	ADD HL,DE
	LD [tokaddlbl1.plbl],HL
	LD HL,[tokaddlbl1.plbl]
	LD DE,_toklblshift
	LD A,[_toklblhash]
	LD C,A
	LD B,0
	EX DE,HL
	ADD HL,BC
	EX DE,HL
	EX DE,HL
	ADD HL,BC
	EX DE,HL
	LD A,[DE]
	INC DE
	EX AF,AF'
	LD A,[DE]
	LD D,A
	EX AF,AF'
	LD E,A
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,_toklblshift
	LD A,[_toklblhash]
	LD E,A
	LD D,0
	ADD HL,DE
	ADD HL,DE
	LD DE,[_toklblbuffreestart]
	LD [HL],E
	INC HL
	LD [HL],D
	LD HL,[tokaddlbl1.plbl]
	LD DE,2
	ADD HL,DE
	LD [tokaddlbl1.plbl],HL
	LD HL,[tokaddlbl1.txt]
	LD [strcopy.A.],HL
	LD HL,10
	LD [strcopy.B.],HL
	LD HL,[tokaddlbl1.plbl]
	LD [strcopy.C.],HL
	CALL strcopy
	LD HL,[tokaddlbl1.plbl]
	LD DE,11
	ADD HL,DE
	LD [tokaddlbl1.plbl],HL
	LD HL,[tokaddlbl1.plbl]
	LD DE,[tokaddlbl1.proc]
	LD BC,0
	LD [HL],E
	INC HL
	LD [HL],D
	INC HL
	LD [HL],C
	INC HL
	LD [HL],B
	LD HL,[tokaddlbl1.plbl]
	LD DE,4
	ADD HL,DE
	LD [tokaddlbl1.plbl],HL
	LD HL,[tokaddlbl1.plbl]
	LD A,[tokaddlbl1.data]
	LD [HL],A
	LD HL,[tokaddlbl1.plbl]
	LD DE,_toklbls
	OR A
	SBC HL,DE
	LD DE,1
	ADD HL,DE
	LD [_toklblbuffreestart],HL
	RET
tokaddlbl
	LD HL,[tokaddlbl.txt]
	LD [tokaddlbl1.A.],HL
	LD HL,[tokaddlbl.proc]
	LD [tokaddlbl1.B.],HL
	LD A,[tokaddlbl.data]
	LD [tokaddlbl1.C.],A
	CALL tokaddlbl1
	LD HL,[tokaddlbl.txt2]
	LD [tokaddlbl1.A.],HL
	LD HL,[tokaddlbl.proc]
	LD [tokaddlbl1.B.],HL
	LD A,[tokaddlbl.data]
	LD [tokaddlbl1.C.],A
	CALL tokaddlbl1
	RET
tokmatch_comma
	LD HL,[_tword]
	LD A,[HL]
	SUB ','
	JP NZ,tokmatch_comma.A.
	LD A,_TOKCOMMA
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	LD A,TRUE
	LD [tokmatch_comma.ok],A
	JP tokmatch_comma.B.
tokmatch_comma.A.
	LD A,FALSE
	LD [tokmatch_comma.ok],A
tokmatch_comma.B.
	LD A,[tokmatch_comma.ok]
	RET
tokmatch_prime
	LD HL,[_tword]
	LD A,[HL]
	SUB '\''
	JP NZ,tokmatch_prime.A.
	LD A,_TOKPRIMESYM
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	LD A,TRUE
	LD [tokmatch_prime.ok],A
	JP tokmatch_prime.B.
tokmatch_prime.A.
	LD A,FALSE
	LD [tokmatch_prime.ok],A
tokmatch_prime.B.
	LD A,[tokmatch_prime.ok]
	RET
tokmatch_quote
	LD HL,[_tword]
	LD A,[HL]
	SUB '\"'
	JP NZ,tokmatch_quote.A.
	LD A,_TOKDBLQUOTESYM
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,TRUE
	LD [tokmatch_quote.ok],A
	JP tokmatch_quote.B.
tokmatch_quote.A.
	LD A,FALSE
	LD [tokmatch_quote.ok],A
tokmatch_quote.B.
	LD A,[tokmatch_quote.ok]
	RET
tokmatch_reequ
	LD HL,[_tword]
	LD A,[HL]
	SUB '='
	JP NZ,tokmatch_reequ.A.
	LD A,_TOKEQUAL
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	LD A,TRUE
	LD [tokmatch_reequ.ok],A
	JP tokmatch_reequ.B.
tokmatch_reequ.A.
	LD A,FALSE
	LD [tokmatch_reequ.ok],A
tokmatch_reequ.B.
	LD A,[tokmatch_reequ.ok]
	RET
tokmatch_open
	LD HL,[_tword]
	LD A,[HL]
	SUB '('
	JP NZ,tokmatch_open.A.
	LD A,_TOKOPEN
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	LD A,TRUE
	LD [tokmatch_open.ok],A
	JP tokmatch_open.B.
tokmatch_open.A.
	LD HL,[_tword]
	LD A,[HL]
	SUB '['
	JP NZ,tokmatch_open.C.
	LD A,_TOKOPENSQ
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	LD A,TRUE
	LD [tokmatch_open.ok],A
	JP tokmatch_open.D.
tokmatch_open.C.
	LD A,FALSE
	LD [tokmatch_open.ok],A
tokmatch_open.D.
tokmatch_open.B.
	LD A,[tokmatch_open.ok]
	RET
tokmatch_close
	LD HL,[_tword]
	LD A,[HL]
	SUB ')'
	JP NZ,tokmatch_close.A.
	LD A,_TOKCLOSE
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	LD A,TRUE
	LD [tokmatch_close.ok],A
	JP tokmatch_close.B.
tokmatch_close.A.
	LD HL,[_tword]
	LD A,[HL]
	SUB ']'
	JP NZ,tokmatch_close.C.
	LD A,_TOKCLOSESQ
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	LD A,TRUE
	LD [tokmatch_close.ok],A
	JP tokmatch_close.D.
tokmatch_close.C.
	LD A,FALSE
	LD [tokmatch_close.ok],A
tokmatch_close.D.
tokmatch_close.B.
	LD A,[tokmatch_close.ok]
	RET
tokeat_label
tokeat_label.B.
	LD A,[_cnext]
	SUB '.'
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_cnext]
	SUB '#'
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	JP Z,tokeat_label.C.
	CALL rdaddwordall
	LD HL,[_spcsize]
	LD DE,0
	OR A
	SBC HL,DE
	JP NZ,tokeat_label.D.
	LD HL,_isalphanum
	LD A,[_cnext]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	OR A
	JP Z,tokeat_label.F.
	LD HL,[_waseols]
	LD DE,0
	OR A
	SBC HL,DE
	JP NZ,tokeat_label.H.
	CALL rdaddwordall
tokeat_label.H.
tokeat_label.F.
tokeat_label.D.
	JP tokeat_label.B.
tokeat_label.C.
	LD A,[tokeat_label.token]
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKTEXT
	LD [asmtoken.A.],A
	CALL asmtoken
	LD HL,[_tword]
	LD [fputs.A.],HL
	LD HL,[_fout]
	LD [fputs.B.],HL
	CALL fputs
	LD A,_TOKENDTEXT
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	RET
tokeat_val
	LD A,[tokeat_val.opsym]
	LD DE,[_tword]
	LD L,A
	LD A,[DE]
	LD [tokeat_val.opsym],A
	LD A,[_asmwaseof]
	CPL
	OR A
	PUSH HL
	JP Z,tokeat_val.A.
	LD A,[tokeat_val.opsym]
	LD E,'0'
	SUB E
	LD E,0x0a
	SUB E
	JP NC,tokeat_val.C.
	LD A,_TOKNUM
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKTEXT
	LD [asmtoken.A.],A
	CALL asmtoken
	LD HL,[_tword]
	LD [fputs.A.],HL
	LD HL,[_fout]
	LD [fputs.B.],HL
	CALL fputs
	LD A,_TOKENDTEXT
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	JP tokeat_val.D.
tokeat_val.C.
	LD HL,_isalphanum
	LD A,[tokeat_val.opsym]
	LD E,A
	LD D,0
	ADD HL,DE
	LD A,[HL]
	LD L,A
	LD A,[tokeat_val.opsym]
	SUB '.'
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	JP Z,tokeat_val.E.
	LD A,_TOKLABEL
	LD [tokeat_label.A.],A
	CALL tokeat_label
	JP tokeat_val.F.
tokeat_val.E.
	LD A,[tokeat_val.opsym]
	SUB '$'
	JP NZ,tokeat_val.G.
	LD A,_TOKDOLLAR
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	JP tokeat_val.H.
tokeat_val.G.
	LD A,[tokeat_val.opsym]
	SUB '('
	JP NZ,tokeat_val.I.
	LD A,_TOKOPEN
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokexpr
	LD A,_TOKCLOSE
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	JP tokeat_val.J.
tokeat_val.I.
	LD A,[tokeat_val.opsym]
	SUB '\''
	JP NZ,tokeat_val.K.
	LD A,_TOKPRIME
	LD [asmtoken.A.],A
	CALL asmtoken
	LD HL,0
	LD [_lentword],HL
	LD A,'\''
	LD [rdquotes.A.],A
	CALL rdquotes
	CALL tok_text
	CALL rdch
	LD A,_TOKPRIME
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	JP tokeat_val.L.
tokeat_val.K.
	LD A,[tokeat_val.opsym]
	SUB '-'
	JP NZ,tokeat_val.M.
	LD A,_OPPUSH0
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKMINUS
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_val
	LD A,_OPSUB
	LD [asmtoken.A.],A
	CALL asmtoken
	JP tokeat_val.N.
tokeat_val.M.
	LD A,[tokeat_val.opsym]
	SUB '+'
	JP NZ,tokeat_val.O.
	LD A,_OPPUSH0
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKPLUS
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_val
	LD A,_OPADD
	LD [asmtoken.A.],A
	CALL asmtoken
	JP tokeat_val.P.
tokeat_val.O.
	LD A,[tokeat_val.opsym]
	SUB '*'
	JP NZ,tokeat_val.Q.
	LD A,_OPPUSH0
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKSTAR
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_val
	LD A,_OPPEEK
	LD [asmtoken.A.],A
	CALL asmtoken
	JP tokeat_val.R.
tokeat_val.Q.
	LD A,[tokeat_val.opsym]
	SUB '~'
	JP NZ,tokeat_val.S.
	LD A,_OPPUSH0
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKTILDE
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_val
	LD A,_OPINV
	LD [asmtoken.A.],A
	CALL asmtoken
	JP tokeat_val.T.
tokeat_val.S.
	LD A,[tokeat_val.opsym]
	SUB '!'
	JP NZ,tokeat_val.U.
	LD A,_OPPUSH0
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKEXCL
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_val
	LD A,_OPINV
	LD [asmtoken.A.],A
	CALL asmtoken
	JP tokeat_val.V.
tokeat_val.U.
	LD A,_ERREXPR
	LD [tok_err.A.],A
	CALL tok_err
tokeat_val.V.
tokeat_val.T.
tokeat_val.R.
tokeat_val.P.
tokeat_val.N.
tokeat_val.L.
tokeat_val.J.
tokeat_val.H.
tokeat_val.F.
tokeat_val.D.
tokeat_val.A.
	POP HL
	LD A,L
	LD [tokeat_val.opsym],A
	RET
tokeat_mul
	LD A,_TOKSTAR
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_val
	LD A,_OPMUL
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_div
	LD A,_TOKSLASH
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_val
	LD A,_OPDIV
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_and
	LD A,_TOKAND
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_val
	LD A,_OPAND
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_andbool
	LD A,_TOKAND
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKAND
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_val
	LD A,_OPAND
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_mulval
	LD A,[tokeat_mulval.opsym]
	LD L,A
	PUSH HL
	LD A,[tokeat_mulval.dbl]
	LD L,A
	PUSH HL
	CALL tokeat_val
tokeat_mulval.A.
	LD A,[_asmwaseof]
	CPL
	LD DE,[_asmwaseols]
	LD BC,0
	LD L,A
	LD A,E
	SUB C
	JR NZ,$+4
	LD A,D
	SUB B
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	AND E
	JP Z,tokeat_mulval.B.
	LD HL,[_tword]
	LD A,[HL]
	LD [tokeat_mulval.opsym],A
	LD A,[tokeat_mulval.opsym]
	SUB '&'
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[_cnext]
	LD E,A
	LD A,[tokeat_mulval.opsym]
	SUB E
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	AND E
	LD [tokeat_mulval.dbl],A
	LD A,[tokeat_mulval.dbl]
	OR A
	JP Z,tokeat_mulval.C.
	CALL asmrdword_tok_spc
tokeat_mulval.C.
	LD A,[tokeat_mulval.opsym]
	SUB '*'
	JP NZ,tokeat_mulval.E.
	CALL tokeat_mul
	JP tokeat_mulval.F.
tokeat_mulval.E.
	LD A,[tokeat_mulval.opsym]
	SUB '/'
	JP NZ,tokeat_mulval.G.
	CALL tokeat_div
	JP tokeat_mulval.H.
tokeat_mulval.G.
	LD A,[tokeat_mulval.opsym]
	SUB '&'
	JP NZ,tokeat_mulval.I.
	LD A,[tokeat_mulval.dbl]
	OR A
	JP Z,tokeat_mulval.K.
	CALL tokeat_andbool
	JP tokeat_mulval.L.
tokeat_mulval.K.
	CALL tokeat_and
tokeat_mulval.L.
	JP tokeat_mulval.J.
tokeat_mulval.I.
	JP tokeat_mulval.B.
tokeat_mulval.J.
tokeat_mulval.H.
tokeat_mulval.F.
	JP tokeat_mulval.A.
tokeat_mulval.B.
	POP HL
	LD A,L
	LD [tokeat_mulval.dbl],A
	POP HL
	LD A,L
	LD [tokeat_mulval.opsym],A
	RET
tokeat_add
	LD A,_TOKPLUS
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_mulval
	LD A,_OPADD
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_sub
	LD A,_TOKMINUS
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_mulval
	LD A,_OPSUB
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_or
	LD A,_TOKPIPE
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_mulval
	LD A,_OPOR
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_orbool
	LD A,_TOKPIPE
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKPIPE
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_mulval
	LD A,_OPOR
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_xor
	LD A,_TOKCARON
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_mulval
	LD A,_OPXOR
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_xorbool
	LD A,_TOKCARON
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKCARON
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_mulval
	LD A,_OPXOR
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_sumval
	LD A,[tokeat_sumval.opsym]
	LD L,A
	PUSH HL
	LD A,[tokeat_sumval.dbl]
	LD L,A
	PUSH HL
	CALL tokeat_mulval
tokeat_sumval.A.
	LD A,[_asmwaseof]
	CPL
	LD DE,[_asmwaseols]
	LD BC,0
	LD L,A
	LD A,E
	SUB C
	JR NZ,$+4
	LD A,D
	SUB B
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	AND E
	JP Z,tokeat_sumval.B.
	LD HL,[_tword]
	LD A,[HL]
	LD [tokeat_sumval.opsym],A
	LD A,[tokeat_sumval.opsym]
	SUB '|'
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,[tokeat_sumval.opsym]
	SUB '^'
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	OR E
	LD L,A
	LD A,[_cnext]
	LD E,A
	LD A,[tokeat_sumval.opsym]
	SUB E
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	AND E
	LD [tokeat_sumval.dbl],A
	LD A,[tokeat_sumval.dbl]
	OR A
	JP Z,tokeat_sumval.C.
	CALL asmrdword_tok_spc
tokeat_sumval.C.
	LD A,[tokeat_sumval.opsym]
	SUB '+'
	JP NZ,tokeat_sumval.E.
	CALL tokeat_add
	JP tokeat_sumval.F.
tokeat_sumval.E.
	LD A,[tokeat_sumval.opsym]
	SUB '-'
	JP NZ,tokeat_sumval.G.
	CALL tokeat_sub
	JP tokeat_sumval.H.
tokeat_sumval.G.
	LD A,[tokeat_sumval.opsym]
	SUB '|'
	JP NZ,tokeat_sumval.I.
	LD A,[tokeat_sumval.dbl]
	OR A
	JP Z,tokeat_sumval.K.
	CALL tokeat_orbool
	JP tokeat_sumval.L.
tokeat_sumval.K.
	CALL tokeat_or
tokeat_sumval.L.
	JP tokeat_sumval.J.
tokeat_sumval.I.
	LD A,[tokeat_sumval.opsym]
	SUB '^'
	JP NZ,tokeat_sumval.M.
	LD A,[tokeat_sumval.dbl]
	OR A
	JP Z,tokeat_sumval.O.
	CALL tokeat_xorbool
	JP tokeat_sumval.P.
tokeat_sumval.O.
	CALL tokeat_xor
tokeat_sumval.P.
	JP tokeat_sumval.N.
tokeat_sumval.M.
	JP tokeat_sumval.B.
tokeat_sumval.N.
tokeat_sumval.J.
tokeat_sumval.H.
tokeat_sumval.F.
	JP tokeat_sumval.A.
tokeat_sumval.B.
	POP HL
	LD A,L
	LD [tokeat_sumval.dbl],A
	POP HL
	LD A,L
	LD [tokeat_sumval.opsym],A
	RET
tokeat_shl
	LD A,_TOKLESS
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKLESS
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_sumval
	LD A,_OPSHL
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_shr
	LD A,_TOKMORE
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKMORE
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_sumval
	LD A,_OPSHR
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_less
	LD A,_TOKLESS
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_sumval
	LD A,_OPLESS
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_lesseq
	LD A,_TOKLESS
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKEQUAL
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_sumval
	LD A,_OPLESSEQ
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_more
	LD A,_TOKMORE
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_sumval
	LD A,_OPMORE
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_moreeq
	LD A,_TOKMORE
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKEQUAL
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_sumval
	LD A,_OPMOREEQ
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_eq
	LD A,_TOKEQUAL
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKEQUAL
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_sumval
	LD A,_OPEQ
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokeat_noteq
	LD A,_TOKEXCL
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,_TOKEQUAL
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokeat_sumval
	LD A,_OPNOTEQ
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tokexpr
	LD A,[tokexpr.opsym]
	LD L,A
	PUSH HL
	LD A,[tokexpr.modified]
	LD L,A
	PUSH HL
	LD A,[tokexpr.dbl]
	LD L,A
	PUSH HL
	CALL tokeat_sumval
tokexpr.A.
	LD A,[_asmwaseof]
	CPL
	LD DE,[_asmwaseols]
	LD BC,0
	LD L,A
	LD A,E
	SUB C
	JR NZ,$+4
	LD A,D
	SUB B
	LD E,0
	JR NZ,$+3
	DEC E
	LD A,L
	AND E
	JP Z,tokexpr.B.
	LD HL,[_tword]
	LD A,[HL]
	LD [tokexpr.opsym],A
	LD A,[_cnext]
	SUB '='
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,L
	LD [tokexpr.modified],A
	LD A,[_cnext]
	LD L,A
	LD A,[tokexpr.opsym]
	SUB L
	LD L,0
	JR NZ,$+3
	DEC L
	LD A,L
	LD [tokexpr.dbl],A
	LD A,[tokexpr.modified]
	LD L,A
	LD A,[tokexpr.dbl]
	OR L
	JP Z,tokexpr.C.
	CALL asmrdword_tok_spc
tokexpr.C.
	LD A,[tokexpr.opsym]
	SUB '<'
	JP NZ,tokexpr.E.
	LD A,[tokexpr.dbl]
	OR A
	JP Z,tokexpr.G.
	CALL tokeat_shl
	JP tokexpr.H.
tokexpr.G.
	LD A,[tokexpr.modified]
	OR A
	JP Z,tokexpr.I.
	CALL tokeat_lesseq
	JP tokexpr.J.
tokexpr.I.
	CALL tokeat_less
tokexpr.J.
tokexpr.H.
	JP tokexpr.F.
tokexpr.E.
	LD A,[tokexpr.opsym]
	SUB '>'
	JP NZ,tokexpr.K.
	LD A,[tokexpr.dbl]
	OR A
	JP Z,tokexpr.M.
	CALL tokeat_shr
	JP tokexpr.N.
tokexpr.M.
	LD A,[tokexpr.modified]
	OR A
	JP Z,tokexpr.O.
	CALL tokeat_moreeq
	JP tokexpr.P.
tokexpr.O.
	CALL tokeat_more
tokexpr.P.
tokexpr.N.
	JP tokexpr.L.
tokexpr.K.
	LD A,[tokexpr.opsym]
	SUB '='
	JP NZ,tokexpr.Q.
	CALL tokeat_eq
	JP tokexpr.R.
tokexpr.Q.
	LD A,[tokexpr.opsym]
	SUB '!'
	JP NZ,tokexpr.S.
	CALL tokeat_noteq
	JP tokexpr.T.
tokexpr.S.
	JP tokexpr.B.
tokexpr.T.
tokexpr.R.
tokexpr.L.
tokexpr.F.
	JP tokexpr.A.
tokexpr.B.
	LD A,TRUE
	POP DE
	LD L,A
	LD A,E
	LD [tokexpr.dbl],A
	POP DE
	LD A,E
	LD [tokexpr.modified],A
	POP DE
	LD A,E
	LD [tokexpr.opsym],A
	LD A,L
	RET
tokexpr_close
	CALL tokexpr
	LD [tokexpr_close.ok],A
	LD A,[tokexpr_close.ok]
	OR A
	JP Z,tokexpr_close.A.
	CALL tokmatch_close
	LD [tokexpr_close.ok],A
tokexpr_close.A.
	LD A,[tokexpr_close.ok]
	RET
asm_direct_expr_close_token
	CALL tokexpr
	OR A
	JP Z,asm_direct_expr_close_token.B.
	CALL tokmatch_close
	OR A
	JP Z,asm_direct_expr_close_token.D.
	LD A,[asm_direct_expr_close_token.token]
	LD [asmtoken.A.],A
	CALL asmtoken
	JP asm_direct_expr_close_token.E.
asm_direct_expr_close_token.D.
	LD A,_ERRCLOSE
	LD [tok_err.A.],A
	CALL tok_err
asm_direct_expr_close_token.E.
	JP asm_direct_expr_close_token.C.
asm_direct_expr_close_token.B.
	LD A,_ERREXPR
	LD [tok_err.A.],A
	CALL tok_err
asm_direct_expr_close_token.C.
	RET
tok_comment
	LD A,_TOKCOMMENT
	LD [asmtoken.A.],A
	CALL asmtoken
	LD HL,0
	LD [_lentword],HL
	LD HL,[_waseols]
	LD DE,0
	OR A
	SBC HL,DE
	JP NZ,tok_comment.A.
tok_comment.C.
	LD HL,[_spcsize]
	LD DE,0
	OR A
	SBC HL,DE
	JP Z,tok_comment.D.
	LD HL,[_tword]
	LD [stradd.A.],HL
	LD HL,[_lentword]
	LD [stradd.B.],HL
	LD A,' '
	LD [stradd.C.],A
	CALL stradd
	LD [_lentword],HL
	LD HL,[_spcsize]
	DEC HL
	LD [_spcsize],HL
	JP tok_comment.C.
tok_comment.D.
tok_comment.E.
	LD HL,[_waseols]
	LD DE,0
	OR A
	SBC HL,DE
	JP NZ,tok_comment.F.
	CALL rdchcmt
	JP tok_comment.E.
tok_comment.F.
tok_comment.A.
	LD HL,[_tword]
	LD DE,[_lentword]
	ADD HL,DE
	LD A,'\0'
	LD [HL],A
	CALL tok_text
	LD A,_TOKENDCOMMENT
	LD [asmtoken.A.],A
	CALL asmtoken
	LD A,[_cnext]
	LD E,'!'
	SUB E
	JP NC,tok_comment.G.
	LD A,[_cnext]
	SUB '\t'
	JP NZ,tok_comment.I.
	LD HL,[_spcsize]
	LD DE,8
	ADD HL,DE
	LD [_spcsize],HL
	JP tok_comment.J.
tok_comment.I.
	LD HL,[_spcsize]
	INC HL
	LD [_spcsize],HL
tok_comment.J.
	CALL rdch
tok_comment.G.
	CALL asmrdword_tok_spc
	RET
tok_org
	LD A,_CMDORG
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokexpr
	OR A
	JP Z,tok_org.A.
	LD A,_FMTCMD
	LD [asmtoken.A.],A
	CALL asmtoken
	JP tok_org.B.
tok_org.A.
	LD A,_ERREXPR
	LD [tok_err.A.],A
	CALL tok_err
tok_org.B.
	RET
tok_align
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_page
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_if
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_else
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_endif
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_dup
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_edup
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_macro
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_endm
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_export
	LD A,_CMDEXPORT
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	LD A,_TOKLABEL
	LD [tokeat_label.A.],A
	CALL tokeat_label
	LD A,_FMTCMD
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tok_local
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_endl
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_disp
	LD A,_CMDDISP
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokexpr
	OR A
	JP Z,tok_disp.A.
	LD A,_FMTCMD
	LD [asmtoken.A.],A
	CALL asmtoken
	JP tok_disp.B.
tok_disp.A.
	LD A,_ERREXPR
	LD [tok_err.A.],A
	CALL tok_err
tok_disp.B.
	RET
tok_ent
	LD A,_CMDENT
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	LD A,_FMTCMD
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tok_include
	LD A,_CMDINCLUDE
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokmatch_quote
	OR A
	JP Z,tok_include.A.
	LD HL,0
	LD [_lentword],HL
	LD A,'\"'
	LD [rdquotes.A.],A
	CALL rdquotes
	CALL tok_text
	CALL rdch
	LD A,_TOKDBLQUOTESYM
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	JP tok_include.B.
tok_include.A.
	LD A,_ERREXPR
	LD [tok_err.A.],A
	CALL tok_err
tok_include.B.
	RET
tok_incbin
	LD A,_CMDINCBIN
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokmatch_quote
	OR A
	JP Z,tok_incbin.A.
	LD HL,0
	LD [_lentword],HL
	LD A,'\"'
	LD [rdquotes.A.],A
	CALL rdquotes
	CALL tok_text
	CALL rdch
	LD A,_TOKDBLQUOTESYM
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	JP tok_incbin.B.
tok_incbin.A.
	LD A,_ERREXPR
	LD [tok_err.A.],A
	CALL tok_err
tok_incbin.B.
	RET
tok_db
	LD A,_CMDDB
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
tok_db.A.
	CALL tokmatch_quote
	OR A
	JP Z,tok_db.C.
	LD A,_OPWRSTR
	LD [asmtoken.A.],A
	CALL asmtoken
	LD HL,0
	LD [_lentword],HL
	LD A,'\"'
	LD [rdquotes.A.],A
	CALL rdquotes
	CALL tok_text
	CALL rdch
	LD A,_TOKDBLQUOTESYM
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	JP tok_db.D.
tok_db.C.
	CALL tokexpr
	OR A
	JP Z,tok_db.E.
	LD A,_OPWRVAL
	LD [asmtoken.A.],A
	CALL asmtoken
	JP tok_db.F.
tok_db.E.
	LD A,_ERREXPR
	LD [tok_err.A.],A
	CALL tok_err
tok_db.F.
tok_db.D.
	CALL tokmatch_comma
	CPL
	OR A
	JP Z,tok_db.A.
tok_db.B.
	LD A,_FMTCMD
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tok_dw
	LD A,_CMDDW
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
tok_dw.A.
	CALL tokexpr
	LD A,_OPWRVAL
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL tokmatch_comma
	CPL
	OR A
	JP Z,tok_dw.A.
tok_dw.B.
	LD A,_FMTCMD
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tok_dl
	LD A,_CMDDL
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
tok_dl.A.
	CALL tokexpr
	LD A,_OPWRVAL
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL tokmatch_comma
	CPL
	OR A
	JP Z,tok_dl.A.
tok_dl.B.
	LD A,_FMTCMD
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tok_ds
	LD A,_CMDDS
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	CALL tokexpr
tok_ds.A.
	CALL tokmatch_comma
	OR A
	JP Z,tok_ds.B.
	CALL tokexpr
	JP tok_ds.A.
tok_ds.B.
	LD A,_FMTCMD
	LD [asmtoken.A.],A
	CALL asmtoken
	RET
tok_display
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_repeat
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_until
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_struct
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_endstruct
	LD A,_ERRCMD
	LD [tok_err.A.],A
	CALL tok_err
	RET
tok_colon
	LD A,_TOKCOLON
	LD [asmtoken.A.],A
	CALL asmtoken
	CALL asmrdword_tok_spc
	RET
tokcmd
	LD HL,[_tword]
	LD A,[HL]
	SUB ';'
	JP NZ,tokcmd.A.
	CALL tok_comment
	JP tokcmd.B.
tokcmd.A.
	LD HL,[_asmspcsize]
	LD DE,0
	OR A
	SBC HL,DE
	JP Z,tokcmd.C.
	CALL tokcalllbl
	JP tokcmd.D.
tokcmd.C.
	LD A,_CMDLABEL
	LD [tokeat_label.A.],A
	CALL tokeat_label
	CALL tokmatch_reequ
	OR A
	JP Z,tokcmd.E.
	CALL tokexpr
	OR A
	JP Z,tokcmd.G.
	LD A,_FMTREEQU
	LD [asmtoken.A.],A
	CALL asmtoken
	JP tokcmd.H.
tokcmd.G.
	LD A,_ERREXPR
	LD [tok_err.A.],A
	CALL tok_err
tokcmd.H.
	JP tokcmd.F.
tokcmd.E.
	LD A,_FMTCMD
	LD [asmtoken.A.],A
	CALL asmtoken
tokcmd.F.
tokcmd.D.
tokcmd.B.
	LD HL,[_asmwaseols]
	LD DE,0
	OR A
	SBC HL,DE
	JP Z,tokcmd.I.
tokcmd.K.
	LD HL,[_asmwaseols]
	LD DE,0
	OR A
	SBC HL,DE
	JP Z,tokcmd.L.
	LD A,_TOKEOL
	LD [asmtoken.A.],A
	CALL asmtoken
	LD HL,[_asmwaseols]
	DEC HL
	LD [_asmwaseols],HL
	JP tokcmd.K.
tokcmd.L.
	CALL tok_spc
tokcmd.I.
	RET
tokinit
	LD HL,_stokfn
	LD [_tokfn],HL
	CALL tokinitlblbuf
	CALL tokfilllblbuf
	RET
tokenize
	LD HL,1
	LD [_curline],HL
	LD HL,[tokenize.fn]
	LD [fopen.A.],HL
	LD HL,tokenize.B.
	LD [fopen.B.],HL
	CALL fopen
	LD [_fin],HL
	LD A,FALSE
	LD [_waseof],A
	CALL initrd
	LD HL,[_tokfn]
	LD [strjoineol.A.],HL
	LD HL,0
	LD [strjoineol.B.],HL
	LD HL,[tokenize.fn]
	LD [strjoineol.C.],HL
	LD A,'.'
	LD [strjoineol.D.],A
	CALL strjoineol
	LD [_lentokfn],HL
	LD HL,[_tokfn]
	LD [stradd.A.],HL
	LD HL,[_lentokfn]
	LD [stradd.B.],HL
	LD A,'.'
	LD [stradd.C.],A
	CALL stradd
	LD [_lentokfn],HL
	LD HL,[_tokfn]
	LD [stradd.A.],HL
	LD HL,[_lentokfn]
	LD [stradd.B.],HL
	LD HL,[tokenize.fn]
	LD DE,[_lentokfn]
	ADD HL,DE
	LD A,[HL]
	LD E,0xdf
	AND E
	LD [stradd.C.],A
	CALL stradd
	LD [_lentokfn],HL
	LD HL,[_tokfn]
	LD [stradd.A.],HL
	LD HL,[_lentokfn]
	LD [stradd.B.],HL
	LD A,'_'
	LD [stradd.C.],A
	CALL stradd
	LD [_lentokfn],HL
	LD HL,[_tokfn]
	LD DE,[_lentokfn]
	ADD HL,DE
	LD A,'\0'
	LD [HL],A
	LD HL,[_tokfn]
	LD [openwrite.A.],HL
	CALL openwrite
	LD [_fout],HL
	LD HL,0
	LD [_asmwaseols],HL
	LD A,FALSE
	LD [_asmwaseof],A
	CALL asmrdword_tok_spc
tokenize.C.
	LD A,[_asmwaseof]
	CPL
	OR A
	JP Z,tokenize.D.
	CALL tokcmd
	JP tokenize.C.
tokenize.D.
	LD A,_TOKEOF
	LD [asmtoken.A.],A
	CALL asmtoken
	LD HL,[_fout]
	LD [closewrite.A.],HL
	CALL closewrite
	LD HL,[_fin]
	LD [fclose.A.],HL
	CALL fclose
	RET
tokenize_end
	RET
