//    
//       
//_asmwaseol   asmrdword_tok_spc(),  eol   

//// imported
#include "str.h"
#include "io.h"

VAR UINT _curlnbeg; //      // read, emit
VAR BOOL _cmts; // read, emit

CONST BOOL _isalphanum[256];

EXTERN PCHAR _tword; // 
EXTERN UINT _lentword;
//EXTERN CHAR _s0[_STRLEN]; // 

EXTERN BOOL _waseof;
EXTERN PBYTE _fin;
EXTERN PBYTE _fout;
FUNC BYTE readfin FORWARD();

EXTERN UINT _curline; //  
EXTERN UINT _waseols; // EOL   
EXTERN UINT _spcsize; //    
EXTERN CHAR _cnext;

FUNC UINT stradd FORWARD(PCHAR s, UINT len, CHAR c);
FUNC BOOL strcplow FORWARD(PCHAR s1, PCHAR s2);

PROC rdchcmt FORWARD();
PROC rdch FORWARD();
PROC rdquotes FORWARD(CHAR eol);
PROC initrd FORWARD();

CONST BYTE _ASMMAXSPC;

PROC tokfilllblbuf FORWARD();

////
VAR CHAR _c1small;
VAR CHAR _c2small;
VAR BOOL _asmwaseof;
VAR UINT _asmwaseols; // EOL   
VAR UINT _asmspcsize;

VAR CHAR _stokfn[_STRLEN]; // 
VAR PCHAR _tokfn; // 
VAR UINT _lentokfn;

VAR BYTE _temppar;

#define _TOKLBLBUFSIZE 0x2000
VAR UINT _toklblbuffreestart; //[1];
//VAR UINT _tokoldlblbuffreestart; //[1];
CONST UINT _TOKLBLBUFEOF = 0xffff;
CONST UINT _TOKLBLBUFMAXSHIFT  = 0x1fb0/**(_LBLBUFSIZE-0x0100)*/; //0x3f00
//todo  
VAR UINT _toklblshift[0x100];
//VAR UINT _tokoldlblshift[0x100];
VAR BYTE _toklbls[_TOKLBLBUFSIZE]; //0x4000
VAR BYTE _toklblhash;

PROC rdaddwordall() //    
{
  _spcsize = 0; //    
  _waseols = 0;
  _curlnbeg = _curline;

  IF (_isalphanum[+(BYTE)_cnext] ) { //  
    REPEAT { //  (EOF  )
      IF (_lentword < _STRMAX) { //      ,     
        _tword[_lentword] = _cnext;
        INC _lentword;
      };
      _cnext = +(CHAR)readfin();
    }UNTIL (!_isalphanum[+(BYTE)_cnext]/** || _waseof*/ );
  }ELSE { //    -    (   )
    //rdch(); //    +    
    IF (_lentword < _STRMAX) { //      ,     
      _tword[_lentword] = _cnext;
      INC _lentword;
    };
    _cnext = +(CHAR)readfin();
  }; //     , ..    cnext   

  goto loopgo;
  loop: //REPEAT { //   EOF
    _cnext = +(CHAR)readfin();
  loopgo:
    IF (+(BYTE)_cnext < +(BYTE)'!') { // 
      INC _spcsize; //spaces after tword
      IF (+(BYTE)_cnext == 0x0a) {
        INC _curline;
        _spcsize = 0;
        INC _waseols;
      }ELSE IF (+(BYTE)_cnext == 0x09) {
        _spcsize = _spcsize + 7;
      };
      IF (!_waseof) goto loop;
    };
  //}UNTIL (_wasdieresis || _waseof );
  _tword[_lentword] = '\0'; //strclose(_tword, _lentword); //todo   clear..close
}
/**
PROC rdwordall()
//  _tword (     , , )
// ,      (   cnext,      )
{
  _lentword = 0; //strclear(_tword); //todo   clear..close
  rdaddwordall();
}
*/
//////////////////

PROC asmtoken(BYTE token)
{
  writebyte(_fout, token);
}

PROC tok_spc()
{
//IF (!_waseol) { //     
  WHILE (_asmspcsize > +(UINT)_ASMMAXSPC) { //    
    asmtoken(+_TOKSPC0+_ASMMAXSPC);
    _asmspcsize = _asmspcsize - +(UINT)_ASMMAXSPC;
  };
  IF (_asmspcsize!=0) asmtoken(+_TOKSPC0 + +(BYTE)_asmspcsize);
//};
}

PROC asmrdword_tok_spc() //       
//todo  eol  ?
{
  _asmwaseof = _waseof;
  _asmwaseols = _waseols;
  _asmspcsize = _spcsize; //    
  IF (_waseols==0) tok_spc(); //     (    eol)
  //rdwordall();
  _lentword = 0/**strclear(_tword)*/; //todo   clear..close
  rdaddwordall();
  _c1small = +(CHAR)(+(BYTE)(*(PCHAR)_tword)|0x20);
  _c2small = +(CHAR)(+(BYTE)_tword[1]|0x20);
}

PROC tok_text() // <text>text<endtext>
{
  asmtoken(+_TOKTEXT);
  fputs(_tword, _fout);
  asmtoken(+_TOKENDTEXT);
}

//        / ( _tword)
//    ,   waseol   ':'
PROC tok_err(BYTE token)
{
  asmtoken(+_ERR);
  asmtoken(token);
  WHILE (+TRUE) {
    tok_text(); // <text>text<endtext>
    IF ((_waseols!=0)||(_waseof)||(*(PCHAR)_tword==':')) BREAK;
    asmrdword_tok_spc();
  }; //TODO   
  asmtoken(+_TOKENDERR);
  asmrdword_tok_spc(); //[    EOL,]    ( )
  //todo asmfmt_err?
}

//         ( _tword)
//   ???
PROC tok_errcmd()
{
  tok_err(+_ERRCMD); //todo  asmcmd_err...asmfmt_err ?
}

PROC tokinitlblbuf()
{
  _toklblhash = 0x00;
  REPEAT {
    _toklblshift[_toklblhash] = _TOKLBLBUFEOF;
    INC _toklblhash;
  }UNTIL (_toklblhash == 0x00);
  _toklblbuffreestart = 0;
};

PROC tokcalllbl()
{
VAR PBYTE plbl; //    
//VAR PBYTE pstr; //    
//VAR BYTE cstr; //  
//VAR BYTE clbl; //   
//VAR BOOL res;
VAR UINT plbl_idx;
VAR PBYTE calladdr;
  //res = +FALSE;
  _toklblhash = +(BYTE)hash((PBYTE)_tword);

  plbl_idx = _toklblshift[_toklblhash];
  WHILE (plbl_idx != _TOKLBLBUFEOF) { //    
    plbl = &_toklbls[plbl_idx];
    plbl_idx = *(PUINT)(plbl);
    plbl = &plbl[+sizeof(UINT)/**+1*/]; //skip string size
    IF (strcp((PCHAR)_tword, (PCHAR)plbl)) { // 
      plbl = &plbl[11/**_lenname+1*/];
      calladdr = (PBYTE)*(PLONG)(plbl); //todo PPOI
      plbl = &plbl[+sizeof(LONG)]; //todo POI
      _temppar = *(PBYTE)(plbl);
      //INC plbl;
      CALL (calladdr);
      //res = +TRUE;
      //BREAK;
      goto e;
    };
  };
  tok_err(+_ERRCMD); //not found
  e: //RETURN res;
}

PROC tokaddlbl1(PCHAR txt, PBYTE proc, BYTE data)
{
VAR PBYTE plbl;
//VAR UINT freestart_idx;
//VAR UINT plbl_idx;
  _toklblhash = +(BYTE)hash((PBYTE)txt);

  // :                 
  //freestart_idx = _toklblbuffreestart; //[0] //  
  //plbl_idx = _toklblbuffreestart; //[0] //freestart_idx; //      (  !) //  
  plbl = &_toklbls[_toklblbuffreestart]; //[0] [plbl_idx]; //     //  
  // 
  POKE *(PUINT)(plbl) = _toklblshift[_toklblhash]; //    
  _toklblshift[_toklblhash] = _toklblbuffreestart; //[0] //freestart_idx; //     //  
  plbl = &plbl[+sizeof(UINT)];
  //POKE *(PBYTE)(plbl) = (BYTE)10/**(BYTE)_lenname*/;
  //INC plbl;
  strcopy(txt, 10/**_lenname*/, (PCHAR)plbl);
  plbl = &plbl[11/**_lenname+1*/];
  POKE *(PLONG)(plbl) = (LONG)proc; //todo PPOI
  plbl = &plbl[+sizeof(LONG)]; //todo POI
  POKE *(PBYTE)(plbl) = data;
  //INC plbl;
  //plbl_idx = +(UINT)(plbl - _toklbls); //   
  //_toklblshift[_toklblhash] = freestart_idx; //    
  //_toklblbuflen = _toklblbuflen + plbl_idx - freestart_idx;
  _toklblbuffreestart = +(UINT)(plbl - _toklbls) + 1; //    //plbl_idx; /**[0]*/
  //INC _toklblcount;
}

PROC tokaddlbl(PCHAR txt, PCHAR txt2, PBYTE proc, BYTE data)
{
  tokaddlbl1(txt, proc, data);
  tokaddlbl1(txt2, proc, data);
}

//////////////////////////////////////
// match ,  _tword  ( )    
//  ,  _tword  ,    (  +FALSE)
// ,     (  +FALSE)

    //reg  rp       inc,dec,[ld],[add],[adc],[sbc]
    //  reg (b,c,d,e,h,l,a,hx,lx,hy,ly,   i,r!),  rp (bc,de,hl,sp,ix,iy,   af!)
    //i,r  af  , ..     ,          
/**
FUNC BOOL tokmatch_direct()
{
  BOOL ok;
  if(*(PCHAR)_tword=='#') {asmtoken(TOK_DIRECT); asmrdword_tok_spc(); ok = +TRUE;}
  else ok = +FALSE;
  return ok;
}
*/
FUNC BOOL tokmatch_comma()
{
VAR BOOL ok;
  IF (*(PCHAR)_tword==',') {
    asmtoken(+_TOKCOMMA);
    asmrdword_tok_spc();
    ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_prime()
{
VAR BOOL ok;
  IF (*(PCHAR)_tword=='\'') {
    asmtoken(+_TOKPRIMESYM);
    asmrdword_tok_spc();
    ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_quote()
{
VAR BOOL ok;
  IF (*(PCHAR)_tword=='\"') {
    asmtoken(+_TOKDBLQUOTESYM);
    //asmrdword_tok_spc();
    ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_reequ()
{
VAR BOOL ok;
  IF (*(PCHAR)_tword=='=') {
    asmtoken(+_TOKEQUAL/**'='*/);
    asmrdword_tok_spc();
    ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_open()
{
VAR BOOL ok;
  IF       (*(PCHAR)_tword=='(') {asmtoken(+_TOKOPEN); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE IF (*(PCHAR)_tword=='[') {asmtoken(+_TOKOPENSQ); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_close()
{
VAR BOOL ok;
  IF       (*(PCHAR)_tword==')') {asmtoken(+_TOKCLOSE); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE IF (*(PCHAR)_tword==']') {asmtoken(+_TOKCLOSESQ); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

//////////////////////////////////////
FUNC BOOL tokexpr RECURSIVE FORWARD();

PROC tokeat_label(BYTE token)
{
  WHILE ((_cnext=='.')||(_cnext=='#')) {
    rdaddwordall(); // 
    IF (_spcsize==0)
      IF (_isalphanum[+(BYTE)_cnext]) // isalpha
        IF (_waseols==0)
          //IF (!_waseof)
            rdaddwordall(); //  
  };
  asmtoken(token/**_TOKLABEL  _CMDLABEL*/);
  asmtoken(+_TOKTEXT);
  fputs(_tword, _fout);
  asmtoken(+_TOKENDTEXT);
  asmrdword_tok_spc(); //    ()    
  //      ,         (   _asmwaseol)
}

PROC tokeat_val RECURSIVE() // ,       (, ,  )
//<val>::=
//(<expr>) // ()
//|<num> //  ( )
//|<var> //    (TODO   :   &<var>)
//|$
//|'CHAR' // 
//|-<val> // val,   NEG
//|+<val> // val
//|~<val> // val,   INV
//|!<val> // val,   INV(BOOL)
//|*<val> //    ( val,   PEEK)
{ //  
VAR CHAR opsym;
{
  opsym = *(PCHAR)_tword;
  IF (!_asmwaseof) { //      
    IF (+(BYTE)(+(BYTE)opsym - +(BYTE)'0') < 0x0a) { //<num> // <num><text>digits<endtext>
      asmtoken(+_TOKNUM);
      asmtoken(+_TOKTEXT);
      fputs(_tword, _fout);
      asmtoken(+_TOKENDTEXT);
      asmrdword_tok_spc(); //    ()    
      //      ,         (   _asmwaseol)
    }ELSE IF (_isalphanum[+(BYTE)opsym] || (opsym=='.') ) { //todo  '.',       // isalpha
      tokeat_label(+_TOKLABEL);
    }ELSE IF ( opsym=='$' ) {
      asmtoken(+_TOKDOLLAR);
      asmrdword_tok_spc(); //    ()    
    }ELSE IF ( opsym=='(' ) {
      asmtoken(+_TOKOPEN);
      asmrdword_tok_spc(); //    ()    
      tokexpr(); // //   expr   ')',       
      asmtoken(+_TOKCLOSE);
      asmrdword_tok_spc(); //    ()    
    }ELSE IF ( opsym=='\'' ) { //todo  TOK_TEXT...TOK_ENDTEXT
      asmtoken(+_TOKPRIME);
      _lentword = 0/**strclear(_tword)*/; //   
      rdquotes('\''/**, +FALSE*/);
      tok_text(); // <text>text<endtext>
      rdch(); //  
      asmtoken(+_TOKPRIME);
      asmrdword_tok_spc(); //    ()    
    }ELSE IF ( opsym=='-' ) {
      asmtoken(+_OPPUSH0); asmtoken(+_TOKMINUS/**'-'*/);
      asmrdword_tok_spc(); //    ()    
      tokeat_val(); //  val
      asmtoken(+_OPSUB);
    }ELSE IF ( opsym=='+' ) {
      asmtoken(+_OPPUSH0); asmtoken(+_TOKPLUS/**'+'*/);
      asmrdword_tok_spc(); //    ()    
      tokeat_val(); //  val
      asmtoken(+_OPADD);
    }ELSE IF ( opsym=='*' ) {
      asmtoken(+_OPPUSH0); asmtoken(+_TOKSTAR/**'*'*/);
      asmrdword_tok_spc(); //    ()    
      tokeat_val(); //  val
      asmtoken(+_OPPEEK);
    }ELSE IF ( opsym=='~' ) {
      asmtoken(+_OPPUSH0); asmtoken(+_TOKTILDE/**'~'*/);
      asmrdword_tok_spc(); //    ()    
      tokeat_val(); //  val
      asmtoken(+_OPINV);
    }ELSE IF ( opsym=='!' ) {
      asmtoken(+_OPPUSH0); asmtoken(+_TOKEXCL/**'!'*/);
      asmrdword_tok_spc(); //    ()    
      tokeat_val(); //  val
      asmtoken(+_OPINV); //todo BOOL
    }ELSE { tok_err(+_ERREXPR);/**errstr( ">>>WRONG PREFIX " ); err( opsym ); enderr();*/ };
  };
}
}

PROC tokeat_mul()
{
  /**asmtoken(_ASMOPPUSHSKIP1);*/ asmtoken(+_TOKSTAR/**'*'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_val(); // ,      
  asmtoken(+_OPMUL);
}

PROC tokeat_div()
{
  /**asmtoken(_ASMOPPUSHSKIP1);*/ asmtoken(+_TOKSLASH/**'/'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_val(); // ,      
  asmtoken(+_OPDIV);
}

PROC tokeat_and()
{
  /**asmtoken(_ASMOPPUSHSKIP1);*/ asmtoken(+_TOKAND/**'&'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_val(); // ,      
  asmtoken(+_OPAND);
}

PROC tokeat_andbool()
{
  /**asmtoken(_ASMOPPUSHSKIP2);*/ asmtoken(+_TOKAND/**'&'*/); asmtoken(+_TOKAND/**'&'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_val(); // ,      
  asmtoken(+_OPAND);
}

PROC tokeat_mulval RECURSIVE() // ,       (, ,  )
{ //  
VAR CHAR opsym;
VAR BOOL dbl;
{
  tokeat_val(); // ,      
  WHILE ((!_asmwaseof)&&(_asmwaseols==0)) { //    -   (_asmwaseol -   val)
    opsym=*(PCHAR)_tword;
    dbl = (opsym=='&')&&(_cnext==opsym); //C compatibility
    IF (dbl) asmrdword_tok_spc(); //use '&' //C compatibility
    IF       (opsym=='*') {tokeat_mul();
    }ELSE IF (opsym=='/') {tokeat_div();
    }ELSE IF (opsym=='&') {
      IF (dbl) {tokeat_andbool();
      }ELSE tokeat_and();
    }ELSE BREAK;
  };
}
}

PROC tokeat_add()
{
  /**asmtoken(_ASMOPPUSHSKIP1);*/ asmtoken(+_TOKPLUS/**'+'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_mulval(); // ,      
  asmtoken(+_OPADD);
}

PROC tokeat_sub()
{
  /**asmtoken(_ASMOPPUSHSKIP1);*/ asmtoken(+_TOKMINUS/**'-'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_mulval(); // ,      
  asmtoken(+_OPSUB);
}

PROC tokeat_or()
{
  /**asmtoken(_ASMOPPUSHSKIP1);*/ asmtoken(+_TOKPIPE/**'|'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_mulval(); // ,      
  asmtoken(+_OPOR);
}

PROC tokeat_orbool()
{
  /**asmtoken(_ASMOPPUSHSKIP2);*/ asmtoken(+_TOKPIPE/**'|'*/); asmtoken(+_TOKPIPE/**'|'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_mulval(); // ,      
  asmtoken(+_OPOR);
}

PROC tokeat_xor()
{
  /**asmtoken(_ASMOPPUSHSKIP1);*/ asmtoken(+_TOKCARON/**'^'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_mulval(); // ,      
  asmtoken(+_OPXOR);
}

PROC tokeat_xorbool()
{
  /**asmtoken(_ASMOPPUSHSKIP2);*/ asmtoken(+_TOKCARON/**'^'*/); asmtoken(+_TOKCARON/**'^'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_mulval(); // ,      
  asmtoken(+_OPXOR);
}

PROC tokeat_sumval RECURSIVE() // ,       (, ,  )
{ //  
VAR CHAR opsym;
VAR BOOL dbl;
{
  tokeat_mulval(); // ,      
  WHILE ((!_asmwaseof)&&(_asmwaseols==0)) { //    -   (_asmwaseol -   val)
    opsym=*(PCHAR)_tword;
    dbl = ( (opsym=='|')||(opsym=='^') )&&(_cnext==opsym); //C compatibility
    IF (dbl) asmrdword_tok_spc(); //use '|' or '^' //C compatibility
    IF (opsym=='+') {tokeat_add();
    }ELSE IF (opsym=='-') {tokeat_sub();
    }ELSE IF (opsym=='|') {
      IF (dbl) {tokeat_orbool();
      }ELSE tokeat_or();
    }ELSE IF (opsym=='^') {
      IF (dbl) {tokeat_xorbool();
      }ELSE tokeat_xor();
    }ELSE BREAK;
  };
}
}

PROC tokeat_shl()
{
  /**asmtoken(_ASMOPPUSHSKIP2);*/ asmtoken(+_TOKLESS/**'<'*/); asmtoken(+_TOKLESS/**'<'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_sumval(); // ,      
  asmtoken(+_OPSHL);
}

PROC tokeat_shr()
{
  /**asmtoken(_ASMOPPUSHSKIP2);*/ asmtoken(+_TOKMORE/**'>'*/); asmtoken(+_TOKMORE/**'>'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_sumval(); // ,      
  asmtoken(+_OPSHR);
}

PROC tokeat_less()
{
  /**asmtoken(_ASMOPPUSHSKIP1);*/ asmtoken(+_TOKLESS/**'<'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_sumval(); // ,      
  asmtoken(+_OPLESS);
}

PROC tokeat_lesseq()
{
  /**asmtoken(_ASMOPPUSHSKIP2);*/ asmtoken(+_TOKLESS/**'<'*/); asmtoken(+_TOKEQUAL/**'='*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_sumval(); // ,      
  asmtoken(+_OPLESSEQ);
}

PROC tokeat_more()
{
  /**asmtoken(_ASMOPPUSHSKIP1);*/ asmtoken(+_TOKMORE/**'>'*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_sumval(); // ,      
  asmtoken(+_OPMORE);
}

PROC tokeat_moreeq()
{
  /**asmtoken(_ASMOPPUSHSKIP2);*/ asmtoken(+_TOKMORE/**'>'*/); asmtoken(+_TOKEQUAL/**'='*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_sumval(); // ,      
  asmtoken(+_OPMOREEQ);
}

PROC tokeat_eq()
{
  /**asmtoken(_ASMOPPUSHSKIP2);*/ asmtoken(+_TOKEQUAL/**'='*/); asmtoken(+_TOKEQUAL/**'='*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_sumval(); // ,      
  asmtoken(+_OPEQ);
}

PROC tokeat_noteq()
{
  /**asmtoken(_ASMOPPUSHSKIP2);*/ asmtoken(+_TOKEXCL/**'!'*/); asmtoken(+_TOKEQUAL/**'='*/);
  asmrdword_tok_spc(); //    ()    
  tokeat_sumval(); // ,      
  asmtoken(+_OPNOTEQ);
}

FUNC BOOL tokexpr RECURSIVE() // ,       (, ,  )
{ //  
VAR CHAR opsym;
VAR BOOL modified;
VAR BOOL dbl;
//VAR BOOL ok;
{
  //ok = +TRUE;
  tokeat_sumval(); // ,      
  WHILE ((!_asmwaseof)&&(_asmwaseols==0)) { //    -   (_asmwaseol -   val)
    opsym = *(PCHAR)_tword;
    modified = (_cnext=='=');
    dbl = (_cnext==opsym);
    IF (modified||dbl) asmrdword_tok_spc(); //use '=' or '>' or '<'
    IF (opsym=='<') {
      IF (dbl) {tokeat_shl(); //   ,   !
      }ELSE IF (modified) {tokeat_lesseq();
      }ELSE tokeat_less();
    }ELSE IF (opsym=='>') {
      IF (dbl) {tokeat_shr(); //   ,   !
      }ELSE IF (modified) {tokeat_moreeq();
      }ELSE tokeat_more();
    }ELSE IF (opsym=='=') {tokeat_eq();
    }ELSE IF (opsym=='!') {tokeat_noteq();
    }ELSE BREAK;
  };
  RETURN +TRUE; //ok; //todo err
}
}

FUNC BOOL tokexpr_close() //     , ..   
{
VAR BOOL ok;
  ok =             tokexpr();
  IF (ok) ok = tokmatch_close();
  RETURN ok;
}

PROC asm_direct_expr_close_token(BYTE token)
{
  //if(tokmatch_direct()) {
    IF (tokexpr()) {
      IF (tokmatch_close()) {asmtoken(token);
      }ELSE tok_err(+_ERRCLOSE); //no closing bracket
    }ELSE tok_err(+_ERREXPR); //wrong expr
  //}else tok_err(_ERRPAR); //no direct
}

PROC tok_comment()
{
  asmtoken(+_TOKCOMMENT);
  _lentword = 0/**strclear(_tword)*/; //   
  IF (_waseols==0) { //    ;  
    WHILE (_spcsize != 0) { //  
      _lentword = stradd(_tword, _lentword, ' ');
      DEC _spcsize;
    };
    WHILE (_waseols==0/**&&(!_waseof)*//**&&(_cnext!=_DIERESIS)*/) {
      rdchcmt(); //  
    };
  };
  _tword[_lentword] = '\0'; //strclose(_tword, _lentword); //todo   clear..close
  tok_text(); // <text>text<endtext>
  asmtoken(+_TOKENDCOMMENT);
  IF (+(BYTE)_cnext < +(BYTE)'!') {
    IF (_cnext == '\t') {
      _spcsize = _spcsize + 8;
    }ELSE {
      INC _spcsize;
    };
    rdch(); //    +    
  };
  asmrdword_tok_spc(); //[    EOL,]    ( )
}

PROC tok_org()
{
  asmtoken(+_CMDORG);
  asmrdword_tok_spc(); // 
  IF (tokexpr()) {asmtoken(+_FMTCMD);
  }ELSE tok_err(+_ERREXPR); //wrong expr
}

PROC tok_align()
{
  tok_err(+_ERRCMD);
}

PROC tok_page()
{
  tok_err(+_ERRCMD);
}

PROC tok_if()
{
  tok_err(+_ERRCMD);
}

PROC tok_else()
{
  tok_err(+_ERRCMD);
}

PROC tok_endif()
{
  tok_err(+_ERRCMD);
}

PROC tok_dup()
{
  tok_err(+_ERRCMD);
}

PROC tok_edup()
{
  tok_err(+_ERRCMD);
}

PROC tok_macro()
{
  tok_err(+_ERRCMD);
}

PROC tok_endm()
{
  tok_err(+_ERRCMD);
}

PROC tok_export()
{
  asmtoken(+_CMDEXPORT);
  asmrdword_tok_spc(); // call
  tokeat_label(+_TOKLABEL);
  //asmmtoken(+_TOKTEXT);
  //fputs(_tword, _fout);
  //asmtoken(+_TOKENDTEXT);
  //asmrdword_tok_spc(); //    ()    
  asmtoken(+_FMTCMD); //  label
}

PROC tok_local()
{
  tok_err(+_ERRCMD);
}

PROC tok_endl()
{
  tok_err(+_ERRCMD);
}

PROC tok_disp()
{
  asmtoken(+_CMDDISP);
  asmrdword_tok_spc(); // 
  IF (tokexpr()) {asmtoken(+_FMTCMD);
  }ELSE tok_err(+_ERREXPR); //wrong expr
}

PROC tok_ent()
{
  asmtoken(+_CMDENT);
  asmrdword_tok_spc(); // 
  asmtoken(+_FMTCMD);
}

PROC tok_include()
{
  asmtoken(+_CMDINCLUDE);
  asmrdword_tok_spc(); // 
  IF (tokmatch_quote()) {
    //asmtoken(+_OPWRSTR);
    _lentword = 0/**strclear(_tword)*/; //   
    rdquotes('\"');
    tok_text(); // <text>text<endtext>
    rdch(); //  
    asmtoken(+_TOKDBLQUOTESYM);
    asmrdword_tok_spc();
  }ELSE tok_err(+_ERREXPR);
  //asmtoken(+_FMTCMD); //todo?
}

PROC tok_incbin()
{
  asmtoken(+_CMDINCBIN);
  asmrdword_tok_spc(); // 
  IF (tokmatch_quote()) {
    //asmtoken(+_OPWRSTR);
    _lentword = 0/**strclear(_tword)*/; //   
    rdquotes('\"');
    tok_text(); // <text>text<endtext>
    rdch(); //  
    asmtoken(+_TOKDBLQUOTESYM);
    asmrdword_tok_spc();
  }ELSE tok_err(+_ERREXPR);
  //todo  (, )
  //asmtoken(+_FMTCMD); //todo?
}

PROC tok_db()
{
  asmtoken(+_CMDDB);
  asmrdword_tok_spc(); // 
  REPEAT {
    IF (tokmatch_quote()) {
      asmtoken(+_OPWRSTR);
      _lentword = 0/**strclear(_tword)*/; //   
      rdquotes('\"');
      tok_text(); // <text>text<endtext>
      rdch(); //  
      asmtoken(+_TOKDBLQUOTESYM);
      asmrdword_tok_spc();
    }ELSE IF (tokexpr()) {
      asmtoken(+_OPWRVAL);
    }ELSE tok_err(+_ERREXPR);
  }UNTIL (!tokmatch_comma());
  asmtoken(+_FMTCMD);
}

PROC tok_dw()
{
  asmtoken(+_CMDDW);
  asmrdword_tok_spc(); // 
  REPEAT {
    tokexpr();
    asmtoken(+_OPWRVAL);
  }UNTIL (!tokmatch_comma());
  asmtoken(+_FMTCMD);
}

PROC tok_dl()
{
  asmtoken(+_CMDDL);
  asmrdword_tok_spc(); // 
  REPEAT {
    tokexpr();
    asmtoken(+_OPWRVAL);
  }UNTIL (!tokmatch_comma());
  asmtoken(+_FMTCMD);
}

PROC tok_ds()
{
  asmtoken(+_CMDDS);
  asmrdword_tok_spc(); // 
  tokexpr();
  WHILE (tokmatch_comma()) {
    tokexpr();
  };
  asmtoken(+_FMTCMD);
}

PROC tok_display()
{
  tok_err(+_ERRCMD);
}

PROC tok_repeat()
{
  tok_err(+_ERRCMD);
}

PROC tok_until()
{
  tok_err(+_ERRCMD);
}

PROC tok_struct()
{
  tok_err(+_ERRCMD);
}

PROC tok_endstruct()
{
  tok_err(+_ERRCMD);
}

PROC tok_colon()
{
  asmtoken(+_TOKCOLON);
  asmrdword_tok_spc(); // ':'
}

///////////////////////

PROC tokcmd()
{
  //_asmwaseof=_waseof;
  //rdword_tok_spc(); //   
  //stringdecapitalize(_tword,_lentword);
  IF (*(PCHAR)_tword==';') {tok_comment();
/**  }ELSE IF (*(PCHAR)_tword==':') {
    asmtoken(+_TOKCOLON);
    asmrdword_tok_spc(); // ':'
*/
  }ELSE IF (_asmspcsize!=0) {
    //tokasm(); //assembly mnemonic or directive
    tokcalllbl();
/**    IF (!tokcalllbl(_tword)) {
      tok_err(+_ERRCMD); //wrong _tword
    };*/
  }ELSE { //<label>  <label>=<expr>
    tokeat_label(+_CMDLABEL); // 
    IF (tokmatch_reequ()) { //<label>=<expr>
      IF (tokexpr()) {
        asmtoken(+_FMTREEQU);
      }ELSE tok_err(+_ERREXPR); //wrong expr
    }ELSE //IF ((_asmwaseols!=0)||(_asmwaseof)||(*(PCHAR)_tword==':')||(*(PCHAR)_tword==';')){ //<label>
      asmtoken(+_FMTCMD); //<label>
    //}ELSE tok_err(+_ERRCMD); //wrong _tword
  };
  // eol  ,       
  IF (_asmwaseols!=0) {
    WHILE (_asmwaseols!=0) {
      asmtoken(+_TOKEOL);
      DEC _asmwaseols;
    };
    tok_spc(); //  
  };
}

PROC tokinit()
{
  _tokfn = (PCHAR)_stokfn;
  tokinitlblbuf();
  tokfilllblbuf();
}

PROC tokenize(PCHAR fn)
{
  _curline = 1;

  _fin = fopen(fn, "rb");
  _waseof = +FALSE;
  initrd();

  _lentokfn = strjoineol(_tokfn, 0, fn, '.'); //terminator is not copied
  _lentokfn = stradd(_tokfn, _lentokfn, '.');
  _lentokfn = stradd(_tokfn, _lentokfn, (CHAR)((BYTE)fn[_lentokfn]&0xdf));
  _lentokfn = stradd(_tokfn, _lentokfn, '_');
  _tokfn[_lentokfn] = '\0';
  _fout = openwrite(_tokfn);

  _asmwaseols = 0;
  _asmwaseof = +FALSE;
  asmrdword_tok_spc(); //  

  WHILE (!_asmwaseof) { //todo  endasm ('}')
    tokcmd();
  };

  asmtoken(+_TOKEOF);
  closewrite(_fout); //closefout();

  fclose(_fin); //closefin();
}

PROC tokenize_end()
{
}
