//// imported
//FUNC BOOL strcplow FORWARD(PCHAR s1, PCHAR s2);
PROC tokaddlbl FORWARD(PCHAR txt, PCHAR txt2, PBYTE proc, BYTE data);

EXTERN PCHAR _tword; // 
EXTERN UINT _lentword;

EXTERN BYTE _temppar;

PROC asmtoken FORWARD(BYTE token);

PROC tok_org FORWARD();
PROC tok_align FORWARD();
PROC tok_page FORWARD();
PROC tok_if FORWARD();
PROC tok_else FORWARD();
PROC tok_endif FORWARD();
PROC tok_dup FORWARD();
PROC tok_edup FORWARD();
PROC tok_macro FORWARD();
PROC tok_endm FORWARD();
//PROC tok_usemacro FORWARD();
PROC tok_export FORWARD();
PROC tok_local FORWARD();
PROC tok_endl FORWARD();
PROC tok_disp FORWARD();
PROC tok_ent FORWARD();
PROC tok_include FORWARD();
PROC tok_incbin FORWARD();
PROC tok_db FORWARD();
PROC tok_dw FORWARD();
PROC tok_dl FORWARD();
PROC tok_ds FORWARD();
PROC tok_display FORWARD();
PROC tok_repeat FORWARD();
PROC tok_until FORWARD();
PROC tok_struct FORWARD();
PROC tok_endstruct FORWARD();
PROC tok_comment FORWARD();
PROC tok_colon FORWARD();

EXTERN CHAR _c1small;
EXTERN CHAR _c2small;
EXTERN BOOL _asmwaseof;
EXTERN UINT _asmwaseols;

PROC tok_eol FORWARD();
PROC asmrdword_tok_spc FORWARD(); //       
PROC tok_text FORWARD(); // <text>text<endtext>
PROC tok_err FORWARD(BYTE token);
PROC tok_errcmd FORWARD();
FUNC BOOL tokmatch_comma FORWARD();
FUNC BOOL tokmatch_prime FORWARD();
FUNC BOOL tokmatch_quote FORWARD();
FUNC BOOL tokmatch_reequ FORWARD();
FUNC BOOL tokmatch_open FORWARD();
FUNC BOOL tokmatch_close FORWARD();
FUNC BOOL tokexpr FORWARD(); // ,       (, ,  )
FUNC BOOL tokexpr_close FORWARD(); //     , ..   
PROC asm_direct_expr_close_token FORWARD(BYTE token);

////

FUNC BOOL tokmatch_nzzncc()
{
VAR BOOL ok;
  IF       ((_lentword==2)&&(_c1small=='n')&&(_c2small=='z')) {asmtoken(+_ASMNZ); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE IF ((_lentword==1)&&(_c1small=='z')                 ) {asmtoken(+_ASMZ); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE IF ((_lentword==2)&&(_c1small=='n')&&(_c2small=='c')) {asmtoken(+_ASMNC); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE IF ((_lentword==1)&&(_c1small=='c')                 ) {asmtoken(+_ASMC); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_cc()
{
VAR BOOL ok;
  IF (_lentword==1) {
    IF       (_c1small=='z') {asmtoken(+_ASMZ); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF (_c1small=='c') {asmtoken(+_ASMC); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF (_c1small=='p') {asmtoken(+_ASMP); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF (_c1small=='m') {asmtoken(+_ASMM); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE ok = +FALSE;
  }ELSE IF (_lentword==2) {
    IF       ((_c1small=='n')&&(_c2small=='z')) {asmtoken(+_ASMNZ); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='n')&&(_c2small=='c')) {asmtoken(+_ASMNC); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='p')&&(_c2small=='o')) {asmtoken(+_ASMPO); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='p')&&(_c2small=='e')) {asmtoken(+_ASMPE); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE ok = +FALSE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_a()
{
VAR BOOL ok;
  IF ((_c1small=='a')&&(_lentword==1)) {
    asmtoken(+_RG_A);  asmrdword_tok_spc(); ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_c()
{
VAR BOOL ok;
  IF ((_c1small=='c')&&(_lentword==1)) {
    asmtoken(+_RG_C); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}
/**
FUNC BOOL tokmatch_bc()
{
VAR BOOL ok;
  IF ((_c1small=='b')&&(_c2small=='c')&&(_lentword==2)) {
    asmtoken(+_RG_BC); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}
*/
FUNC BOOL tokmatch_de()
{
VAR BOOL ok;
  IF ((_c1small=='d')&&(_c2small=='e')&&(_lentword==2)) {
    asmtoken(+_RG_DE); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_hl()
{
VAR BOOL ok;
  IF ((_c1small=='h')&&(_c2small=='l')&&(_lentword==2)) {
    asmtoken(+_RG_HL); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_sp()
{
VAR BOOL ok;
  IF ((_c1small=='s')&&(_c2small=='p')&&(_lentword==2)) {
    asmtoken(+_RG_SP); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_af()
{
VAR BOOL ok;
  IF ((_c1small=='a')&&(_c2small=='f')&&(_lentword==2)) {
    asmtoken(+_RG_AF); asmrdword_tok_spc(); ok = +TRUE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_ixiy()
{
VAR BOOL ok;
  IF (_lentword==2) {
    IF       ((_c1small=='i')&&(_c2small=='x')) {
      asmtoken(+_RG_IX); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='i')&&(_c2small=='y')) {
      asmtoken(+_RG_IY); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE ok = +FALSE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_hlixiy()
{
VAR BOOL ok;
  IF (_lentword==2) {
    IF       ((_c1small=='h')&&(_c2small=='l')) {
      asmtoken(+_RG_HL); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='i')&&(_c2small=='x')) {
      asmtoken(+_RG_IX); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='i')&&(_c2small=='y')) {
      asmtoken(+_RG_IY); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE ok = +FALSE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_ir()
{
VAR BOOL ok;
  IF (_lentword==1) {
    IF       (_c1small=='i') {
      asmtoken(+_RG_I); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF (_c1small=='r') {
      asmtoken(+_RG_R); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE ok = +FALSE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_rp()
{
VAR BOOL ok;
  IF (_lentword==2) {
    IF       ((_c1small=='b')&&(_c2small=='c')) {asmtoken(+_RG_BC); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='d')&&(_c2small=='e')) {asmtoken(+_RG_DE); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='h')&&(_c2small=='l')) {asmtoken(+_RG_HL); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='s')&&(_c2small=='p')) {asmtoken(+_RG_SP); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='i')&&(_c2small=='x')) {asmtoken(+_RG_IX); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='i')&&(_c2small=='y')) {asmtoken(+_RG_IY); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='r')&&(_c2small=='p')) { //rp 
      asmrdword_tok_spc();
      asmtoken(+_RG_RPBYNAME);
      tok_text(); // <text>text<endtext>
      asmrdword_tok_spc();
      ok = +TRUE;
    }ELSE ok = +FALSE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

FUNC BOOL tokmatch_rb()
{
VAR BOOL ok;
  IF (_lentword==1) {
    IF       (_c1small=='b') {asmtoken(+_RG_B); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF (_c1small=='c') {asmtoken(+_RG_C); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF (_c1small=='d') {asmtoken(+_RG_D); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF (_c1small=='e') {asmtoken(+_RG_E); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF (_c1small=='h') {asmtoken(+_RG_H); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF (_c1small=='l') {asmtoken(+_RG_L); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF (_c1small=='a') {asmtoken(+_RG_A); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE ok = +FALSE;
  }ELSE IF (_lentword==2) {
    IF       ((_c1small=='h')&&(_c2small=='x')) {asmtoken(+_RG_HX); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='l')&&(_c2small=='x')) {asmtoken(+_RG_LX); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='h')&&(_c2small=='y')) {asmtoken(+_RG_HY); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='l')&&(_c2small=='y')) {asmtoken(+_RG_LY); asmrdword_tok_spc(); ok = +TRUE;
    }ELSE IF ((_c1small=='r')&&(_c2small=='b')) { //rb 
      asmrdword_tok_spc();
      asmtoken(+_RG_RBBYNAME);
      tok_text(); // <text>text<endtext>
      asmrdword_tok_spc();
      ok = +TRUE;
    }ELSE ok = +FALSE;
  }ELSE ok = +FALSE;
  RETURN ok;
}

//////////////       

PROC asm_hlix_close_token(BYTE hltoken, BYTE ixtoken)
{
  IF (tokmatch_hl()) {
    IF (tokmatch_close()) {asmtoken(hltoken);
    }ELSE tok_err(+_ERRCLOSE); //no closing bracket
  }ELSE IF (tokmatch_ixiy()) {
    IF (tokexpr_close()) {asmtoken(ixtoken);
    }ELSE tok_err(+_ERREXPR); //wrong expr / no closing bracket
  }ELSE tok_err(+_ERRREG); //wrong register
}

PROC asm_directhlixrp_close_token(BYTE directtoken, BYTE hltoken, BYTE ixtoken, BYTE rptoken)
{
  IF (tokmatch_hl()){
    IF (tokmatch_close()) {asmtoken(hltoken);
    }ELSE tok_err(+_ERRCLOSE); //no closing bracket
  }ELSE IF (tokmatch_ixiy()) {
    IF (tokexpr_close()) {asmtoken(ixtoken);
    }ELSE tok_err(+_ERREXPR); //wrong expr / no closing bracket
  }ELSE IF (tokmatch_rp()) {
    IF (tokmatch_close()) {asmtoken(rptoken);
    }ELSE tok_err(+_ERRCLOSE); //no closing bracket
  }ELSE //if(tokmatch_direct()) {
    IF (tokexpr_close()) {asmtoken(directtoken);
    }ELSE tok_err(+_ERREXPR); //wrong expr / no closing bracket
  //}else tok_err(+_ERRPAR); //wrong register
}

PROC asm_directrb_token(BYTE directtoken, BYTE rbtoken)
{
  IF (tokmatch_rb()) { //<cmd> rb
    asmtoken(rbtoken);
  }ELSE //if(tokmatch_direct()) { //<cmd> #N
    IF (tokexpr()) {asmtoken(directtoken);
    }ELSE tok_err(+_ERREXPR); //wrong expr
  //}else tok_err(+_ERRPAR); //wrong register or direct expr
}

///////////////////////////////////////////////////

PROC tok_ex()
{
//  _ignoreprime = +TRUE;
  asmtoken(+_ASMEX);
  asmrdword_tok_spc(); //  : a, <rp>/rp 
  IF (tokmatch_open()) { //ex (sp),hl/ix/iy
    IF (tokmatch_sp()) {
      IF (tokmatch_close()) {
        IF (tokmatch_comma()) { //  : hl, ix, iy
          IF (tokmatch_hlixiy()) {asmtoken(+_FMTEXRPRP);
          }ELSE tok_err(+_ERRREG); //wrong register
        }ELSE tok_err(+_ERRCOMMA); //no comma
      }ELSE tok_err(+_ERRCLOSE); //no closing bracket
    }ELSE tok_err(+_ERRREG); //wrong register
  }ELSE IF (tokmatch_de()) { //ex de,hl
    IF (tokmatch_comma()) { //  : hl
      IF (tokmatch_hl()) {asmtoken(+_FMTEXRPRP);
      }ELSE tok_err(+_ERRREG); //wrong register
    }ELSE tok_err(+_ERRCOMMA); //no comma
  }ELSE IF (tokmatch_af()) { //ex af,af'
    IF (tokmatch_comma()) { //  : af'
      IF (tokmatch_af()) {
        IF (tokmatch_prime()) {asmtoken(+_FMTEXRPRP);
        }ELSE tok_err(+_ERRREG); //wrong register
      }ELSE tok_err(+_ERRREG); //wrong register
    }ELSE tok_err(+_ERRCOMMA); //no comma
  };
//  _ignoreprime = +FALSE;
}

PROC tok_inc()
{
  asmtoken(+_ASMINC);
  asmrdword_tok_spc(); //  : <rb>, <rp>, '('  (hl), '('  (ix/iy[+-d]), rp  ( rpbyname), rb  ( rbbyname)
  IF (tokmatch_open()) { //inc (hl)  inc(ix/iy[+-d])
    asm_hlix_close_token(+_FMTINCDECMHL/**_FMTALUCMDMHL*/, +_FMTINCDECIDX/**_FMTALUCMDIDX*/);
  }ELSE { // 
    IF (tokmatch_rp()) {asmtoken(+_FMTINCRP); //bc,de,hl,sp,ix,iy,rp 
    }ELSE IF (tokmatch_rb()) {asmtoken(+_FMTINCDECRB/**_FMTALUCMDRB*/); //b,c,d,e,h,l,a,hx,lx,hy,ly,rb 
    }ELSE tok_err(+_ERRREG); //wrong register
  };
}

PROC tok_dec()
{
  asmtoken(+_ASMDEC);
  asmrdword_tok_spc(); //  : <rb>, <rp>, '('  (hl), '('  (ix/iy[+-d]), rp  ( rpbyname), rb  ( rbbyname)
  IF (tokmatch_open()) { //inc (hl)  inc(ix/iy[+-d])
    asm_hlix_close_token(+_FMTINCDECMHL/**_FMTALUCMDMHL*/, +_FMTINCDECIDX/**_FMTALUCMDIDX*/);
  }ELSE { // 
    IF (tokmatch_rp()) {asmtoken(+_FMTDECRP); //bc,de,hl,sp,ix,iy,rp 
    }ELSE IF (tokmatch_rb()) {asmtoken(+_FMTINCDECRB/**_FMTALUCMDRB*/); //b,c,d,e,h,l,a,hx,lx,hy,ly,rb 
    }ELSE tok_err(+_ERRREG); //wrong register
  };
}

PROC tok_add()
{
  asmtoken(+_ASMADD);
  asmrdword_tok_spc(); //  : a, <rp>/rp 
  IF (tokmatch_a()) {
    IF (tokmatch_comma()) { //  : N, '('  hl, '('  (ix/iy[+-d]), <rb>/rb 
      IF (tokmatch_open()) {asm_hlix_close_token(+_FMTALUCMDMHL, +_FMTALUCMDIDX); //add a,(hl)  add a,(ix/iy[+-d])
      }ELSE asm_directrb_token(+_FMTALUCMDN, +_FMTALUCMDRB); //add a,#N  add a,rb
    }ELSE tok_err(+_ERRCOMMA); //no comma
  }ELSE IF (tokmatch_hlixiy()) { //add hl/ix/iy,rp
    IF (tokmatch_comma()) { //  : <rp>/rp 
      IF (tokmatch_rp()) {asmtoken(+_FMTADDHLRP);
      }ELSE tok_err(+_ERRREG); //wrong register
    }ELSE tok_err(+_ERRCOMMA); //no comma
  };
}

PROC tok_adc()
{
  asmtoken(+_ASMADC);
  asmrdword_tok_spc(); //  : a, hl
  IF (tokmatch_a()) {
    IF (tokmatch_comma()) { //  : N, '('  hl, '('  (ix/iy[+-d]), <rb>/rb 
      IF (tokmatch_open()) {asm_hlix_close_token(+_FMTALUCMDMHL, +_FMTALUCMDIDX); //adc a,(hl)  adc a,(ix/iy[+-d])
      }ELSE asm_directrb_token(+_FMTALUCMDN, +_FMTALUCMDRB); //adc a,#N  adc a,rb
    }ELSE tok_err(+_ERRCOMMA); //no comma
  }ELSE IF (tokmatch_hl()) { //adc hl,rp
    IF (tokmatch_comma()) { //  : <rp>/rp 
      IF (tokmatch_rp()) {asmtoken(+_FMTADCHLRP);
      }ELSE tok_err(+_ERRREG); //wrong register
    }ELSE tok_err(+_ERRCOMMA); //no comma
  };
}

PROC tok_sbc()
{
  asmtoken(+_ASMSBC);
  asmrdword_tok_spc(); //  : a, hl
  IF (tokmatch_a()) {
    IF (tokmatch_comma()) { //  : N, '('  hl, '('  (ix/iy[+-d]), <rb>/rb 
      IF (tokmatch_open()) {asm_hlix_close_token(+_FMTALUCMDMHL, +_FMTALUCMDIDX); //adc a,(hl)  adc a,(ix/iy[+-d])
      }ELSE asm_directrb_token(+_FMTALUCMDN, +_FMTALUCMDRB); //adc a,#N  adc a,rb
    }ELSE tok_err(+_ERRCOMMA); //no comma
  }ELSE IF (tokmatch_hl()) { //sbc hl,rp
    IF (tokmatch_comma()) { //  : <rp>/rp 
      IF (tokmatch_rp()) {asmtoken(+_FMTSBCHLRP);
      }ELSE tok_err(+_ERRREG); //wrong register
    }ELSE tok_err(+_ERRCOMMA); //no comma
  };
}

PROC tok_alucmd(BYTE token)
{
  asmtoken(token);
  asmrdword_tok_spc(); //  //  : N, '('  hl, '('  (ix/iy[+-d]), <rb>/rb 
  IF (tokmatch_open()) {asm_hlix_close_token(+_FMTALUCMDMHL, +_FMTALUCMDIDX); //<cmd> (hl)  <cmd> (ix/iy[+-d])
  }ELSE asm_directrb_token(+_FMTALUCMDN, +_FMTALUCMDRB); //<cmd> #N  <cmd> rb
}

PROC tok_cbxx(BYTE token)
{
  asmtoken(token);
  asmrdword_tok_spc(); //  //  : '('  hl, '('  (ix/iy[+-d]), <rb>/rb 
  IF (tokmatch_open()) {asm_hlix_close_token(+_FMTCBCMDMHL, +_FMTCBCMDIDX); //<cmd> (hl)  <cmd> (ix/iy[+-d])
  }ELSE { //<cmd> rb
    IF (tokmatch_rb()) {asmtoken(+_FMTCBCMDRB);
    }ELSE tok_err(+_ERRREG); //wrong register
  };
}

PROC tok_bit(BYTE token)
{
  asmtoken(token);
  asmrdword_tok_spc(); // 
  IF (tokexpr()) {
    asmtoken(+_OPBIT); // bit/res/set:  pseudon (  0..7,  ),   8     
    IF (tokmatch_comma()) { //  : '('  hl, '('  (ix/iy[+-d]), <rb>/rb 
      IF (tokmatch_open()) {asm_hlix_close_token(+_FMTCBCMDMHL, +_FMTCBCMDIDX); //<cmd> N,(hl)  <cmd> N,(ix/iy[+-d])
      }ELSE { //<cmd> N,rb
        IF (tokmatch_rb()) {asmtoken(+_FMTCBCMDRB);
        }ELSE tok_err(+_ERRREG); //wrong register
      };
    }ELSE tok_err(+_ERRCOMMA); //no comma
  }ELSE tok_err(+_ERREXPR); //wrong expr
}

PROC tok_out()
{
  asmtoken(+_ASMOUT);
  asmrdword_tok_spc(); //  //  : '('  c, '('  #N
  IF (tokmatch_open()) {
    IF (tokmatch_c()) {
      IF (tokmatch_close()) {
        IF (tokmatch_comma()) { //  : <rb>/rb 
          IF (tokmatch_rb()) {asmtoken(+_FMTOUTCRB);
          }ELSE tok_err(+_ERRREG); //wrong register
        }ELSE tok_err(+_ERRCOMMA); //no comma
      }ELSE tok_err(+_ERRCLOSE); //no closing bracket
    }ELSE IF (tokexpr_close()) { //out (#N),a
      IF (tokmatch_comma()) { //  : a
        IF (tokmatch_a()) {asmtoken(+_FMTALUCMDN);
        }ELSE tok_err(+_ERRREG); //wrong register
      }ELSE tok_err(+_ERRCOMMA); //no comma
    }ELSE tok_err(+_ERRPAR); //wrong parameter / no closing bracket
  }ELSE tok_err(+_ERROPEN); //no opening bracket
}

PROC tok_in()
{
  asmtoken(+_ASMIN);
  asmrdword_tok_spc(); //  //  : a, <rb>/rb 
  IF (tokmatch_a()) {
    IF (tokmatch_comma()) { //  : '('  c, '('  #N
      IF (tokmatch_open()) {
        IF (tokmatch_c()) {
          IF (tokmatch_close()) {asmtoken(+_FMTINRBC);
          }ELSE tok_err(+_ERRCLOSE); //no closing bracket
        }ELSE IF (tokexpr_close()) {
          asmtoken(+_FMTALUCMDN); //in a,(#N)
        }ELSE tok_err(+_ERRPAR); //wrong parameter / no closing bracket
      }ELSE tok_err(+_ERROPEN); //no opening bracket
    }ELSE tok_err(+_ERRCOMMA); //no comma
  }ELSE IF (tokmatch_rb()) {
    IF (tokmatch_comma()) { //  : '('  c
      IF (tokmatch_open()) {
        IF (tokmatch_c()) {
          IF (tokmatch_close()) {asmtoken(+_FMTINRBC);
          }ELSE tok_err(+_ERRCLOSE); //no closing bracket
        }ELSE tok_err(+_ERRPAR); //wrong parameter
      }ELSE tok_err(+_ERROPEN); //no opening bracket
    }ELSE tok_err(+_ERRCOMMA); //no comma
  }ELSE tok_err(+_ERRREG); //wrong register
}

PROC tok_push()
{
  asmtoken(+_ASMPUSH);
  asmrdword_tok_spc();
  IF (tokmatch_af()) {asmtoken(+_FMTPUSHPOPRP);
  }ELSE IF (tokmatch_rp()) {asmtoken(+_FMTPUSHPOPRP);
  }ELSE tok_err(+_ERRREG); //wrong register
}

PROC tok_pop()
{
  asmtoken(+_ASMPOP);
  asmrdword_tok_spc();
  IF (tokmatch_af()) {asmtoken(+_FMTPUSHPOPRP);
  }ELSE IF (tokmatch_rp()) {asmtoken(+_FMTPUSHPOPRP);
  }ELSE tok_err(+_ERRREG); //wrong register
}

PROC tok_ld() //(ix)  +d  , ..         push0 - TODO
{
  asmtoken(+_ASMLD);
  asmrdword_tok_spc(); //  : 'I', 'R', <rb>, <rp>, '('  NN, '('  (hl), '('  (ix/iy[+-d]), rp  ( rpbyname), rb  ( rbbyname)
  IF (tokmatch_open()) { //   
    IF (tokmatch_hl()) { //ld (hl),rb  ld (hl),N
      IF (tokmatch_close()) {
        IF (tokmatch_comma()) {asm_directrb_token(+_FMTPUTMHLN, +_FMTPUTMHLRB);
        }ELSE tok_err(+_ERRCOMMA); //no comma
      }ELSE tok_err(+_ERRCLOSE); //no closing bracket
    }ELSE IF (tokmatch_ixiy()) { //ld (ix/iy[+-d]),rb  ld (ix/iy[+-d]),N
      IF (tokexpr_close()) { //       , ..   
        IF (tokmatch_comma()) {asm_directrb_token(+_FMTPUTIDXN, +_FMTPUTIDXRB);
        }ELSE tok_err(+_ERRCOMMA); //no comma
      }ELSE tok_err(+_ERREXPR); //wrong expr / no closing bracket
    }ELSE IF (tokmatch_rp()) { //ld (rp),a
      IF (tokmatch_close()) {
        IF (tokmatch_comma()) {
          IF (tokmatch_a()) {asmtoken(+_FMTPUTMRPA);
          }ELSE tok_err(+_ERRREG); //wrong register
        }ELSE tok_err(+_ERRCOMMA); //no comma
      }ELSE tok_err(+_ERRCLOSE); //no closing bracket
    }ELSE //if(tokmatch_direct()) { //ld (#NN),a  ld (#NN),rp
      IF (tokexpr_close()) { //       , ..   
        IF (tokmatch_comma()) { //  : 'a', <rp>/rp 
          IF (tokmatch_a()) {asmtoken(+_FMTPUTMNNA);
          }ELSE IF (tokmatch_rp()) {asmtoken(+_FMTPUTMNNRP);
          }ELSE tok_err(+_ERRREG); //wrong register
        }ELSE tok_err(+_ERRCOMMA); //no comma
      }ELSE tok_err(+_ERREXPR); //wrong expr
    //}else tok_err(+_ERRPAR); //wrong register (todo    expr)

  }ELSE { //  //  : 'I', 'R', <rb>, <rp>, rp  ( rpbyname), rb  ( rbyname)
    IF (tokmatch_rp()) {
      IF (tokmatch_comma()) { //  : NN, '('  NN
        IF (tokmatch_open()) {asm_direct_expr_close_token(+_FMTGETRPMNN); //ld rp,(#NN)
        }ELSE IF (tokmatch_rp()) {asmtoken(+_FMTMOVRPRP); //ld rp,rp
        }ELSE //if(tokmatch_direct()) { //ld rp,#NN
          IF (tokexpr()) {asmtoken(+_FMTLDRPNN);
          }ELSE tok_err(+_ERREXPR); //wrong expr
        //}else tok_err(+_ERRPAR); //wrong parameter
      }ELSE tok_err(+_ERRCOMMA); //no comma
    }ELSE IF (tokmatch_a()) {
      IF (tokmatch_comma()) { //  : 'I', 'R', N, '('  NN, '('  rp, '('  (ix/iy[+-d]), <rb>/rb 
        IF (tokmatch_open()) {asm_directhlixrp_close_token(+_FMTGETAMNN, +_FMTGETRBMHL, +_FMTGETRBIDX, +_FMTGETAMRP); //ld a,(#NN)  ld a,(hl)  ld a,(ix/iy[+-d])  ld a,(rp)
        }ELSE IF (tokmatch_ir()) {asmtoken(+_FMTMOVAIR); //ld a,i/r
        }ELSE asm_directrb_token(+_FMTLDRBN, +_FMTMOVRBRB); //ld a,#N  ld a,rb
      }ELSE tok_err(+_ERRCOMMA); //no comma
    }ELSE IF (tokmatch_rb()) {
      IF (tokmatch_comma()) { //  : N, '('  hl, '('  (ix/iy[+-d]), <rb>/rb 
        IF (tokmatch_open()) {asm_hlix_close_token(+_FMTGETRBMHL, +_FMTGETRBIDX); //ld rb,(hl)  ld rb,(ix/iy[+-d])
        }ELSE asm_directrb_token(+_FMTLDRBN, +_FMTMOVRBRB); //ld rb,#N  ld rb,rb
      }ELSE tok_err(+_ERRCOMMA); //no comma
    }ELSE IF (tokmatch_ir()) { //ld i/r,a
      IF (tokmatch_comma()) { //  : 'a'
        IF (tokmatch_a()) {asmtoken(+_FMTMOVIRA);
        }ELSE tok_err(+_ERRREG); //wrong register
      }ELSE tok_err(+_ERRCOMMA); //no comma
    }ELSE tok_err(+_ERRREG); //wrong register
  };
}

PROC tok_ret()
{
  asmtoken(+_ASMRET);
  asmrdword_tok_spc(); // ret
  IF ((_asmwaseols!=0)||(_asmwaseof)||(*(PCHAR)_tword==':')||(*(PCHAR)_tword==';')) { //ret
    asmtoken(+_FMTXX);
  }ELSE { //ret cc
    IF (tokmatch_cc()) {asmtoken(+_FMTXX);
    }ELSE tok_err(+_ERRCMD);
  };
}

PROC tok_djnz()
{
  asmtoken(+_ASMDJNZ);
  asmrdword_tok_spc(); // djnz
  IF (tokexpr()) {asmtoken(+_FMTJRDD);
  }ELSE tok_err(+_ERREXPR); //wrong expr
}

PROC tok_jr()
{
  asmtoken(+_ASMJR);
  asmrdword_tok_spc(); // jr
  IF (tokmatch_nzzncc()) { //jr cc,NN
    IF (tokmatch_comma()) {
      IF (tokexpr()) {asmtoken(+_FMTJRDD);
      }ELSE tok_err(+_ERREXPR); //wrong expr
    }ELSE tok_err(+_ERRCOMMA); //no comma
  }ELSE { //jr NN
    IF (tokexpr()) {asmtoken(+_FMTJRDD);
    }ELSE tok_err(+_ERREXPR); //wrong expr
  };
}

PROC tok_jp()
{
  asmtoken(+_ASMJP);
  asmrdword_tok_spc(); // jp
  IF (tokmatch_cc()) { //jp cc,NN
    IF (tokmatch_comma()) {
      IF (tokexpr()) {asmtoken(+_FMTJPNN);
      }ELSE tok_err(+_ERREXPR); //wrong expr
    }ELSE tok_err(+_ERRCOMMA); //no comma
  }ELSE { //jp NN
    IF (tokmatch_open()) { //
      IF (tokmatch_hlixiy()) { //jp (hl)/(ix)/(iy)
        IF (tokmatch_close()) {asmtoken(+_FMTJPRP);
        }ELSE tok_err(+_ERRCLOSE); //no closing bracket
      }ELSE IF (tokexpr_close()) {asmtoken(+_FMTJPNN);
      }ELSE tok_err(+_ERREXPR); //wrong expr
    }ELSE IF (tokexpr()) {asmtoken(+_FMTJPNN);
    }ELSE tok_err(+_ERREXPR); //wrong expr
  };
}

PROC tok_call()
{
  asmtoken(+_ASMCALL);
  asmrdword_tok_spc(); // call
  IF (tokmatch_cc()) { //call cc,NN
    IF (tokmatch_comma()) {
      IF (tokexpr()) {asmtoken(+_FMTJPNN);
      }ELSE tok_err(+_ERREXPR); //wrong expr
    }ELSE tok_err(+_ERRCOMMA); //no comma
  }ELSE { //call NN
    IF (tokexpr()) {asmtoken(+_FMTJPNN);
    }ELSE tok_err(+_ERREXPR); //wrong expr
  };
}

PROC tok_rst()
{
  asmtoken(+_ASMRST);
  asmrdword_tok_spc(); // rst
  IF (tokexpr()) {asmtoken(+_FMTRST);
  }ELSE tok_err(+_ERREXPR); //wrong expr
}

PROC tok_im()
{
  asmtoken(+_ASMIM);
  asmrdword_tok_spc(); // im
  IF (tokexpr()) {asmtoken(+_FMTIM);
  }ELSE tok_err(+_ERREXPR); //wrong expr
}

PROC tok_xx(BYTE token) //  
{
  asmtoken(token);
  asmrdword_tok_spc(); // 
  asmtoken(+_FMTXX);
}

PROC tok_alucmdN()
{
  tok_alucmd(_temppar);
}

PROC tok_xxN()
{
  tok_xx(_temppar);
}

PROC tok_cbxxN()
{
  tok_cbxx(_temppar);
}

PROC tok_bitN()
{
  tok_bit(_temppar);
}

PROC tokfilllblbuf()
{
  tokaddlbl("ld"  , "LD"  , (PBYTE)&tok_ld  , 0x00);
  tokaddlbl("call", "CALL", (PBYTE)&tok_call, 0x00);
  tokaddlbl("jp"  , "JP"  , (PBYTE)&tok_jp  , 0x00);
  tokaddlbl("ret" , "RET" , (PBYTE)&tok_ret , 0x00);
  tokaddlbl("jr"  , "JR"  , (PBYTE)&tok_jr  , 0x00);

  tokaddlbl("db"  , "DB"  , (PBYTE)&tok_db  , 0x00); /**db ...,  defb -      writeN,     - */
  tokaddlbl("dw"  , "DW"  , (PBYTE)&tok_dw  , 0x00); /**dw ...,  defw -      writeNN*/
  tokaddlbl("dl"  , "DL"  , (PBYTE)&tok_dl  , 0x00); /**dl ...,  defl -      writeNNNN*/
  tokaddlbl("ds"  , "DS"  , (PBYTE)&tok_ds  , 0x00); /**ds ...,  defs -   writeds*/


  tokaddlbl("pop" , "POP" , (PBYTE)&tok_pop , 0x00);
  tokaddlbl("push", "PUSH", (PBYTE)&tok_push, 0x00);

  tokaddlbl("add" , "ADD" , (PBYTE)&tok_add , 0x00);
  tokaddlbl("adc" , "ADC" , (PBYTE)&tok_adc , 0x00);
  tokaddlbl("sub" , "SUB" , (PBYTE)&tok_alucmdN, +_ASMSUB);
  tokaddlbl("sbc" , "SBC" , (PBYTE)&tok_sbc , 0x00);
  tokaddlbl("and" , "AND" , (PBYTE)&tok_alucmdN, +_ASMAND);
  tokaddlbl("xor" , "XOR" , (PBYTE)&tok_alucmdN, +_ASMXOR);
  tokaddlbl("or"  , "OR"  , (PBYTE)&tok_alucmdN, +_ASMOR);
  tokaddlbl("cp"  , "CP"  , (PBYTE)&tok_alucmdN, +_ASMCP);

  tokaddlbl("inc" , "INC" , (PBYTE)&tok_inc , 0x00);
  tokaddlbl("dec" , "DEC" , (PBYTE)&tok_dec , 0x00);

  tokaddlbl("ex"  , "EX"  , (PBYTE)&tok_ex  , 0x00);

  tokaddlbl("rlc" , "RLC" , (PBYTE)&tok_cbxxN, +_ASMRLC);
  tokaddlbl("rrc" , "RRC" , (PBYTE)&tok_cbxxN, +_ASMRRC);
  tokaddlbl("rl"  , "RL"  , (PBYTE)&tok_cbxxN, +_ASMRL);
  tokaddlbl("rr"  , "RR"  , (PBYTE)&tok_cbxxN, +_ASMRR);
  tokaddlbl("sla" , "SLA" , (PBYTE)&tok_cbxxN, +_ASMSLA);
  tokaddlbl("sra" , "SRA" , (PBYTE)&tok_cbxxN, +_ASMSRA);
  tokaddlbl("sli" , "SLI" , (PBYTE)&tok_cbxxN, +_ASMSLI);
  tokaddlbl("srl" , "SRL" , (PBYTE)&tok_cbxxN, +_ASMSRL);

  tokaddlbl("djnz", "DJNZ", (PBYTE)&tok_djnz, 0x00);

  tokaddlbl("rst" , "RST" , (PBYTE)&tok_rst , 0x00);

  tokaddlbl("out" , "OUT" , (PBYTE)&tok_out , 0x00);
  tokaddlbl("in"  , "IN"  , (PBYTE)&tok_in  , 0x00);

  tokaddlbl("bit" , "BIT" , (PBYTE)&tok_bitN, +_ASMBIT);
  tokaddlbl("res" , "RES" , (PBYTE)&tok_bitN, +_ASMRES);
  tokaddlbl("set" , "SET" , (PBYTE)&tok_bitN, +_ASMSET);

  tokaddlbl("im"  , "IM"  , (PBYTE)&tok_im  , 0x00);

  tokaddlbl("rlca", "RLCA", (PBYTE)&tok_xxN, +_ASMRLCA);
  tokaddlbl("rrca", "RRCA", (PBYTE)&tok_xxN, +_ASMRRCA);
  tokaddlbl("rla" , "RLA" , (PBYTE)&tok_xxN, +_ASMRLA);
  tokaddlbl("rra" , "RRA" , (PBYTE)&tok_xxN, +_ASMRRA);
  tokaddlbl("daa" , "DAA" , (PBYTE)&tok_xxN, +_ASMDAA);
  tokaddlbl("cpl" , "CPL" , (PBYTE)&tok_xxN, +_ASMCPL);
  tokaddlbl("scf" , "SCF" , (PBYTE)&tok_xxN, +_ASMSCF);
  tokaddlbl("ccf" , "CCF" , (PBYTE)&tok_xxN, +_ASMCCF);
  tokaddlbl("nop" , "NOP" , (PBYTE)&tok_xxN, +_ASMNOP);
  tokaddlbl("halt", "HALT", (PBYTE)&tok_xxN, +_ASMHALT);
  tokaddlbl("di"  , "DI"  , (PBYTE)&tok_xxN, +_ASMDI);
  tokaddlbl("ei"  , "EI"  , (PBYTE)&tok_xxN, +_ASMEI);
  tokaddlbl("exx" , "EXX" , (PBYTE)&tok_xxN, +_ASMEXX);

  tokaddlbl("retn", "RETN", (PBYTE)&tok_xxN, +_ASMRETN);
  tokaddlbl("reti", "RETI", (PBYTE)&tok_xxN, +_ASMRETI);
  tokaddlbl("ldi" , "LDI" , (PBYTE)&tok_xxN, +_ASMLDI);
  tokaddlbl("ldd" , "LDD" , (PBYTE)&tok_xxN, +_ASMLDD);
  tokaddlbl("ldir", "LDIR", (PBYTE)&tok_xxN, +_ASMLDIR);
  tokaddlbl("lddr", "LDDR", (PBYTE)&tok_xxN, +_ASMLDDR);
  tokaddlbl("cpi" , "CPI" , (PBYTE)&tok_xxN, +_ASMCPI);
  tokaddlbl("cpd" , "CPD" , (PBYTE)&tok_xxN, +_ASMCPD);
  tokaddlbl("cpir", "CPIR", (PBYTE)&tok_xxN, +_ASMCPIR);
  tokaddlbl("cpdr", "CPDR", (PBYTE)&tok_xxN, +_ASMCPDR);
  tokaddlbl("ini" , "INI" , (PBYTE)&tok_xxN, +_ASMINI);
  tokaddlbl("ind" , "IND" , (PBYTE)&tok_xxN, +_ASMIND);
  tokaddlbl("inir", "INIR", (PBYTE)&tok_xxN, +_ASMINIR);
  tokaddlbl("indr", "INDR", (PBYTE)&tok_xxN, +_ASMINDR);
  tokaddlbl("outi", "OUTI", (PBYTE)&tok_xxN, +_ASMOUTI);
  tokaddlbl("outd", "OUTD", (PBYTE)&tok_xxN, +_ASMOUTD);
  tokaddlbl("otir", "OTIR", (PBYTE)&tok_xxN, +_ASMOTIR);
  tokaddlbl("otdr", "OTDR", (PBYTE)&tok_xxN, +_ASMOTDR);
  tokaddlbl("inf" , "INF" , (PBYTE)&tok_xxN, +_ASMINF);
  tokaddlbl("neg" , "NEG" , (PBYTE)&tok_xxN, +_ASMNEG);

  tokaddlbl("org" , "ORG" , (PBYTE)&tok_org , 0x00); /**org nn -   writeorg,     - */
  tokaddlbl("align","ALIGN",(PBYTE)&tok_align,0x00); /**align nn -   writealign,     - */
  tokaddlbl("page", "PAGE", (PBYTE)&tok_page, 0x00); /**page n -   writepage,     - */
  tokaddlbl("if"  , "IF"  , (PBYTE)&tok_if  , 0x00); /**if nn -   writeif,     - */
  tokaddlbl("else", "ELSE", (PBYTE)&tok_else, 0x00); /**else*/
  tokaddlbl("endif","ENDIF",(PBYTE)&tok_endif,0x00); /**endif*/
  tokaddlbl("dup" , "DUP" , (PBYTE)&tok_dup , 0x00); /**dup nn -   writedup,     - */
  tokaddlbl("edup", "EDUP", (PBYTE)&tok_edup, 0x00); /**edup*/
  tokaddlbl("macro","MACRO",(PBYTE)&tok_macro,0x00); /**macro name -  ?*/
  tokaddlbl("endm", "ENDM", (PBYTE)&tok_endm, 0x00); /**endm*/
  //tokaddlbl("usemacro","USEMACRO",(PBYTE)&tok_usemacro, 0x00); /**usemacro name ... -  ?*/
  tokaddlbl("export","EXPORT",(PBYTE)&tok_export, 0x00); /**export name -  ?*/
  tokaddlbl("local","LOCAL",(PBYTE)&tok_local,0x00); /**local name -  ?*/
  tokaddlbl("endl", "ENDL", (PBYTE)&tok_endl, 0x00); /**endl*/
  tokaddlbl("disp", "DISP", (PBYTE)&tok_disp, 0x00); /**disp nn -   writedisp*/
  tokaddlbl("ent" , "ENT" , (PBYTE)&tok_ent , 0x00); /**ent*/
  tokaddlbl("include","INCLUDE",(PBYTE)&tok_include, 0x00); /**include "filename" -  ?*/
  tokaddlbl("incbin","INCBIN",(PBYTE)&tok_incbin, 0x00); /**incbin "filename" -  ?*/
  tokaddlbl("display","DISPLAY",(PBYTE)&tok_display, 0x00); /**display nn -  displaynum, displaystring -     - */
  tokaddlbl("repeat","REPEAT",(PBYTE)&tok_repeat, 0x00); /**repeat*/
  tokaddlbl("until","UNTIL",(PBYTE)&tok_until, 0x00); /**until nn -   writeuntil*/
  tokaddlbl("struct","STRUCT",(PBYTE)&tok_struct, 0x00); /**struct name -  ?*/
  tokaddlbl("endstruct","ENDSTRUCT",(PBYTE)&tok_endstruct, 0x00); /**endstruct*/

  tokaddlbl(":",":",(PBYTE)&tok_colon, 0x00);
//  tokaddlbl(";",";",(PBYTE)&tok_comment, 0x00);
}

