//    :
//-   ( text)  ,   
//-    
//-   -  , ..  -  ,         (  ?)
//,        -  
//(      ,     ?)
//       (    )
//-        2   (     2  ,      ),
//         -
//-       (    disp?)
//-        b/c/d/e/h/l/a/hx/lx/hy/ly .     ld lx,h, ld lx,ly, ld lx,(hl), ld lx,(ix+).
//     ,     (     ld hx,lx).
//- bc/de/hl/sp/ix/iy (    )  ,  ld a,(bc/de/hl/ix/iy) (   ), ld (bc/de/hl/ix/iy),a (   ).
//  rp  af ( push af -   ,  push rp,  af== sp).
//   ,  rp ,         .
//ix      : add ix,ix,  add ix,iy    (   !),
//      ix    .
//-    ( +  + ...)
//-    
//(     ?     ,     () )
//(       (   ))
//  comma   reg->oldreg->veryoldreg
//-         (   )

// , ,      ,      (   )

// :
//<label><text><endtext>
//<inc><HL><asmfmt_incrp>
//<comment><text><endtext>
//<eol>

//ASMCMD...TOK...FMT   
//TOK_ERR,TOK_TEXT    (  CMD_ERR,   CMD...FMT?)
//ASMCMD...TOK_ERR,TOK_TEXT...FMT_ERR    (   CMD...FMT   )

CONST BYTE _ASMMAXSPC = 0x08;

//#define TOKBASE 0x40
//#define ASMCCBASE    0x01 /*max 0x07*/
//#define TOKBASE 0x10 /*max 0x0b*/
//#define ASMOPBASE    0x1c /*max 0x02*/
//#define ASMREGBASE   0x66 /*max 0x15*/ /*  []^*/
//#define DIRBASE   0x60 /*max 0x1c*/ /*  |~*/
//#define OPBASE 0x7f /*max 0x10*/
//#define ASMCMDBASE   0x90 /*max 0x41*/
//#define FMTBASE   0xd2 /*max 0x2a*/

#ifdef TARGET_THUMB
#include "../_sdk/fmtarm.h"
#else
#include "../_sdk/fmtz80.h"
#endif

/** <TOK_ERR><TOK_ERR...>,    <text>text<endtext><space><text>text<endtext>... <enderr> -        */
CONST BYTE _ERRCMD = 0x31;
//#define _ERRCMD   '1' /*(TOKBASE+0x02)*/
CONST BYTE _ERREXPR = 0x32;
//#define _ERREXPR  '2' /*(TOKBASE+0x03)*/
CONST BYTE _ERRCOMMA = 0x33;
//#define _ERRCOMMA '3' /*(TOKBASE+0x04)*/
CONST BYTE _ERRPAR = 0x34;
//#define _ERRPAR   '4' /*(TOKBASE+0x05)*/
CONST BYTE _ERROPEN = 0x35;
//#define _ERROPEN  '5' /*(TOKBASE+0x06)*/
CONST BYTE _ERRCLOSE = 0x36;
//#define _ERRCLOSE '6' /*(TOKBASE+0x07)*/
CONST BYTE _ERRREG = 0x37;
//#define _ERRREG   '7' /*(TOKBASE+0x08)*/

