;startup
	org 0x6000
	ld hl,0
	ld (23672),hl
	ld hl,start.
	ld (23834),hl ; 
	ld hl,467 ; (     RUN "..." CODE )
	push hl
	jp 0x3d2f ;call in DOS
start.
	LD HL,fnerr.
	LD [openwrite.A.],HL
	CALL openwrite
	LD [_ferr],HL
	LD A,TRUE
	LD [_errs],A

	ld hl,fnbuf.
	ld (asmcompile.fn),hl
	ld hl,(23645) ;CH_ADD
	ld bc,256
	ld a,234 ;REM
	cpir
loop.
	dec hl
	ld de,fnbuf.-1
l0.
	inc hl
	inc de
	ld a,(hl)
	ld (de),a
	cp ' '+1
	jr nc,l0. ;read until space or CR
	xor a
	ld (de),a ;'\0'

	push hl
	call asmcompile
	pop hl

	ld a,(hl)
	cp 0x0d ;CR
	inc hl
	jr nz,loop.

	LD HL,[_ferr]
	LD [closewrite.A.],HL
	CALL closewrite

	ld hl,10072
	exx
	ld hl,(23672)
	add hl,hl
	ld b,h
	ld c,l
	ret

	include "emit.asm"
	include "asm.asm"
	include "asmtg.asm"
	include "lib.i"
	include "str.i"
	include "io.i"

fnbuf.
	db "12345678.123"
	db 0
fnerr.
	db "asmerr.f"
	db 0

	include "fmttg.var"
	include "emit.var"
	include "asm.var"
	include "asmtg.var"
