//// imported
#include "io.h"
#include "str.h" //stradd, strjoineol
#include "emit.h"

EXTERN BYTE _token; //  
EXTERN BYTE _prefixedtoken; //    \n  ..
EXTERN BYTE _curdir; //     (    )
EXTERN BOOL _labelchanged; // " " -     LABEL (   REEQU)
EXTERN LONG _value[_MAXVALS];
EXTERN PBYTE _inclfile[_MAXINCLUDES];

EXTERN UINT _curlnbeg; //     

EXTERN BYTE _reg; // 
EXTERN BYTE _oldreg; // 
EXTERN BYTE _base; //  
EXTERN BYTE _base2; //2   (  )

EXTERN BYTE _nvalues; //   
EXTERN BYTE _ninclfiles; //  

EXTERN UINT _curaddr; //,  
EXTERN UINT _curshift; //$=(_curaddr+curshift), curshift=(disp-_curaddr)
EXTERN UINT _curbegin; //  ,  
//EXTERN BYTE _curpage0;
//EXTERN BYTE _curpage1;
//EXTERN BYTE _curpage2;
//EXTERN BYTE _curpage3;

EXTERN PBYTE _pstr; //    TOK_ENDTEXT
EXTERN PBYTE _curlabeltext;
EXTERN PBYTE _evallabeltext;
EXTERN PCHAR _fn;
EXTERN UINT _lenfn;

PROC asmpushvalue FORWARD(LONG value);
PROC asmpushbool FORWARD(BOOL b);
FUNC LONG asmpopvalue FORWARD();
//PROC asmwritestate FORWARD();
//PROC asmreadstate FORWARD();
PROC readlabel FORWARD();
PROC findlabel FORWARD(PBYTE labeltext);
FUNC LONG getlabel FORWARD(); //   findlabel!!!
PROC errwrongreg FORWARD();
PROC errwrongpar FORWARD();
PROC asmerrtext FORWARD();
PROC asmbyte FORWARD(BYTE _token);
PROC asmemitblock FORWARD(); //   org
PROC asmdir_label FORWARD();
PROC asmfmt_reequ FORWARD();

PROC asmreadprefixed FORWARD();

EXTERN PBYTE _fincb;
EXTERN BOOL _asms;

PROC decltoken FORWARD(BYTE c);
PROC decldig FORWARD(UINT d);

EXTERN PBYTE _forg;
EXTERN PBYTE _fdecl;

EXTERN BYTE _isaddr; // "   "

////
//   0x3f  ix/iy  hl
CONST BYTE _ASMRBIXADD = 0x40;
CONST BYTE _ASMRBCODE_B = 0x00;
CONST BYTE _ASMRBCODE_C = 0x08;
CONST BYTE _ASMRBCODE_D = 0x10;
CONST BYTE _ASMRBCODE_E = 0x18;
CONST BYTE _ASMRBCODE_H = 0x20;
CONST BYTE _ASMRBCODE_L = 0x28;
CONST BYTE _ASMRBCODE_A = 0x38;
CONST BYTE _ASMRBCODE_HX = 0x60;
CONST BYTE _ASMRBCODE_LX = 0x68;
CONST BYTE _ASMRBCODE_HY = 0xa0;
CONST BYTE _ASMRBCODE_LY = 0xa8;
CONST BYTE _ASMRBCODE_I = 0x00;
CONST BYTE _ASMRBCODE_R = 0x08;

CONST BYTE _ASMRPIXADD = 0x40;
CONST BYTE _ASMRPCODE_BC = 0x00;
CONST BYTE _ASMRPCODE_DE = 0x10;
CONST BYTE _ASMRPCODE_HL = 0x20;
CONST BYTE _ASMRPCODE_SP = 0x30;
CONST BYTE _ASMRPCODE_AF = 0x30;
CONST BYTE _ASMRPCODE_IX = 0x60;
CONST BYTE _ASMRPCODE_IY = 0xa0;

//CONST UINT _BASEADDR = 0x6000;
//VAR UINT _baseaddr;

PROC asmbytepopvalue()
{
  DEC _nvalues;
  IF (_asms) {
    ;;writefout((BYTE)_value[_nvalues]/**+(BYTE)asmpopvalue()*/); //compatible version
    /*writefout(*(PBYTE)&_value[_nvalues]);*/ //fast version (little endian)
  };
  INC _curaddr;
}

PROC asmwordpopvalue() //  UINT/DW
{
VAR UINT uinttempvalue;
  DEC _nvalues;
  //asmbyte(+(BYTE)uinttempvalue);
  //asmbyte(+(BYTE)(uinttempvalue>>8));
  IF (_asms) {
    //     _isaddr!
    IF (_isaddr!=0x00) {
      uinttempvalue = _curaddr+_curshift-_curbegin; //_curaddr+_curshift-_BASEADDR;
      fwrite((PBYTE)&uinttempvalue, 2, 1, _forg);
    }; //
    ;;uinttempvalue = +(UINT)_value[_nvalues]; //+(UINT)asmpopvalue();
    ;;fwrite(&uinttempvalue, 2, 1, _fout); //compatible version ( _SIZEOF_UINT, ..     !)
    /*fwrite((PBYTE)&_value[_nvalues], 2, 1, _fout);*/ //fast version (little endian) ( _SIZEOF_UINT, ..     !)
  };
  _curaddr = _curaddr + 2; // _SIZEOF_UINT, ..     !
}

PROC asmlong(LONG value) //  LONG/DL
{
  ;;asmbyte(+(BYTE)value); //compatible version
  ;;asmbyte(+(BYTE)(+(UINT)value>>8)); //compatible version
  ;;asmbyte(+(BYTE)(value>>16L)); //compatible version
  ;;asmbyte(+(BYTE)(value>>24L)); //compatible version
  /*fwrite(+(PBYTE)&value, 4, 1, _fout);*/ //fast version (little endian) ( _SIZEOF_LONG, ..     !)
  /*_curaddr = _curaddr + 4;*/ //fast version (little endian) ( _SIZEOF_LONG, ..     !)
}

PROC asmorgword(LONG addr) //  POINTER
{
//todo ORG
//  IF (_asms) {
//    ;;writebyte(_forg, +(BYTE)addr); //compatible version
//    ;;writebyte(_forg, +(BYTE)(+(UINT)addr>>8)); //compatible version
//    /*fwrite(+(PBYTE)&addr, 2, 1, _forg);*/ //fast version (little endian) ( _SIZEOF_UINT, ..     !)
//  };
}

PROC asmdisp(INT ivalue) // $+d  ix+d
{
  IF (+(UINT)(ivalue + +(INT)0x0080) >= 0x0100) {
    errstr("+d too long"); enderr();
  };
  asmbyte(+(BYTE)ivalue); // ,   !
}

PROC asmdisppopvalue() // jr  ix+d
{
  asmdisp(+(INT)asmpopvalue());
}

PROC asmrb_ixiyprefix() //  dd/fd   _reg  h/l
{
//  IF       (_reg==+_ASMRBCODE_HX) {asmbyte(0xdd); //_reg = +_ASMRBCODE_H;
//  }ELSE IF (_reg==+_ASMRBCODE_LX) {asmbyte(0xdd); //_reg = +_ASMRBCODE_L;
//  }ELSE IF (_reg==+_ASMRBCODE_HY) {asmbyte(0xfd); //_reg = +_ASMRBCODE_H;
//  }ELSE /**IF (_reg==+_ASMRBCODE_LY)*/{asmbyte(0xfd); //_reg = +_ASMRBCODE_L;
//  };
  IF (_reg < +_ASMRBCODE_HY) {asmbyte(0xdd);
  }ELSE asmbyte(0xfd);
  _reg = _reg&0x3f;
}

PROC asmoldrb_ixiyprefix() //  dd/fd   _reg  h/l
{
//  IF       (_oldreg==+_ASMRBCODE_HX) {asmbyte(0xdd); //_oldreg = +_ASMRBCODE_H;
//  }ELSE IF (_oldreg==+_ASMRBCODE_LX) {asmbyte(0xdd); //_oldreg = +_ASMRBCODE_L;
//  }ELSE IF (_oldreg==+_ASMRBCODE_HY) {asmbyte(0xfd); //_oldreg = +_ASMRBCODE_H;
//  }ELSE /**IF (_oldreg==+_ASMRBCODE_LY)*/{asmbyte(0xfd); //_oldreg = +_ASMRBCODE_L;
//  };
  IF (_oldreg < +_ASMRBCODE_HY) {asmbyte(0xdd);
  }ELSE asmbyte(0xfd);
  _oldreg = _oldreg&0x3f;
}

PROC asmrbrb_ixiyprefix() //  dd/fd   _oldreg,_reg  h/l
//   ?x,?y / ?y,?x / ?x/y,h/l / h/l,?x/y
{
VAR BYTE prefix1;
  prefix1 = 0x00; //needed
  IF (_oldreg >= +_ASMRBCODE_HY) {
    prefix1=0xfd;
    goto test1;
  }ELSE IF (_oldreg >= +_ASMRBCODE_HX) {
    prefix1=0xdd;
    test1:
    IF (_reg==+_ASMRBCODE_H) errwrongreg(); //?x/y, h
    IF (_reg==+_ASMRBCODE_L) errwrongreg(); //?x/y, l
    asmbyte(prefix1);
  };
  IF (_reg >= +_ASMRBCODE_HY) {
    IF (prefix1!=0xfd) {
      asmbyte(0xfd);
      IF (prefix1==0xdd) errwrongreg();
    };
    goto test2;
  }ELSE IF (_reg >= +_ASMRBCODE_HX) {
    IF (prefix1!=0xdd) {
      asmbyte(0xdd);
      IF (prefix1==0xfd) errwrongreg();
    };
    test2:
    IF (_oldreg==+_ASMRBCODE_H) errwrongreg(); //h, ?x/y
    IF (_oldreg==+_ASMRBCODE_L) errwrongreg(); //l, ?x/y
    _reg = _reg&0x3f;
  };
  _oldreg = _oldreg&0x3f;
}

PROC asmrp_ixiyprefix() //  dd/fd   _reg  hl
{
  IF (_reg==+_ASMRPCODE_IX) {asmbyte(0xdd); //_reg = +_ASMRPCODE_HL;
  }ELSE /*IF (_reg==+_ASMRPCODE_IY)*/{asmbyte(0xfd); //_reg = +_ASMRPCODE_HL;
  };
  _reg = +_ASMRPCODE_HL;
}

PROC asmoldrp_ixiyprefix() //  dd/fd   _reg  hl
{
  IF (_oldreg==+_ASMRPCODE_IX) {asmbyte(0xdd); //_oldreg = +_ASMRPCODE_HL;
  }ELSE /*IF (_oldreg==+_ASMRPCODE_IY)*/{asmbyte(0xfd); //_oldreg = +_ASMRPCODE_HL;
  };
  _oldreg = +_ASMRPCODE_HL;
}

PROC asmrprp_ixiyprefix() //  dd/fd   _oldreg,_reg  hl
//   ix,iy / iy,ix / ix/iy,hl / hl,ix/iy
{
VAR BYTE prefix1;
  prefix1=0x00; //needed
  IF (_oldreg==+_ASMRPCODE_IX) {
    prefix1=0xdd;
    goto test1;
  }ELSE IF (_oldreg==+_ASMRPCODE_IY) {
    prefix1=0xfd;
    test1:
    IF (_reg==+_ASMRPCODE_HL) errwrongreg(); //ix/iy, hl
    asmbyte(prefix1);
  };//ELSE prefix1=0x00;
  IF (_reg==+_ASMRPCODE_IX) {
    IF (prefix1!=0xdd) {
      asmbyte(0xdd);
      IF (prefix1==0xfd) errwrongreg();
    };
    goto test2;
  }ELSE IF (_reg==+_ASMRPCODE_IY) {
    IF (prefix1!=0xfd) {
      asmbyte(0xfd);
      IF (prefix1==0xdd) errwrongreg();
    };
    test2:
    IF (_oldreg==+_ASMRPCODE_HL) errwrongreg(); //hl, ix/iy
    _reg = +_ASMRPCODE_HL;
  };//ELSE prefix2=0x00;
  _oldreg = _oldreg&0x3f;
}

PROC asmbyte_ed()
{
  asmbyte(0xed);
}

PROC err_rbix()
{
  IF (_reg>=_ASMRBIXADD) errwrongreg();
}

PROC err_oldrbix()
{
  IF (_oldreg>=_ASMRBIXADD) errwrongreg();
}

PROC err_rpix()
{
  IF (_reg>=_ASMRPIXADD) errwrongreg();
}

PROC asmcheckrb_ixiyprefix()
{
  IF (_reg>=_ASMRBIXADD) asmrb_ixiyprefix();
}

PROC asmcheckrp_ixiyprefix()
{
  IF (_reg>=_ASMRPIXADD) asmrp_ixiyprefix();
}

PROC asmcheckoldrp_ixiyprefix()
{
  IF (_oldreg>=_ASMRPIXADD) asmoldrp_ixiyprefix();
}

PROC asmloop()
{
VAR UINT scale; //  
VAR LONG tempvalue; //,   popvalue     pushvalue
VAR UINT i;
  loop:
    _token = readfin();
    switch (_token) {

      case _CMDINCLUDE: {
        _inclfile[_ninclfiles] = _fin;
        INC _ninclfiles;
        _lenfn = 0;
        readfin(); //tab
        readfin(); //"
        //readfin(); //TOK_WRSTR
        _token = readfin(); //TOK_TEXT
        inclfnloop:
          asmreadprefixed(); //  readfin,  \n \r \t \0
          IF ((_token==+_TOKENDTEXT)||_waseof) goto inclfnq; //BREAK;
          //IF (_waseof) BREAK; //  
          _lenfn = stradd(_fn, _lenfn, (CHAR)_token); //asmbyte(_prefixedtoken);
          goto inclfnloop;
        inclfnq:
   _lenfn = strjoineol(_fn, 0, _fn, '.'); //terminator is not copied
   _lenfn = stradd(_fn, _lenfn, '.');
   _lenfn = stradd(_fn, _lenfn, (CHAR)((BYTE)_fn[_lenfn]&0xdf));
   _lenfn = stradd(_fn, _lenfn, '_');
        _fn[_lenfn] = '\0';
        readfin(); //"
        _fin = fopen(_fn, "rb"); //todo       fclose
        goto loop;
///    
      inclq:
        fclose(_fin);
        DEC _ninclfiles;
        _fin = _inclfile[_ninclfiles];
        _waseof = +FALSE;
        goto loop;
      }

      case _CMDINCBIN: {
        _lenfn = 0;
        readfin(); //tab
        readfin(); //"
        //readfin(); //TOK_WRSTR
        _token = readfin(); //TOK_TEXT
        incbfnloop:
          asmreadprefixed(); //  readfin,  \n \r \t \0
          IF ((_token==+_TOKENDTEXT)||_waseof) goto incbfnq; //BREAK;
          //IF (_waseof) BREAK; //  
          _lenfn = stradd(_fn, _lenfn, (CHAR)_token); //asmbyte(_prefixedtoken);
          goto incbfnloop;
        incbfnq:
        _fn[_lenfn] = '\0';
        readfin(); //"
        _fincb = fopen(_fn, "rb");
        incbloop:
          _token = readf(_fincb);
          IF (_waseof) goto incbq; //BREAK;
          asmbyte(_token);
          goto incbloop;
        incbq:
        fclose(_fincb);
        _waseof = +FALSE;
        goto loop;
      }

      //case _CMDREADSTATE: {asmreadstate(); goto loop;}
      case _CMDLABEL: {
        _isaddr = 0x00;
        _curdir = _token;
        asmdir_label(); //  !   label=label+1
        goto loop;
      }

      case _CMDEXPORT: /**{
        _lenfn = 0;
        readfin(); //tab
        readfin(); //TOK_LABEL
        _token = readfin(); //TOK_TEXT
        getexploop:
          asmreadprefixed(); //  readfin,  \n \r \t \0
          IF ((_token==+_TOKENDTEXT)||_waseof) goto getexpq; //BREAK;
          //IF (_waseof) BREAK; //  
          _lenfn = stradd(_fn, _lenfn, (CHAR)_token); //asmbyte(_prefixedtoken);
          goto getexploop;
        getexpq:
        _fn[_lenfn] = '\0';
        goto loop;
      }*/

      case _CMDORG:
      case _CMDDISP:
      case _CMDDB:
      case _CMDDW:
      case _CMDDL:
      case _CMDDS:

        {_isaddr = 0x00; _curdir=_token; goto loop;}

      case _FMTREEQU: {
        asmfmt_reequ();
        goto loop;
      }
      case _FMTCMD: {
        IF (_curdir == +_CMDLABEL) {
          IF (_labelchanged) {
            errstr("redef "); errstr((PCHAR)_curlabeltext); enderr();
          };
        }ELSE IF (_curdir == +_CMDORG) {
          asmemitblock();
          _curaddr = +(UINT)asmpopvalue();
          _curbegin = _curaddr;
        }ELSE IF (_curdir == +_CMDDISP) {
          _curshift = +(UINT)asmpopvalue() - _curaddr; //todo 
        }ELSE IF (_curdir == +_CMDENT) {
          _curshift = 0; //todo 
        }ELSE IF (_curdir == +_CMDDB) {
        }ELSE IF (_curdir == +_CMDDW) {
        }ELSE IF (_curdir == +_CMDDL) {
        }ELSE IF (_curdir == +_CMDDS) {
          IF (_nvalues>0x01) {_token = +(BYTE)asmpopvalue();
          }ELSE _token=0x00;
          i = +(UINT)asmpopvalue();
          WHILE (i != 0) {
            asmbyte(_token);
            DEC i;
          };
          //fwrite(+(PBYTE)&zeros, 1, i, _fout);
          //_curaddr = _curaddr + i;
          //todo while  ds  ,      
        }ELSE IF (_curdir == +_CMDEXPORT) {
          i = +(UINT)asmpopvalue();
          IF (_asms) { // <_curlabeltext>=<?modname?>+<i-?base?>
            decltoken(+_CMDLABEL);
            decltoken(+_TOKTEXT);
            fputs((PCHAR)_curlabeltext, _fdecl);
            decltoken(+_TOKENDTEXT);
            decltoken(+_TOKEQUAL/**'='*/);
            decltoken(+_TOKLABEL);
            decltoken(+_TOKTEXT);
            decltoken((BYTE)'_'); //todo <modname>?
            decltoken(+_TOKENDTEXT);
            decltoken(+_TOKPLUS/**'+'*/);
            decltoken(+_TOKNUM);
            decltoken(+_TOKTEXT);
            emitn(i-_curbegin/**_BASEADDR*/);
            fputs((PCHAR)_nbuf, _fdecl); //+_TOKENDTEXT==0
            decltoken(+_TOKENDTEXT);
            decltoken(+_OPADD);
            decltoken(+_FMTREEQU);
            decltoken(+_TOKEOL);
          }; //
        ;;}ELSE {err(+(CHAR)_token); enderr();
        };
        goto loop;
      }

      case _OPPUSH0: {asmpushvalue(0L); /**readfin();*/ goto loop;}

      case _OPADD:   {                           asmpushvalue(asmpopvalue()+asmpopvalue()); goto loop;}
      case _OPSUB:   {tempvalue=asmpopvalue();   asmpushvalue(asmpopvalue()-tempvalue); goto loop;}
      case _OPMUL:   {                           asmpushvalue(asmpopvalue()*asmpopvalue()); _isaddr = 0x00; goto loop;}
      case _OPDIV:   {
        tempvalue=asmpopvalue();
        {
        ;;IF (tempvalue!=0L)
          asmpushvalue(asmpopvalue()/tempvalue);
        }
        goto loop;
      }
      case _OPAND:   {                           asmpushvalue(asmpopvalue()&asmpopvalue()); goto loop;}
      case _OPOR:    {                           asmpushvalue(asmpopvalue()|asmpopvalue()); goto loop;}
      case _OPXOR:   {                           asmpushvalue(asmpopvalue()^asmpopvalue()); goto loop;}
      case _OPSHL:   {tempvalue=asmpopvalue();   asmpushvalue(asmpopvalue()<<tempvalue); goto loop;}
      case _OPSHR:   {tempvalue=asmpopvalue();   asmpushvalue(asmpopvalue()>>tempvalue); goto loop;}
      //case _OPEQ:    {                           asmpushbool((asmpopvalue()==asmpopvalue())); goto loop;} //   .   TRUE (-1  1 )
      //case _OPNOTEQ: {                           asmpushbool((asmpopvalue()!=asmpopvalue())); goto loop;}
      //case _OPLESS:  {tempvalue=asmpopvalue();   asmpushbool(+(UINT)asmpopvalue() <  +(UINT)tempvalue); goto loop;}
      //case _OPLESSEQ:{tempvalue=asmpopvalue();   asmpushbool(+(UINT)asmpopvalue() <= +(UINT)tempvalue); goto loop;}
      //case _OPMORE:  {tempvalue=asmpopvalue();   asmpushbool(+(UINT)asmpopvalue() >  +(UINT)tempvalue); goto loop;}
      //case _OPMOREEQ:{tempvalue=asmpopvalue();   asmpushbool(+(UINT)asmpopvalue() >= +(UINT)tempvalue); goto loop;}
      case _OPINV:   {                           asmpushvalue(~asmpopvalue()); goto loop;} //==invbool
      //case _OPPEEK:{/**asmpopvalue();*/ errstr("PEEK not supported"); enderr(); goto loop;}

      case _TOKEOL: {INC _curlnbeg; goto loop;}
      case _TOKEOF: {IF (_ninclfiles==0x00) {goto endloop;/**exit!!!*/}ELSE goto inclq;} //todo break

      case _TOKPLUS/**'+'*/:
      case _TOKMINUS/**'-'*/:
      case _TOKSTAR/**'*'*/:
      case _TOKSLASH/**'/'*/:
      case _TOKLESS/**'<'*/:
      case _TOKMORE/**'>'*/:
      case _TOKEQUAL/**'='*/:
      case _TOKAND/**'&'*/:
      case _TOKPIPE/**'|'*/:
      case _TOKCARON/**'^'*/:
      case _TOKTILDE/**'~'*/:
      case _TOKEXCL/**'!'*/:
      case _TOKPRIMESYM:
      case _TOKDBLQUOTESYM:
      case _TOKOPEN:
      case _TOKOPENSQ:
      case _TOKCLOSE:
      case _TOKCLOSESQ:
      case _TOKCOLON:
      case _TOKDIRECT:
      case _TOKSPC0:
      case _TOKSPC1:
      case _TOKSPC2:
      case _TOKSPC3:
      case _TOKSPC4:
      case _TOKSPC5:
      case _TOKSPC6:
      case _TOKSPC7:
      case _TOKSPC8:

        {goto loop;}

      case _TOKCOMMA: {_oldreg = _reg;/**  value!     value!*/ goto loop;}
      case _TOKPRIME: {
        readfin(); //text
        asmreadprefixed(); //  readfin,  \n \r \t \0
        asmpushvalue(+(LONG)_prefixedtoken);
        readfin(); //endtext
        readfin(); // 
        goto loop;
      }
      case _TOKDOLLAR: {asmpushvalue(+(LONG)(_curaddr+_curshift)); _isaddr = +_ASMLABEL_ISADDR; goto loop;}

      case _TOKCOMMENT: { /**skip cmt text*/
        REPEAT {
          _token=readfin();
        }UNTIL ((_token==+_TOKENDCOMMENT)||_waseof); /**,     */
        goto loop;
      }
      case _TOKNUM: {
        readfin(); //TOK_TEXT
        _token = readfin(); //first digit or prefix (0x, 0b, 0)
        tempvalue = 0L;
        scale = 10;
        IF (+(CHAR)_token=='0'){
          _token=readfin(); //'x' (hex), 'b' (bin), 'o' (oct), else oct with error
          IF       (+(CHAR)_token=='x') {
            scale=16;
            rdbase:
            IF (_token!=+_TOKENDTEXT) _token=readfin(); //first digit
          }ELSE IF (+(CHAR)_token=='b') {
            scale=2;
            goto rdbase; //IF (_token!=+_TOKENDTEXT) _token=readfin(); //first digit
          }ELSE IF (+(CHAR)_token=='o') {
            scale=8;
            goto rdbase; //IF (_token!=+_TOKENDTEXT) _token=readfin(); //first digit
          }ELSE IF (+(CHAR)_token=='L') { //0L
          }ELSE IF (_token!=+_TOKENDTEXT) {
            scale=8;
            errstr("Use 0o oct"); enderr();
          };
        };
        IF (_token!=+_TOKENDTEXT) {
          rdnumloop: //WHILE (+TRUE)
          { //    
            IF ((_token==+_TOKENDTEXT)||_waseof) goto rdnumend; //BREAK;
            //IF (_waseof) goto rdnumend; //BREAK; //  
            IF (+(CHAR)_token!='L') {
              IF (_token>=+(BYTE)'a') {_token = _token - 0x27/**- +(BYTE)'a' + 0x0a + +(BYTE)'0'*/; //todo error
              }ELSE IF (_token>=+(BYTE)'A') {_token = _token - 0x07/**- +(BYTE)'A' + 0x0a + +(BYTE)'0'*/; //todo error
              };//ELSE _token = _token - +(BYTE)'0';
              tempvalue = +(LONG)scale*tempvalue + +(LONG)(_token - +(BYTE)'0');
            };
            _token = readfin();
            goto rdnumloop;
          };
          rdnumend:;
        };
        asmpushvalue(tempvalue);
        goto loop;
      }
      case _TOKLABEL: { //   
        readlabel();
        findlabel(_curlabeltext);
        asmpushvalue(getlabel());
        goto loop;
      }
      case _ERR: {
        _token=readfin();
        IF       (_token==+_ERRCMD) {errstr("badcmd \""); goto err;
        }ELSE IF (_token==+_ERREXPR) {errstr("badexpr \""); goto err;
        }ELSE IF (_token==+_ERRCOMMA) {errstr("\',\' needed \""); goto err;
        }ELSE IF (_token==+_ERRPAR) {errstr("badpar \""); goto err;
        }ELSE IF (_token==+_ERROPEN) {errstr("\'(\' or \'[\' needed \""); goto err;
        }ELSE IF (_token==+_ERRCLOSE) {errstr("\')\' or \']\' needed \""); goto err;
        }ELSE IF (_token==+_ERRREG) {errstr("badreg \"");
          err:
          asmerrtext(); goto loop;
        };
      }

      case _OPWRSTR: { //  quotesymbol
        //   text...endtext
        _token = readfin(); //TOK_TEXT
        writestringloop:
          asmreadprefixed(); //  readfin,  \n \r \t \0
          IF ((_token==+_TOKENDTEXT)||_waseof) goto loop; //BREAK;
          //IF (_waseof) BREAK; //  
          asmbyte(_prefixedtoken);
          goto writestringloop;
      }
      case _OPWRVAL: { //  
        IF       (_curdir==+_CMDDB) {asmbytepopvalue();
        }ELSE IF (_curdir==+_CMDDW) {asmwordpopvalue();
        }ELSE IF (_curdir==+_CMDDL) {asmlong(+(LONG)asmpopvalue());
        };
        goto loop;
      }
///////////////////////    
      case _ASMNZ: {_base=_base2/**+0x00*/; goto loop;}
      case _ASMZ:  {_base=_base2+0x08; goto loop;}
      case _ASMNC: {_base=_base2+0x10; goto loop;}
      case _ASMC:  {_base=_base2+0x18; goto loop;}
      case _ASMPO: {_base=_base2+0x20; goto loop;}
      case _ASMPE: {_base=_base2+0x28; goto loop;}
      case _ASMP:  {_base=_base2+0x30; goto loop;}
      case _ASMM:  {_base=_base2+0x38; goto loop;}

      case _ASMEX:
      case _ASMLD:
      case _ASMRST:
      case _ASMIM:

        {_isaddr = 0x00; goto loop;}

      case _ASMRET: {_base=0xc9; _base2=0xc0;/**cc  1  2+8*cc*/ goto loop;}
      case _ASMDJNZ:{_base=0x10; goto loop;}
      case _ASMJR:  {_base=0x18; _base2=0x20;/**cc  1  2+8*cc*/ goto loop;}
      case _ASMJP:  {_isaddr = 0x00; _base=0xc3; _base2=0xc2;/**cc  1  2+8*cc*/ goto loop;}
      case _ASMCALL:{_isaddr = 0x00; _base=0xcd; _base2=0xc4;/**cc  1  2+8*cc*/ goto loop;}

      case _ASMADD: {_base=0x80;/**+0x46  N*/ goto loop;}
      case _ASMADC: {_base=0x88;/**+0x46  N*/ goto loop;}
      case _ASMSUB: {_base=0x90;/**+0x46  N*/ goto loop;}
      case _ASMSBC: {_base=0x98;/**+0x46  N*/ goto loop;}
      case _ASMAND: {_base=0xa0;/**+0x46  N*/ goto loop;}
      case _ASMXOR: {_base=0xa8;/**+0x46  N*/ goto loop;}
      case _ASMOR:  {_base=0xb0;/**+0x46  N*/ goto loop;}
      case _ASMCP:  {_base=0xb8;/**+0x46  N*/ goto loop;}

      case _ASMINC: {_base=0x04; goto loop;}
      case _ASMDEC: {_base=0x05; goto loop;}

      case _ASMOUT: {_base=0x8d/**0xd3-0x46*/;/**  alucmdn*/ goto loop;}
      case _ASMIN:  {_base=0x95/**0xdb-0x46*/;/**  alucmdn*/ goto loop;}

      case _ASMPOP: {_base=0xc1; goto loop;}
      case _ASMPUSH:{_base=0xc5; goto loop;}

      case _ASMRLC: {_base=0x00; goto loop;}
      case _ASMRRC: {_base=0x08; goto loop;}
      case _ASMRL:  {_base=0x10; goto loop;}
      case _ASMRR:  {_base=0x18; goto loop;}
      case _ASMSLA: {_base=0x20; goto loop;}
      case _ASMSRA: {_base=0x28; goto loop;}
      case _ASMSLI: {_base=0x30; goto loop;}
      case _ASMSRL: {_base=0x38; goto loop;}

      case _ASMBIT: {_base=0x40; goto loop;}
      case _ASMRES: {_base=0x80; goto loop;}
      case _ASMSET: {_base=0xc0; goto loop;}

      case _ASMRLCA:{_base=0x07; goto loop;}
      case _ASMRRCA:{_base=0x0f; goto loop;}
      case _ASMRLA: {_base=0x17; goto loop;}
      case _ASMRRA: {_base=0x1f; goto loop;}
      case _ASMDAA: {_base=0x27; goto loop;}
      case _ASMCPL: {_base=0x2f; goto loop;}
      case _ASMSCF: {_base=0x37; goto loop;}
      case _ASMCCF: {_base=0x3f; goto loop;}
      case _ASMNOP: {_base=0x00; goto loop;}
      case _ASMHALT:{_base=0x76; goto loop;}
      case _ASMDI:  {_base=0xf3; goto loop;}
      case _ASMEI:  {_base=0xfb; goto loop;}
      case _ASMEXX: {_base=0xd9; goto loop;}

      case _ASMRETN:{asmbyte_ed(); _base=0x45; goto loop;}
      case _ASMRETI:{asmbyte_ed(); _base=0x4d; goto loop;}
      case _ASMLDI: {asmbyte_ed(); _base=0xa0; goto loop;}
      case _ASMLDD: {asmbyte_ed(); _base=0xa8; goto loop;}
      case _ASMLDIR:{asmbyte_ed(); _base=0xb0; goto loop;}
      case _ASMLDDR:{asmbyte_ed(); _base=0xb8; goto loop;}
      case _ASMCPI: {asmbyte_ed(); _base=0xa1; goto loop;}
      case _ASMCPD: {asmbyte_ed(); _base=0xa9; goto loop;}
      case _ASMCPIR:{asmbyte_ed(); _base=0xb1; goto loop;}
      case _ASMCPDR:{asmbyte_ed(); _base=0xb9; goto loop;}
      case _ASMINI: {asmbyte_ed(); _base=0xa2; goto loop;}
      case _ASMIND: {asmbyte_ed(); _base=0xaa; goto loop;}
      case _ASMINIR:{asmbyte_ed(); _base=0xb2; goto loop;}
      case _ASMINDR:{asmbyte_ed(); _base=0xba; goto loop;}
      case _ASMOUTI:{asmbyte_ed(); _base=0xa3; goto loop;}
      case _ASMOUTD:{asmbyte_ed(); _base=0xab; goto loop;}
      case _ASMOTIR:{asmbyte_ed(); _base=0xb3; goto loop;}
      case _ASMOTDR:{asmbyte_ed(); _base=0xbb; goto loop;}
      case _ASMINF: {asmbyte_ed(); _base=0x70; goto loop;}
      case _ASMNEG: {asmbyte_ed(); _base=0x44; goto loop;}

      case _FMTMOVRBRB:   {IF ((_reg|_oldreg)>=+_ASMRBIXADD)asmrbrb_ixiyprefix(); asmbyte((_reg>>0x03)+_oldreg+0x40); goto loop;} //<ld><_reg><commakeepreg><_reg><writemovrbrb> -    (?x,?y / ?y,?x / ?x/y,h/l / h/l,?x/y),  dd/fd   (    h/l)
      case _FMTMOVAIR:    {asmbyte_ed(); asmbyte(_reg+0x57); goto loop;} //<ld><_reg(==A)><commakeepreg><regIR><writemovair>
      case _FMTMOVIRA:    {asmbyte_ed(); asmbyte(_oldreg+0x47); goto loop;} //<ld><regIR><commakeepreg><_reg(==A)><writemovira>
      case _FMTMOVRPRP:   {asmcheckrp_ixiyprefix(); IF ((_oldreg!=_ASMRPCODE_SP)||(_reg!=_ASMRPCODE_HL))errwrongreg(); asmbyte(0xf9); goto loop;} //<ld><rp(==SP)><comma><rp><writemovrprp> -     rp (  bc,de,sp)   dd/fd (  ld bc,de  ..)
      case _FMTLDRBN:     {IF (_oldreg>=_ASMRBIXADD)asmoldrb_ixiyprefix(); asmbyte(_oldreg+0x06); asmbytepopvalue(); goto loop;} //<ld><rp><comma><num>LH<writeldrbN> -     rp   dd/fd
      case _FMTLDRPNN:    {asmcheckoldrp_ixiyprefix(); asmbyte(_oldreg+0x01); asmwordpopvalue(); goto loop;} //<ld><rp><comma><num>LH<writeldrpNN> -     rp   dd/fd
      case _FMTGETAMRP:   {asmcheckrp_ixiyprefix(); IF (_reg==_ASMRPCODE_HL){asmbyte(0x7e);}ELSE IF (_reg==_ASMRPCODE_SP){errwrongreg();}ELSE asmbyte(_reg+0x0a); goto loop;} //<ld><_reg(==A)><commakeepreg><(><rp><)><writegetamrp> -  !!!   sp,    hl
      case _FMTGETAMNN:   {asmbyte(0x3a); asmwordpopvalue(); goto loop;} //<ld><_reg(==A)><comma><(><num>LH<)><writegetamNN> -  !!!
      case _FMTGETRBMHL:  {err_oldrbix(); asmbyte(_oldreg+0x46); goto loop;} //<ld><_reg><commakeepreg><(><rp(==HL)><)><writegetrbmhl> -     _reg
      case _FMTGETRBIDX:  {err_oldrbix(); asmrp_ixiyprefix(); asmbyte(_oldreg+0x46); asmdisppopvalue(); goto loop;} //writegetrbindex: <ld><_reg><commakeepreg><(><rp(==IX/IY)><num>LH<)><writegetrbindex>: ix/iy ,     !  dd/fd, ==
      case _FMTGETRPMNN:  {asmcheckoldrp_ixiyprefix(); IF (_oldreg==_ASMRPCODE_HL){asmbyte(0x2a);}ELSE {asmbyte_ed();asmbyte(_oldreg+0x4b);}; asmwordpopvalue(); goto loop;} //<ld><rp><comma><num>LH<writegetrpmNN> -     rp   dd/fd
      case _FMTPUTMHLRB:  {err_rbix(); asmbyte((_reg>>0x03)+0x70); goto loop;} //<ld><(><rp(==HL)><)><comma><_reg><writeputmhlrb> - hl !!!  ==
      case _FMTPUTMHLN:   {asmbyte(0x36); asmbytepopvalue(); goto loop;} //<ld><(><rp(==HL)><)><comma><num>LH<writeputmhlN> - hl !!!
      case _FMTPUTIDXRB:  {err_rbix(); asmoldrp_ixiyprefix(); asmbyte((_reg>>0x03)+0x70); asmdisppopvalue(); goto loop;} //<ld><(><rp(==IX/IY)><num>LH<)><commakeepreg><_reg><writeputindexrb>: ix/iy ,     !  dd/fd, ==
      case _FMTPUTIDXN:   {asmrp_ixiyprefix(); asmbyte(0x36); tempvalue=asmpopvalue(); asmdisppopvalue(); asmbyte(+(BYTE)tempvalue); goto loop;} //<ld><(><rp(==IX/IY)><num>LH<)><comma><num>LH<writeputindexN> - ix/iy  (    )!   dd/fd
      case _FMTPUTMRPA:   {asmcheckoldrp_ixiyprefix(); IF (_oldreg==_ASMRPCODE_HL){asmbyte(0x77);}ELSE IF (_oldreg==_ASMRPCODE_SP){errwrongreg();}ELSE asmbyte(_oldreg+0x02); goto loop;} //<ld><(><rp><)><commakeepreg><_reg(==A)><writeputmrpa> -  !!!   sp,    hl
      case _FMTPUTMNNA:   {asmbyte(0x32); asmwordpopvalue(); goto loop;} //<ld><(><num>LH<)><comma><_reg(==A)><writeputmNNa> -  !!!
      case _FMTPUTMNNRP:  {asmcheckrp_ixiyprefix(); IF (_reg==_ASMRPCODE_HL){asmbyte(0x22);}ELSE {asmbyte_ed();asmbyte(_reg+0x43);}; asmwordpopvalue(); goto loop;} //writeputmNNrp(==writeputmNNa?): <ld><(><num>LH<)><comma><rp><writeputmNNrp> -     rp   dd/fd

      case _FMTALUCMDN:   {asmbyte(0x46+_base); asmbytepopvalue(); goto loop;} //<sbc><_reg(==A)><comma><num>LH<writealucmdN> -  !!!  (1)  dd/fd         h/l
      case _FMTALUCMDRB:  {asmcheckrb_ixiyprefix();/**IF (_reg>=_ASMRBIXADD)asmrb_ixiyprefix();*/ asmbyte((_reg>>0x03)+_base); goto loop;} //<sbc><_reg(==A)><comma><rp><writealucmdrb> -  !!!  (2)  dd/fd         h/l
      case _FMTALUCMDMHL: {asmbyte(0x06+_base); goto loop;} //<sbc><_reg(==A)><comma><(><rp(==HL)><)><writealucmdmhl> - .! hl 
      case _FMTALUCMDIDX: {asmrp_ixiyprefix(); asmbyte(0x06+_base); asmdisppopvalue(); goto loop;} //<sbc><_reg(==A)><comma><(><rp(==IX/IY)><num>LH<)><writealucmdindex> - .! ix/iy  (    )!   dd/fd,2
      case _FMTADDHLRP:   {/**IF ((_reg|_oldreg)>=_ASMRPIXADD)*/asmrprp_ixiyprefix(); asmbyte(_reg+0x09); goto loop;} //<add><rp(==HL/IX/IY)><commakeepreg><rp><writeaddhlrp> -   rp1, rp2   dd/fd (add ix,iy, add iy,ix, add ix/iy,hl, add hl,ix/iy - )
      case _FMTADCHLRP:   {err_rpix(); asmbyte_ed(); asmbyte(_reg+0x4a); goto loop;} //<adc><rp(==HL)><comma><rp><writeadchlrp> -   rp (ix/iy - )
      case _FMTSBCHLRP:   {err_rpix(); asmbyte_ed(); asmbyte(_reg+0x42); goto loop;} //<sbc><rp(==HL)><comma><rp><writesbchlrp> -   rp (ix/iy - )
      case _FMTINCRP:     {asmcheckrp_ixiyprefix(); asmbyte(_reg+0x03); goto loop;} //      inc (  )
      case _FMTDECRP:     {asmcheckrp_ixiyprefix(); asmbyte(_reg+0x0b); goto loop;} //      dec (  ) (    writedecrp==writeincrp?)
      case _FMTINCDECRB:  {asmcheckrb_ixiyprefix();/**IF (_reg>=_ASMRBIXADD)asmrb_ixiyprefix();*/ asmbyte(_base+_reg); goto loop;}
      case _FMTINCDECMHL: {asmbyte(_base+0x30); goto loop;}
      case _FMTINCDECIDX: {asmrp_ixiyprefix(); asmbyte(_base+0x30); asmdisppopvalue(); goto loop;}

      case _FMTEXRPRP:    {IF (_oldreg==_ASMRPCODE_DE){asmbyte(0xeb);}ELSE IF (_reg==_ASMRPCODE_AF){asmbyte(0x08);}ELSE /**IF (_oldreg==_ASMRPCODE_SP)*/{IF (_reg>=_ASMRPIXADD){asmrp_ixiyprefix();}; asmbyte(0xe3);}; goto loop;} //<ex><rp><commakeepreg><rp><writeexrprp>
      case _FMTJRDD:      {asmbyte(_base); asmdisp(+(INT)(+(UINT)asmpopvalue()-((_curaddr+_curshift)+1))); goto loop;} //<jr><cc><comma><num>LH<writejr> -    $    - cc  1  2+8*cc
      case _FMTJPNN:      {asmbyte(_base); asmwordpopvalue(); goto loop;} //<call><cc><comma><num>LH<writejp> - cc  1  2+8*cc
      case _FMTJPRP:      {asmcheckrp_ixiyprefix(); IF (_reg!=_ASMRPCODE_HL)errwrongreg(); asmbyte(0xe9); goto loop;}  //<jp><rp><writejprp> -   ,       .   rp    -   textcmd?
      case _FMTPUSHPOPRP: {asmcheckrp_ixiyprefix(); asmbyte(_base+_reg); goto loop;}
      case _FMTCBCMDRB:   {err_rbix(); asmbyte(0xcb); asmbyte((_reg>>0x03)+_base); goto loop;} //<rlc><_reg><writecbcmd> -   _reg (  - ) -   rlc  ..    , ..   dd/fd, cb
      case _FMTCBCMDMHL:  {asmbyte(0xcb); asmbyte(_base+0x06); goto loop;} //<rlc><(><rp(==HL)><)><writecbcmdmhl> - hl !!! -   <writecbcmdindex>,   rp
      case _FMTCBCMDIDX:  {asmrp_ixiyprefix(); asmbyte(0xcb); asmdisppopvalue(); asmbyte(_base+0x06); goto loop;} //<rlc><(><rp(==IX/IY)><num>LH<)><writecbcmdindex> - ix/iy  (    )!!!   dd/fd, cb
      case _FMTRST:       {tempvalue=asmpopvalue(); /**IF ((+(UINT)tempvalue&0xffc7)!=0)errwrongpar();*/ asmbyte(+(BYTE)tempvalue+0xc7); goto loop;} //<rst><num>LH<writerst> -  pseudon (  0/8/16/../56,  )   textcmd?
      case _OPBIT:        {tempvalue=asmpopvalue(); /**IF ((+(UINT)tempvalue&0xfff8)!=0)errwrongpar();*/ _base=((+(BYTE)tempvalue&0x07)<<0x03)+_base; goto loop;} // bit/res/set:  pseudon (  0..7,  ),   8     
      case _FMTIM:        {asmbyte_ed(); tempvalue=asmpopvalue(); IF (+(UINT)tempvalue==0){asmbyte(0x46);}ELSE IF (+(UINT)tempvalue==1){asmbyte(0x56);}ELSE IF (+(UINT)tempvalue==2){asmbyte(0x5e);}ELSE errwrongpar(); goto loop;} //writeim:  0..2 ( )    46, 56, 5e -   textcmd?         ( writealucmd,  writecmd)
      case _FMTXX:        {asmbyte(_base); goto loop;} //(   ret/ret cc    ) -   writealucmd ( <ret>  ),  ret cc  textcmd   writejp (       )
      case _FMTOUTCRB:    {err_rbix(); asmbyte_ed(); asmbyte(_reg+0x41); goto loop;} //out (c),_reg (ed 41+) -  _reg (  - )
      case _FMTINRBC:     {err_oldrbix(); asmbyte_ed(); asmbyte(_oldreg+0x40); goto loop;} //in _reg,(c) (ed 40+) -  _oldreg (  - )

      case _RG_B: {_reg = _ASMRBCODE_B; goto loop;}
      case _RG_C: {_reg = _ASMRBCODE_C; goto loop;}
      case _RG_D: {_reg = _ASMRBCODE_D; goto loop;}
      case _RG_E: {_reg = _ASMRBCODE_E; goto loop;}
      case _RG_H: {_reg = _ASMRBCODE_H; goto loop;}
      case _RG_L: {_reg = _ASMRBCODE_L; goto loop;}
      case _RG_A: {_reg = _ASMRBCODE_A; goto loop;}
      case _RG_HX:{_reg = _ASMRBCODE_HX; goto loop;}
      case _RG_LX:{_reg = _ASMRBCODE_LX; goto loop;}
      case _RG_HY:{_reg = _ASMRBCODE_HY; goto loop;}
      case _RG_LY:{_reg = _ASMRBCODE_LY; goto loop;}
      case _RG_I: {_reg = _ASMRBCODE_I; goto loop;}
      case _RG_R: {_reg = _ASMRBCODE_R; goto loop;}

      case _RG_BC: {_reg = _ASMRPCODE_BC; goto loop;}
      case _RG_DE: {_reg = _ASMRPCODE_DE; goto loop;}
      case _RG_HL: {_reg = _ASMRPCODE_HL; goto loop;}
      case _RG_SP: {_reg = _ASMRPCODE_SP; goto loop;}
      case _RG_AF: {_reg = _ASMRPCODE_AF; goto loop;}
      case _RG_IX: {_reg = _ASMRPCODE_IX; goto loop;}
      case _RG_IY: {_reg = _ASMRPCODE_IY; goto loop;}

      //case _TOKTEXT: {errstr("TEXT"); enderr(); /**format error*/ goto loop;}
      //case _TOKENDTEXT: {errstr("ENDTEXT"); enderr(); /**format error*/ goto loop;}
      //case _TOKENDCOMMENT: {errstr("ENDCOMMENT"); enderr(); /**format error*/ goto loop;}
      //case _TOKENDERR: {errstr("ENDERR"); enderr(); goto loop;}
      default : {err(+(CHAR)_token); enderr(); goto loop;}
    };
  endloop:;
}

PROC initmemmodel()
{
  //_curaddr = _BASEADDR; //0x0100;
  //_curpage0 = 0x00;
  //_curpage1 = 0x05;
  //_curpage2 = 0x02;
  //_curpage3 = 0x07;
}
