//// imported
#include "emit.h"

//,    ,  _joined
//( call -  _callee,   loadrg/b -  _const)
//    (put, call, jpiffalse)  _jpflag = 0x00 (  ""      )
//   jpiffalse, ..     ""
EXPORT VAR PCHAR _callee; //   (  )
EXPORT VAR UINT  _lencallee;
EXTERN PCHAR _joined; //
EXTERN UINT  _lenjoined;
EXTERN PCHAR _const; // 
EXTERN UINT  _lenconst;

EXPORT VAR BYTE _exprlvl; //  (  == 1)

//  ( rgs) - todo  codegen   rgs
EXTERN BYTE _rnew;
EXTERN BYTE _rold;
EXTERN BYTE _rold2;
EXTERN BYTE _rold3;

//rg pool
PROC getnothing FORWARD(); //       
//PROC getmainrg FORWARD(); // RMAIN=new    
PROC getmain2rgs FORWARD(); // RMAIN=old, RMAIN2=new     // call2rgs
//PROC getmain3rgs FORWARD(); // call3rgs
PROC getmain4rgs FORWARD(); // call4rgs
PROC setmainrg FORWARD(); // ,        // call2rgs
PROC setmain2rgs FORWARD(); // ,        // call4rgs

PROC rgs_initrgs FORWARD();

////
CONST BYTE _NRGS = 0x04; // 

CONST BYTE _RFAST = 0x01; /**HL*/ /**  */ //TODO   
CONST BYTE _RFAST2= 0x02; /**DE*/
CONST BYTE _RFAST3= 0x03; /**BC*/
CONST BYTE _RFAST4= 0x04; /**IX*/
  // :
CONST BYTE _RMAIN = 0x01; /**HL*/ /**      */
CONST BYTE _RMAIN2= 0x02; /**DE*/ /**        */
CONST BYTE _RMAIN3= 0x03;
CONST BYTE _RMAIN4= 0x04;

VAR PCHAR _RNAME [5];
VAR PCHAR _RHIGH [5];
VAR PCHAR _RLOW  [5];
/**CONST PCHAR _RNAME [5] = {
  "",
  "HL",
  "DE",
  "BC",
  "IX"
};*/

VAR BYTE _rproxy;
VAR BOOL _fused;

VAR INT _funcstkdepth;

VAR BYTE _jpflag; //0=OR A:JZ, 1=JZ, 2=JNZ, 3=JNC, 4=JC

#include "sizes.h"

EXPORT CONST BYTE _typesz[32] = { //     
  _SZ_BYTE/**T_BYTE */, //  
  _SZ_REG/**T_UINT */, //  
  _SZ_REG/**T_INT  */, //  
  _SZ_BYTE/**T_BOOL */,
  _SZ_LONG/**T_LONG */,
  _SZ_BYTE/**T_CHAR */,
  _SZ_LONG/**T_FLOAT*/,
  0x00/**unknown*/,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  _SZ_REG/**T_PBYTE */,
  _SZ_REG/**T_PUINT */,
  _SZ_REG/**T_PINT  */,
  _SZ_REG/**T_PBOOL */,
  _SZ_REG/**T_PLONG */,
  _SZ_REG/**T_PCHAR */,
  _SZ_REG/**T_PFLOAT*/,
  _SZ_REG/**        */,
  _SZ_REG, _SZ_REG, _SZ_REG, _SZ_REG, _SZ_REG, _SZ_REG, _SZ_REG, _SZ_REG //pointer to...
};

CONST BYTE _typeshift[32] = { //log   (n  2^n )  
  _RL_BYTE/**T_BYTE */, //  
  _RL_REG/**T_UINT */, //  
  _RL_REG/**T_INT  */, //  
  _RL_BYTE/**T_BOOL */,
  _RL_LONG/**T_LONG */,
  _RL_BYTE/**T_CHAR */,
  _RL_LONG/**T_FLOAT*/,
  0x00/**unknown*/,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  _RL_REG/**T_BYTE  */,
  _RL_REG/**T_UINT  */,
  _RL_REG/**T_INT   */,
  _RL_REG/**T_BOOL  */,
  _RL_REG/**T_LONG  */,
  _RL_REG/**T_CHAR  */,
  _RL_REG/**T_PFLOAT*/,
  _RL_REG/**        */,
  _RL_REG, _RL_REG, _RL_REG, _RL_REG, _RL_REG, _RL_REG, _RL_REG, _RL_REG //pointer to...
};

PROC initrgs FORWARD(); //     (  cemitfunc)

////////////      

PROC asm_comma()
{
  asmc(',');
}

PROC asm_open()
{
  asmc('[');
}

PROC asm_close()
{
  asmc(']');
}

PROC asm_rname(BYTE r)
{
  asmstr( _RNAME[+(UINT)r] );
}

PROC asm_mrgname(BYTE r)
{
  asm_open(); asm_rname(r); asm_close();
}

PROC asm_rlow(BYTE r)
{
  asmstr( _RLOW[+(UINT)r] );
}

PROC asm_rhigh(BYTE r)
{
  asmstr( _RHIGH[+(UINT)r] );
}
/**
PROC asm_raname(BYTE r)
{
  asmstr( _RLOW[+(UINT)r] );
  //asmstr( _RGANAME[+(UINT)r] );
}
*/
PROC asm_close_eol()
{
  asm_close(); endasm();
}

PROC asm_a()
{
  asmc('A');
}

PROC asm_hl()
{
  asm_rname(_RFAST);
}

PROC asm_mhl()
{
  asm_mrgname(_RFAST);
}

EXPORT PROC var_db() //  compile!
{
  varstr( "\tDB " );
}

EXPORT PROC asm_db() //     TODO
{
  asmstr( "\tDB " );
}

EXPORT PROC var_dw() //  compile!
{
  varstr( "\tDW " );
}

PROC var_dl()
{
  varstr( "\tDL " );
}

EXPORT PROC var_def(BYTE t, PCHAR s) //  compile!
{
VAR BYTE sz = _typesz[t];
  IF (sz==_SZ_BYTE/**(tmasked==_T_BYTE)||(tmasked==_T_CHAR)||(tmasked==_T_BOOL)*/) {
    var_db(); varstr(s); endvar();
  }ELSE IF (sz==_SZ_REG/**(tmasked==_T_INT)||(tmasked==_T_UINT)*/) {
    var_dw(); varstr(s); endvar(); // DW  uint
  }ELSE IF (sz==_SZ_LONG/**tmasked==_T_LONG*/) {
    var_dl(); varstr(s); endvar();
  }ELSE { errstr( "const bad type " ); erruint(+(UINT)t); enderr(); };
}

PROC asm_and()
{
  asmstr( "\tAND " );
}

PROC asm_or()
{
  asmstr( "\tOR " );
}

PROC asm_xor()
{
  asmstr( "\tXOR " );
}

PROC asm_sub()
{
  asmstr( "\tSUB " );
}

PROC asm_sbc()
{
  asmstr( "\tSBC " );
}

PROC asm_add()
{
  asmstr( "\tADD " );
}

PROC asm_adc()
{
  asmstr( "\tADC " );
}

PROC asm_inc()
{
  asmstr( "\tINC " );
}

PROC asm_dec()
{
  asmstr( "\tDEC " );
}

PROC asm_ld()
{
  asmstr( "\tLD " );
}

PROC asm_jp()
{
  asmstr( "\tJP " );
}

PROC asm_ex()
{
  asmstr( "\tEX " );
}

PROC asm_push()
{
  asmstr( "\tPUSH " );
}

PROC asm_pop()
{
  asmstr( "\tPOP " );
}

PROC asm_lda_comma()
{
  asm_ld(); asm_a(); asm_comma();
}

PROC asm_ldmhl_comma()
{
  asm_ld(); asm_mhl(); asm_comma();
}

PROC asm_comma_a_eol()
{
  asm_comma(); asm_a(); endasm();
}

PROC asm_comma_mhl_eol()
{
  asm_comma(); asm_mhl(); endasm();
}

PROC asm_inchl_eol()
{
  asm_inc(); asm_rname(_RFAST); endasm();
}

PROC asm_exa_eol()
{
  asm_ex(); asmstr("AF,AF\'"); endasm();
}

PROC asm_exd_eol()
{
  asm_ex(); asmstr("DE,HL"); endasm();
}

PROC asm_ccf_eol()
{
  asmstr( "\tCCF" ); endasm();
}

PROC asm_call_eol(PCHAR s)
{
  asmstr( "\tCALL " ); asmstr( s ); endasm();
}

///////////////////////////////////
//  commands
PROC unproxy()
{
  IF (_rproxy != 0x00) { //  - 
    asm_ld(); /**rganame*/asm_rlow(_rproxy); asm_comma_a_eol();
    _rproxy = 0x00;
  };
}

PROC proxy(BYTE r)
{
  IF (_rproxy != r) {
    unproxy();
    asm_lda_comma(); /**rganame*/asm_rlow(r); endasm();
    _rproxy = r;
  };
}

///////////////////////////////////////////////////////////
//     rgs

PROC emitpushrg(BYTE rnew)
{
  unproxy(); //todo 
  asm_push(); asm_rname(rnew); endasm();
  INC _funcstkdepth;
}

PROC emitpoprg(BYTE rnew) //    getrfree/getrg
{
  asm_pop(); asm_rname(rnew); endasm();
  DEC _funcstkdepth;
}

PROC emitmovrg(BYTE rsrc, BYTE rdest) //     (. emitmoverg)
{
  IF (rsrc!=rdest) { //todo   rsrc!=rdest ?
    //rdest    FASTRG4?    getslowrg,   :(
    IF ( ((rdest==_RFAST4)&&(rsrc==_RFAST))
       ||((rdest==_RFAST)&&(rsrc==_RFAST4))
       ) {
      asm_push(); asm_rname(rsrc); endasm();
      asm_pop(); asm_rname(rdest); endasm();
    }ELSE {
      asm_ld(); asm_rhigh(rdest); asm_comma(); asm_rhigh(rsrc); endasm();
      asm_ld(); asm_rlow(rdest); asm_comma(); asm_rlow(rsrc); endasm();
    };
  };
}

///////////////////////////////////////////////////////////////////////////////////////
//   
//  ,   commands

PROC emitjpmainrg() //"jp (hl)"
{
  //         
  //(   ,   storergs       )
  unproxy();
  getnothing(); //getnothingword();
  asm_jp(); asm_mhl(); endasm();
}

PROC emitcallmainrg() //"call (hl)"
{
  //         
  //(   ,   storergs       )
  unproxy();
  getnothing(); //getnothingword();
  asm_call_eol("_JPHL.");
  _fused = +FALSE; // 
}

PROC emitjp()
{
  //         
  //(   ,   storergs       )
  unproxy();
  getnothing(); //getnothingword();
  asm_jp(); asmstr(_joined); endasm();
}

PROC emitbtoz() // jp!
{
  //    ,     BOOL
  //IF (_jpflag == 0x00) {
  IF (!_fused) { //   
    proxy(_rnew); //todo 
    //IF (anew==_RGA) {
      asm_or(); asm_a(); endasm();
    //}ELSE {
    //  asm_inc(); /**rganame*/asm_rlow(anew); endasm();
    //  asm_dec(); /**rganame*/asm_rlow(anew); endasm();
    //};
  };
  _rproxy = 0x00;
}

PROC emitjpiffalse()
{
  //         
  //(   ,   storergs       )
  //unproxy();
  getnothing(); //getnothingword();
  asm_jp();
  IF       (_jpflag == 0x02) {asmstr("NZ");
  }ELSE IF (_jpflag == 0x03) {asmstr("NC");
  }ELSE IF (_jpflag == 0x04) {asmc('C');
  }ELSE                      {asmc('Z');
  };
  asm_comma();
  asmstr(_joined);
  endasm();
  _fused = +FALSE;
  _jpflag = 0x00;
}

PROC emitret()
{
  //unproxy();
  asmstr( "\tRET" ); endasm();
}

PROC emitcall2rgs(PCHAR s)
{
  unproxy();
  getmain2rgs();
  initrgs();
  asm_call_eol(s);
  setmainrg(); //  RMAIN
}
/**
PROC emitcall3rgs(PCHAR s) //todo 
{
  unproxy();
  getmain3rgs();
  initrgs();
  asm_call_eol(s);
  //     
  //setwordcontext();
  setmain2rgs(); //  RMAIN,RMAIN2
}
*/
PROC emitcall4rgs(PCHAR s) //todo 
{
  unproxy();
  getmain4rgs();
  initrgs();
  asm_call_eol(s);
  //     
  //setwordcontext();
  setmain2rgs(); //  RMAIN,RMAIN2
}

PROC emitcallproc()
{
  //_jpflag = 0x00;
  asm_call_eol(_callee);
}

PROC emitloadrg(BOOL high) //    getrfree
{
  asm_ld();
  asm_rname(_rnew);
  asm_comma();
  asmstr(_const);
  IF (high) {asmstr( ">>16"/**WORDBITS*/ );
  //}ELSE {asmstr( "&0xffff"/**WORDMASK*/ );
  };
  endasm();
  _fused = +FALSE; // 
}

PROC emitloadrg0() //    getrfree
{
  asm_ld(); asm_rname(_rnew); asm_comma(); asmc('0'); endasm();
}

PROC emitloadb() //    getfreea
{
  IF (_rproxy == 0x00) {
    _rproxy = _rnew;
    asm_lda_comma();
  }ELSE {
    asm_ld();
    /**rganame*/asm_rlow(_rnew);
    asm_comma();
  };
  asmstr(_const);
  endasm();
  _fused = +FALSE; // 
}

PROC emitgetrg(BOOL high) //    getrfree
{
  asm_ld();
  asm_rname(_rnew);
  asm_comma();
  asm_open();
  asmstr(_joined);
  IF (high) {asmc('+'); asmc('2');
  };
  asm_close();
  endasm();
}

PROC emitgetb() //    getfreea
{
  unproxy();
  _rproxy = _rnew;
  asm_lda_comma();
  asm_open();
  asmstr(_joined);
  asm_close();
  endasm();
}

PROC emitputrg(BOOL high) //ld [],new
{
  //_jpflag = 0x00;
  asm_ld(); asm_open();
  asmstr(_joined);
  IF (high) {asmc('+'); asmc('2'); //asmstr( "+2"/**WORDSIZE*/ );
  };
  asm_close(); asm_comma();
  asm_rname(_rnew);
  endasm();
  _fused = +FALSE; // 
}

PROC emitputb()
{
  //_jpflag = 0x00;
  proxy(_rnew);
  asm_ld(); asm_open();
  asmstr(_joined);
  asm_close();
  asm_comma_a_eol();
  _rproxy = 0x00;
  _fused = +FALSE; // 
}

PROC emitshl1rg()
{
  IF ((_rnew == _RFAST)||(_rnew == _RFAST4)) {
    asm_add(); asm_hl(); asm_comma(); asm_hl(); endasm();
  }ELSE {
    asmstr( "\tSLA " ); asm_rlow(_rnew); endasm();
    asmstr( "\tRL " ); asm_rhigh(_rnew); endasm();
  };
}

PROC emitshl1b()
{
    proxy(_rnew);
  //IF (_rproxy==_rnew) {
    asm_add(); asm_a(); asm_comma_a_eol();
  //}ELSE {
  //  asmstr( "\tSLA " ); /**rganame*/asm_rlow(anew); endasm();
  //};
}
/**
PROC emitshr1rg(BYTE rnew)
{
  asmstr( "\tSRL " ); asm_rhigh(rnew); endasm();
  asmstr( "\tRR " ); asm_rlow(rnew); endasm();
}

PROC emitshr1signedrg(BYTE rnew)
{
  asmstr( "\tSRA " ); asm_rhigh(rnew); endasm();
  asmstr( "\tRR " ); asm_rlow(rnew); endasm();
}
*/
//PROC emitshr1b(BYTE anew)
//{
//  asmstr( "\tSRL " ); /**rganame*/asm_rlow(anew] ); endasm();
//}

PROC emitinvb() //~A -> A
{
  proxy(_rnew);
  asmstr( "\tCPL" ); endasm();
  _fused = +FALSE; //  if (!(a||b))
}

PROC emitinvrg()
{
  unproxy();
  asm_lda_comma(); asm_rhigh(_rnew); endasm();
  asmstr( "\tCPL" ); endasm();
  asm_ld(); asm_rhigh(_rnew); asm_comma_a_eol();
  emitinvb(); //TODO test
  //asm_lda_comma(); asm_rlow(_rnew); endasm();
  //asmstr( "\tCPL" ); endasm();
  //asm_ld(); asm_rlow(_rnew); asm_comma_a_eol();
  //unreserverg( _RGA );
}

PROC emitnegrg()
{
  unproxy();
  asm_xor(); asm_a(); endasm();
  asm_sub(); asm_rlow(_rnew); endasm();
  asm_ld(); asm_rlow(_rnew); asm_comma_a_eol();
  asm_sbc(); asm_a(); asm_comma(); asm_rhigh(_rnew); endasm();
  asm_sub(); asm_rlow(_rnew); endasm();
  asm_ld(); asm_rhigh(_rnew); asm_comma_a_eol();
}

PROC emitSxorVtocy() // subflags,  A
{
  asmstr( "\tRLA" ); endasm(); //sign
  asm_jp(); asmstr( "PO,$+4" ); endasm();
  asm_ccf_eol();
}

PROC emitinvSxorVtocy() // subflags,  A
{
  asmstr( "\tRLA" ); endasm(); //sign
  asm_jp(); asmstr( "PE,$+4" ); endasm();
  asm_ccf_eol();
}

PROC emitxorrg() //old^new => old
{
  unproxy();
  asm_lda_comma(); asm_rhigh(_rnew); endasm();
  asm_xor(); asm_rhigh(_rold); endasm();
  asm_ld(); asm_rhigh(_rold); asm_comma_a_eol();
  asm_lda_comma(); asm_rlow(_rnew); endasm();
  asm_xor(); asm_rlow(_rold); endasm();
  asm_ld(); asm_rlow(_rold); asm_comma_a_eol();
}

PROC getxorb() //RGA^RGA2 -> RGA
{
  IF (_rproxy == _rnew) {
    asm_xor();
    /**rganame*/asm_rlow(_rold);
    _rproxy = _rold;
  }ELSE {
    proxy(_rold);
    asm_xor();
    /**rganame*/asm_rlow(_rnew);
  };
   endasm();
  _fused = +TRUE; //^^
}

PROC emitorrg() //old|new => old
{
  unproxy();
  asm_lda_comma(); asm_rhigh(_rnew); endasm();
  asm_or(); asm_rhigh(_rold); endasm();
  asm_ld(); asm_rhigh(_rold); asm_comma_a_eol();
  asm_lda_comma(); asm_rlow(_rnew); endasm();
  asm_or(); asm_rlow(_rold); endasm();
  asm_ld(); asm_rlow(_rold); asm_comma_a_eol();
}

PROC getorb() //RGA|RGA2 -> RGA
{
  IF (_rproxy == _rnew) {
    asm_or();
    /**rganame*/asm_rlow(_rold);
    _rproxy = _rold;
  }ELSE {
    proxy(_rold);
    asm_or();
    /**rganame*/asm_rlow(_rnew);
  };
  endasm();
  _fused = +TRUE; //||
}

PROC emitandrg() //old&new => old
{
  unproxy();
  asm_lda_comma(); asm_rhigh(_rnew); endasm();
  asm_and(); asm_rhigh(_rold); endasm();
  asm_ld(); asm_rhigh(_rold); asm_comma_a_eol();
  asm_lda_comma(); asm_rlow(_rnew); endasm();
  asm_and(); asm_rlow(_rold); endasm();
  asm_ld(); asm_rlow(_rold); asm_comma_a_eol();
}

PROC getandb() //RGA&RGA2 -> RGA
{
  IF (_rproxy == _rnew) {
    asm_and();
    /**rganame*/asm_rlow(_rold);
    _rproxy = _rold;
  }ELSE {
    proxy(_rold);
    asm_and();
    /**rganame*/asm_rlow(_rnew);
  };
  endasm();
  _fused = +TRUE; //&&
}

PROC emitaddrg() //old+new => old
{ //add ix    
  IF ((_rold==_RFAST)&&(_rnew!=_RFAST4)) {
    asm_add(); asm_hl(); asm_comma(); asm_rname(_rnew); endasm();
  }ELSE IF ((_rold==_RFAST2)&&(_rnew!=_RFAST4)) {
    asm_exd_eol(); //todo  swaprgs?
    asm_add(); asm_hl(); asm_comma();
    IF (_rnew==_RFAST) {asm_rname(_RFAST2); //de+hl
    }ELSE asm_rname(_rnew);
    endasm();
    asm_exd_eol(); //todo  swaprgs?
  }ELSE {
    unproxy();
    asm_lda_comma(); asm_rlow(_rold); endasm();
    asm_add(); asm_a(); asm_comma(); asm_rlow(_rnew); endasm();
    asm_ld(); asm_rlow(_rold); asm_comma_a_eol();
    asm_lda_comma(); asm_rhigh(_rold); endasm();
    asm_adc(); asm_a(); asm_comma(); asm_rhigh(_rnew); endasm();
    asm_ld(); asm_rhigh(_rold); asm_comma_a_eol();
  };
}

PROC emitadcrg() //old+new => old
{
  IF ((_rold==_RFAST)&&(_rnew!=_RFAST4)) {
    asm_adc(); asm_hl(); asm_comma(); asm_rname(_rnew); endasm();
  }ELSE IF ((_rold==_RFAST2)&&(_rnew!=_RFAST4)) {
    asm_exd_eol(); //todo  swaprgs?
    asm_adc(); asm_hl(); asm_comma();
    IF (_rnew==_RFAST) {asm_rname(_RFAST2); //de+hl
    }ELSE asm_rname(_rnew);
    endasm();
    asm_exd_eol(); //todo  swaprgs?
  }ELSE {
    unproxy();
    asm_lda_comma(); asm_rlow(_rold); endasm();
    asm_adc(); asm_a(); asm_comma(); asm_rlow(_rnew); endasm();
    asm_ld(); asm_rlow(_rold); asm_comma_a_eol();
    asm_lda_comma(); asm_rhigh(_rold); endasm();
    asm_adc(); asm_a(); asm_comma(); asm_rhigh(_rnew); endasm();
    asm_ld(); asm_rhigh(_rold); asm_comma_a_eol();
  };
}

PROC emitaddb() //old+new
{
  IF (_rproxy == _rnew) {
    asm_add(); asm_a(); asm_comma(); /**rganame*/asm_rlow(_rold); endasm();
    _rproxy = _rold;
  }ELSE {
    proxy(_rold);
    asm_add(); asm_a(); asm_comma(); /**rganame*/asm_rlow(_rnew); endasm();
  };
}

PROC emitaddbconst() //new8+<const>
{
  proxy(_rnew);
  asm_add(); asm_a(); asm_comma(); asmstr(_const); endasm();
}

PROC emitsubrg() //old-new => old
{
  IF ((_rold==_RFAST)&&(_rnew!=_RFAST4)) {
    asm_or(); asm_a(); endasm();
    asm_sbc(); asm_hl(); asm_comma(); asm_rname(_rnew); endasm();
/**  }ELSE IF ((_rold==_RFAST2)&&(_rnew!=_RFAST4)) {
    asmstr("\tOR A"); endasm();
    asmstr("\tEX DE,HL"); endasm(); //todo  swaprgs?
    asmstr("\tSBC HL,"); asm_rname(rnew); endasm();
    asmstr("\tEX DE,HL"); endasm(); //todo  swaprgs?
    // 27  (   ,   23)
*/
  }ELSE {
    unproxy();
    asm_lda_comma(); asm_rlow(_rold); endasm();
    asm_sub(); asm_rlow(_rnew); endasm();
    asm_ld(); asm_rlow(_rold); asm_comma_a_eol();
    asm_lda_comma(); asm_rhigh(_rold); endasm();
    asm_sbc(); asm_a(); asm_comma(); asm_rhigh(_rnew); endasm();
    asm_ld(); asm_rhigh(_rold); asm_comma_a_eol();
  };
}

PROC emitsbcrg() //old-new => old
{
  IF ((_rold==_RFAST)&&(_rnew!=_RFAST4)) {
    asm_sbc(); asm_hl(); asm_comma(); asm_rname(_rnew); endasm();
  }ELSE IF ((_rold==_RFAST2)&&(_rnew!=_RFAST4)) {
    asm_exd_eol(); //todo  swaprgs?
    asm_sbc(); asm_hl(); asm_comma();
    IF (_rnew==_RFAST) {asm_rname(_RFAST2); //de-hl
    }ELSE asm_rname(_rnew);
    endasm();
    asm_exd_eol(); //todo  swaprgs?
  }ELSE {
    unproxy();
    asm_lda_comma(); asm_rlow(_rold); endasm();
    asm_sbc(); asm_a(); asm_comma(); asm_rlow(_rnew); endasm();
    asm_ld(); asm_rlow(_rold); asm_comma_a_eol();
    asm_lda_comma(); asm_rhigh(_rold); endasm();
    asm_sbc(); asm_a(); asm_comma(); asm_rhigh(_rnew); endasm();
    asm_ld(); asm_rhigh(_rold); asm_comma_a_eol();
  };
}

PROC emitsubb() //old-new
{
  proxy(_rold);
  asm_sub(); /**rganame*/asm_rlow(_rnew); endasm();
}

PROC emitsubflags(BYTE rnew, BYTE rold) //r2-r1 => CY,sign,overflow
{
  unproxy();
  asm_lda_comma(); asm_rlow(rold); endasm();
  asm_sub(); asm_rlow(rnew); endasm();
  asm_lda_comma(); asm_rhigh(rold); endasm();
  asm_sbc(); asm_a(); asm_comma(); asm_rhigh(rnew); endasm();
  _fused = +TRUE;
}

PROC emitsubbflags(BYTE anew, BYTE aold) //a2-a1 => CY,sign,overflow
{
  proxy(aold);
  asm_sub(); /**rganame*/asm_rlow(anew); endasm();
  _rproxy = 0x00;
  _fused = +TRUE;
}

PROC emitsubz() //old-new => Z
{
  IF (_rold == _RFAST) {
    emitsubrg();
  }ELSE {
    unproxy();
    asm_lda_comma(); asm_rlow(_rold); endasm();
    asm_sub(); asm_rlow(_rnew); endasm();
    IF ((_rold!=_RFAST4)&&(_rnew!=_RFAST4)) {asmstr( "\tJR NZ,$+4" );
    }ELSE asmstr( "\tJR NZ,$+5" ); //ix
    endasm();
    asm_lda_comma(); asm_rhigh(_rold); endasm();
    asm_sub(); asm_rhigh(_rnew); endasm();
  };
  _fused = +TRUE;
}

PROC emitsubbz() //old-new => Z
{
  IF (_rproxy == _rnew) {
    asm_sub();
    /**rganame*/asm_rlow(_rold);
  }ELSE {
    proxy(_rold);
    asm_sub();
    /**rganame*/asm_rlow(_rnew);
  };
  endasm();
  _rproxy = 0x00;
  _fused = +TRUE;
}

PROC emitsubbzconst() //new-<const> => Z
{
  proxy(_rnew);
  asm_sub(); asmstr(_const); endasm();
  _rproxy = 0x00;
  _fused = +TRUE;
}

PROC emitsublongz() //old2-new, old3-old => Z
//ld a,low(_rold2)
//sub low(_rnew)
//jr nz,$+2+2(1)+1 + 2+1(2)+1 + 2+1(2)+1
//ld a,high(_rold2)
//sub high(_rnew)
//jr nz,$+2+1(2)+1 + 2+1(2)+1
//ld a,low(_rold3)
//sub low(_rold)
//jr nz,$+2+1(2)+1
//ld a,high(_rold3)
//sub high(_rold)
{
  unproxy();
  asm_lda_comma(); asm_rlow(_rold2); endasm();
  asm_sub(); asm_rlow(_rnew); endasm();
  IF ((_rold3!=_RFAST4)&&(_rold!=_RFAST4)) {asmstr( "\tJR NZ,$+13" ); //5+4+4//ix  rold2  rnew
  }ELSE asmstr( "\tJR NZ,$+14" ); //4+5+5//ix  rold3  rold
  endasm();
  asm_lda_comma(); asm_rhigh(_rold2); endasm();
  asm_sub(); asm_rhigh(_rnew); endasm();
  IF ((_rold3!=_RFAST4)&&(_rold!=_RFAST4)) {asmstr( "\tJR NZ,$+8" );
  }ELSE asmstr( "\tJR NZ,$+10" ); //ix
  endasm();
  asm_lda_comma(); asm_rlow(_rold3); endasm();
  asm_sub(); asm_rlow(_rold); endasm();
  IF ((_rold3!=_RFAST4)&&(_rold!=_RFAST4)) {asmstr( "\tJR NZ,$+4" );
  }ELSE asmstr( "\tJR NZ,$+5" ); //ix
  endasm();
  asm_lda_comma(); asm_rhigh(_rold3); endasm();
  asm_sub(); asm_rhigh(_rold); endasm();
  _fused = +TRUE;
}

PROC emitpokerg() //     
{
  IF ((_rold == _RFAST)&&(_rnew!=_RFAST4)) {
    asm_ldmhl_comma(); asm_rlow(_rnew); endasm();
    asm_inchl_eol();
    asm_ldmhl_comma(); asm_rhigh(_rnew); endasm();
  }ELSE {
    unproxy();
    asm_lda_comma(); asm_rlow(_rnew); endasm();
    asm_ld(); asm_mrgname(_rold); asm_comma_a_eol();
    asm_inc(); asm_rname(_rold); endasm();
    asm_lda_comma(); asm_rhigh(_rnew); endasm();
    asm_ld(); asm_mrgname(_rold); asm_comma_a_eol();
  };
  _fused = +FALSE; // 
}

PROC emitpokeb() //     
// rnew    ,  rproxy==rnew!!!
{
  IF ((_rold==_RFAST) && (_rnew!=_RFAST4) && (_rproxy!=_rnew)) {
    asm_ld(); asm_mhl(); asm_comma(); asm_rlow(_rnew); endasm();
  }ELSE {
    proxy(_rnew); //   ld [rp],rg
    asm_ld(); asm_mrgname(_rold); asm_comma_a_eol();
  };
  _rproxy = 0x00;
  _fused = +FALSE; // 
}

PROC emitpokelong() //old2(addr), old(high), new(low)
{
  IF ((_rold2==_RFAST)&&(_rnew!=_RFAST4)) {
    asm_ldmhl_comma(); asm_rlow(_rnew); endasm();
    asm_inchl_eol();
    asm_ldmhl_comma(); asm_rhigh(_rnew); endasm();
    asm_inchl_eol();
    asm_ldmhl_comma(); asm_rlow(_rold); endasm();
    asm_inchl_eol();
    asm_ldmhl_comma(); asm_rhigh(_rold); endasm();
  }ELSE {
    unproxy();
    asm_lda_comma(); asm_rlow(_rnew); endasm();
    asm_ld(); asm_mrgname(_rold2); asm_comma_a_eol();
    asm_inc(); asm_rname(_rold2); endasm();
    asm_lda_comma(); asm_rhigh(_rnew); endasm();
    asm_ld(); asm_mrgname(_rold2); asm_comma_a_eol();
    asm_inc(); asm_rname(_rold2); endasm();
    asm_lda_comma(); asm_rlow(_rold); endasm();
    asm_ld(); asm_mrgname(_rold2); asm_comma_a_eol();
    asm_inc(); asm_rname(_rold2); endasm();
    asm_lda_comma(); asm_rhigh(_rold); endasm();
    asm_ld(); asm_mrgname(_rold2); asm_comma_a_eol();
  };
  _fused = +FALSE; // 
}

PROC emitpeekrg() //[new] => new
{
  unproxy();
  IF (_rnew==_RFAST) {
    asm_lda_comma(); asm_mhl(); endasm();
    asm_inchl_eol();
    asm_ld(); asmc('H'); asm_comma_mhl_eol();
    asm_ld(); asmc('L'); asm_comma_a_eol();
  }ELSE {
    asm_lda_comma(); asm_mrgname(_rnew); endasm();
    asm_inc(); asm_rname(_rnew); endasm();
    asm_exa_eol();
    asm_lda_comma(); asm_mrgname(_rnew); endasm();
    asm_ld(); asm_rhigh(_rnew); asm_comma_a_eol();
    asm_exa_eol();
    asm_ld(); asm_rlow(_rnew); asm_comma_a_eol();
  };
}

PROC emitpeekb()
{
//  IF (_rnew == _RFAST) {
//    asm_ld(); asmc('L'); asm_comma_mhl_eol(); //
//  }ELSE {
    unproxy();
    _rproxy = _rnew;
    asm_lda_comma(); asm_mrgname(_rnew); endasm();
//  };
}

PROC emitpeeklong() //[old] => old(high),new(low)
{
  unproxy();
  IF ((_rold==_RFAST)&&(_rnew!=_RFAST4)) {
    asm_ld(); asm_rlow(_rnew); asm_comma_mhl_eol();
    asm_inchl_eol();
    asm_ld(); asm_rhigh(_rnew); asm_comma_mhl_eol();
    asm_inchl_eol();
    asm_lda_comma(); asm_mhl(); endasm();
    asm_inchl_eol();
    asm_ld(); asmc('H'); asm_comma_mhl_eol();
    asm_ld(); asmc('L'); asm_comma_a_eol();
  }ELSE {
    asm_lda_comma(); asm_mrgname(_rold); endasm();
    asm_inc(); asm_rname(_rold); endasm();
    asm_ld(); asm_rlow(_rnew); asm_comma_a_eol();
    asm_lda_comma(); asm_mrgname(_rold); endasm();
    asm_inc(); asm_rname(_rold); endasm();
    asm_ld(); asm_rhigh(_rnew); asm_comma_a_eol();
    asm_lda_comma(); asm_mrgname(_rold); endasm();
    asm_inc(); asm_rname(_rold); endasm();
    asm_exa_eol();
    asm_lda_comma(); asm_mrgname(_rold); endasm();
    asm_ld(); asm_rhigh(_rold); asm_comma_a_eol();
    asm_exa_eol();
    asm_ld(); asm_rlow(_rold); asm_comma_a_eol();
  };
}

PROC emitztob()
{
  //asmstr(";emitztoa exprlvl="); asmuint(_exprlvl); endasm();
  IF (_exprlvl != 0x01) { //if (a == b)
    asm_ld(); /**rganame*/asm_rlow(_rnew); asm_comma(); asmc('0'); endasm();
    IF (_rnew != _RFAST4) {asmstr( "\tJR NZ,$+3" );
    }ELSE asmstr( "\tJR NZ,$+4" ); //ix
    endasm();
    asm_dec(); /**rganame*/asm_rlow(_rnew); endasm();
    _fused = +FALSE; //   if ((a==b))
    //_jpflag = 0x00;
  }ELSE {
    //_fused = +TRUE;
    _jpflag = 0x02;
  };
}

PROC emitinvztob()
{
  //asmstr(";emitinvztoa exprlvl="); asmuint(_exprlvl); endasm();
  IF (_exprlvl != 0x01) { //if (a != b)
    asm_ld(); /**rganame*/asm_rlow(_rnew); asm_comma(); asmc('0'); endasm();
    IF (_rnew != _RFAST4) {asmstr( "\tJR Z,$+3" );
    }ELSE asmstr( "\tJR Z,$+4" ); //ix
    endasm();
    asm_dec(); /**rganame*/asm_rlow(_rnew); endasm();
    _fused = +FALSE; //   if ((a!=b))? todo test //  ifnot ((a!=b))
    //_jpflag = 0x00;
  }ELSE {
    //_fused = +TRUE;
    _jpflag = 0x01;
  };
}

PROC emitcytob()
{
  //asmstr(";emitcytoa exprlvl="); asmuint(_exprlvl); endasm();
  IF (_exprlvl != 0x01) { //if (a < b)
    unproxy();
    asm_sbc(); asm_a(); asm_comma_a_eol();
    _rproxy = _rnew;
    //_fused = +FALSE;
    //_jpflag = 0x00;
  }ELSE {
    //_fused = +TRUE;
    _jpflag = 0x03;
  };
}

PROC emitinvcytob()
{
  //asmstr(";emitinvcytoa exprlvl="); asmuint(_exprlvl); endasm();
  IF (_exprlvl != 0x01) { //if (a >= b)
    asm_ccf_eol();
    unproxy();
    asm_sbc(); asm_a(); asm_comma_a_eol();
    _rproxy = _rnew;
    //_fused = +FALSE;
    //_jpflag = 0x00;
  }ELSE {
    //_fused = +TRUE;
    _jpflag = 0x04;
  };
}

PROC emitrgtob() //  - 
{
}

PROC emitbtorg()
{
  unproxy();
  asm_ld(); asm_rhigh(_rnew); asm_comma(); asmc('0'); endasm();
}

PROC emitincrg()
{
  asm_inc(); asm_rname(_rnew); endasm();
  _fused = +FALSE; // 
}

PROC emitincb_bypoi() //todo    [hl]
{
  asm_inc(); asm_open(); asm_rname(_rnew); asm_close(); endasm();
  _fused = +FALSE; // 
}
/**
PROC emitinclong() //todo
{
  asm_inc(); asm_open(); asm_rname(_rnew); asm_close(); endasm();
  _fused = +FALSE; // 
}
*/
PROC emitdecrg()
{
  asm_dec(); asm_rname(_rnew); endasm();
  _fused = +FALSE; // 
}

PROC emitdecb_bypoi() //todo    [hl]
{
  asm_dec(); asm_open(); asm_rname(_rnew); asm_close(); endasm();
  _fused = +FALSE; // 
}
/**
PROC emitdeclong() //todo
{
  asm_dec(); asm_open(); asm_rname(_rnew); asm_close(); endasm();
  _fused = +FALSE; // 
}
*/

/////////////
EXPORT PROC initcode()
{
  _RNAME[+(UINT)_RFAST] ="HL";
  _RNAME[+(UINT)_RFAST2]="DE";
  _RNAME[+(UINT)_RFAST3]="BC";
  _RNAME[+(UINT)_RFAST4]="IX";
  _RHIGH[+(UINT)_RFAST] ="H";
  _RHIGH[+(UINT)_RFAST2]="D";
  _RHIGH[+(UINT)_RFAST3]="B";
  _RHIGH[+(UINT)_RFAST4]="HX";
  _RLOW[+(UINT)_RFAST] ="L";
  _RLOW[+(UINT)_RFAST2]="E";
  _RLOW[+(UINT)_RFAST3]="C";
  _RLOW[+(UINT)_RFAST4]="LX";
  _jpflag = 0x00;
}

PROC initrgs()
{
  rgs_initrgs();
  _fused = +FALSE; //    initif   (   if, while, until)
  _rproxy = 0x00;
}

