#include <stdio.h>

#include "nedodefs.h" //C only

#define USE_HINTS
#define USE_COMMENTS

#include "emit.c" //  compile  asm (   )

#include "read.c" //  compile  token

//#include "codetg.c"
//#include "regs.c"
#include "commands.c"
#include "compile.c"

#include "fmttg.h" //  token, asm, export

#include "tokentg.c"
#include "token.c"

#include "asm.c"
#include "asmtg.c"

#include "exporttg.c"
#include "export.c"

PROC writearray(PBYTE parray, UINT size, PCHAR filename)
{
VAR PBYTE file;
  file = fopen(filename, "wb");
  fwrite(parray, size, 1, file);
  fclose(file);
}

int main(int argc,char* argv[])
{
  int i;
  char *filename;
  BOOL fcompile = +TRUE;
  BOOL ftokenize = +FALSE;
  BOOL fassemble = +FALSE;
  BOOL fexport = +FALSE;

  _ferr = openwrite("err.f");
  _errs = +TRUE;

  //filename = "_test.c";
  //_asms = +TRUE;
  _cmts = +FALSE;
  _hints = +FALSE;

  for (i=1; i<argc; i++) {
    if      ((argv[i][0]=='-')&&(argv[i][1]=='B')) {fassemble = +TRUE; fcompile = +FALSE; //i++; filename = argv[i];
    }else if((argv[i][0]=='-')&&(argv[i][1]=='T')) {ftokenize = +TRUE; fcompile = +FALSE; //i++; filename = argv[i];
    }else if((argv[i][0]=='-')&&(argv[i][1]=='E')) {fexport = +TRUE; fcompile = +FALSE; //i++; filename = argv[i];
    //}else if((argv[i][0]=='-')&&(argv[i][1]=='a')) {_asms = +FALSE;
    }else if((argv[i][0]=='-')&&(argv[i][1]=='C')) {_cmts = +TRUE;
    }else if((argv[i][0]=='-')&&(argv[i][1]=='H')) {_hints = +TRUE;
    }else {
      filename = argv[i];
      if (fcompile) {
        compile(filename);
        writearray((PBYTE)/**_lblbuf*/_lbls, /**_lblbufindex*//**_lblbuflen+0x200*/_LBLBUFSZ, "label.f");
    /**
        system("del asm.f");
        system("copy _test.asm asm.f");

        _fout = openwrite("tok.f"); //setfout( "ftok" ); //AssignFile(fout,'fout'); Rewrite(fout);
        _curline = 1;
        tokenize("asm.f");
        tokenize_end();
        closewrite(_fout); //closefout(); //CloseFile(fout);

        asmcompile();
      writearray((PBYTE)_labels0, _LABELPAGESIZE, "label0.f");
    */
      };
      if (ftokenize) {
        tokinit();
        tokenize(filename); //("asm.f");
        tokenize_end();
      };
      if (fassemble) {
        asmcompile(filename);
      writearray((PBYTE)_labels0, _LABELPAGESIZE, "label0.f");
      //writearray((PBYTE)_labels1, _LABELPAGESIZE, "label1.f");
      //writearray((PBYTE)_labels2, _LABELPAGESIZE, "label2.f");
      //writearray((PBYTE)_labels3, _LABELPAGESIZE, "label3.f");
      //writearray((PBYTE)_labels4, _LABELPAGESIZE, "label4.f");
      //writearray((PBYTE)_labels5, _LABELPAGESIZE, "label5.f");
      //writearray((PBYTE)_labels6, _LABELPAGESIZE, "label6.f");
      //writearray((PBYTE)_labels7, _LABELPAGESIZE, "label7.f");
      };
      if (fexport) {
        asmexport(filename);
      };
    };
  }; //for

  closewrite(_ferr);

  return 0;
}
