//#ifdef __BORLANDC__
//typedef unsigned long intptr_t;
//#else
//#include <stdint.h>
//#endif

#define TRUE 0xff
#define FALSE 0x00
#define CONST const
#define CHAR char
#define BYTE unsigned char
#define INT short int
#define UINT unsigned INT
#define LONG unsigned int
//#define FLOAT double
#define BOOL unsigned char
#define PBYTE BYTE*
#define PCHAR CHAR*
#define PBOOL BOOL*
#define PINT INT*
#define PUINT UINT*
#define PLONG LONG*
//#define PFLOAT FLOAT*
//#define POINTER intptr_t
//#define PPROC void*
#define EXTERN extern
#define FORWARD /**/
#define FUNC /**/
#define PROC void
#define BREAK break
#define RETURN return
#define VAR /**/
#define RECURSIVE /**/
#define POKE /**/
#define IF(x) if(x)
//#define IFNOT(x) if(!(x))
//#define IFZ(x) if(!(x))
//#define IFNZ(x) if(x)
#define ELSE else
#define WHILE(x) while(x)
//#define WHILENOT(x) while(!(x))
//#define WHILEZ(x) while(!(x))
//#define WHILENZ(x) while(x)
#define REPEAT do
#define UNTIL(x) while(!(x));
//#define UNTILNOT(x) while(x);
//#define UNTILZ(x) while(x);
//#define UNTILNZ(x) while(!(x));
#define ENUM enum
#define INC ++
#define DEC --
#define CALL(x) ((void(*)(void))(x))() /**  x,   */
#define STRUCT struct
#define EXPORT /**/

#include "str.h"

VAR PBYTE _fin;
VAR PBYTE _fout;
VAR BOOL _waseof;
//CONST UINT _STRLEN; /** 0*/
//CONST UINT _STRMAX; /**  0*/

FUNC BYTE readfin()
{
VAR BYTE c;
  //rd(handle, &c, 1);
  IF (+(UINT)fread(/*+*/(PBYTE)&c, +sizeof(BYTE), 1, _fin) == 0) {
    _waseof = +TRUE;
    c = '\n'; //EOF returns '\n'
  };
  RETURN c;
}

FUNC BYTE readf(PBYTE file)
{
VAR BYTE c;
  //rd(handle, &c, 1);
  IF (+(UINT)fread(/*+*/(PBYTE)&c, +sizeof(BYTE), 1, file) == 0) {
    _waseof = +TRUE;
    c = '\n'; //EOF returns '\n'
  };
  RETURN c;
}

PROC writefout(BYTE c)
{
  //writebyte(_fout, token);
  fwrite(/*+*/(PBYTE)&c, +sizeof(BYTE), 1, _fout);
}

FUNC PBYTE openwrite(PCHAR s)
{
  RETURN fopen(s, "wb");
}

PROC closewrite(PBYTE file)
{
  fclose(file);
}

PROC writebyte(PBYTE file, BYTE c)
{
  //fprintf(file,"%c",c);
  fwrite(/*+*/(PBYTE)&c, +sizeof(BYTE), 1, file);
}

FUNC UINT strjoin(PCHAR to, UINT tolen, PCHAR s2/**, UINT s2len*/) //  !
{ //to = to + s2;
VAR UINT len;
VAR CHAR c;
  to = &to[tolen/**+_FIRST*/];
  len = tolen; //  !
  loop: //REPEAT {
    c = *(PCHAR)s2;
    IF ((c == '\0') || (len>=_STRMAX)) goto endloop; //BREAK; //  
    POKE *(PCHAR)(to) = c;
    INC s2;
    INC to;
    INC len;
  goto loop; //}UNTIL ( (c=='\0') || (len>=_STRMAX) ); //  
  endloop:
  RETURN len; //  !
}

FUNC UINT strjoineol(PCHAR to, UINT tolen, PCHAR s2/**, UINT s2len*/, CHAR eol) //  !
{ //to = to + s2;
VAR UINT len;
VAR CHAR c;
  to = &to[tolen/**+_FIRST*/];
  len = tolen; //  !
  loop: //REPEAT {
    c = *(PCHAR)s2;
    IF ((c == eol) || (len>=_STRMAX)) goto endloop; //BREAK; //  
    POKE *(PCHAR)(to) = c;
    INC s2;
    INC to;
    INC len;
  goto loop; //}UNTIL ( (c==eol) || (len>=_STRMAX) ); //  
  endloop:
  RETURN len; //  !
}

FUNC UINT strcopy(PCHAR from, UINT len, PCHAR to) //  !
{
VAR UINT i = len+1;
VAR CHAR c;
  REPEAT {
    c = *(PCHAR)from;
    POKE *(PCHAR)(to) = c;
    INC from;
    INC to;
    DEC i;
  }UNTIL (i==0); //(c=='\0'); // 
  RETURN len; //  !
}

PROC memcopy(PBYTE from, UINT len, PBYTE to)
{
VAR CHAR c;
  REPEAT {
    c = *(PCHAR)from;
    POKE *(PCHAR)(to) = c;
    INC from;
    INC to;
    DEC len;
  }UNTIL (len==0);
}

FUNC BOOL strcp(PCHAR s1, PCHAR s2)
{
VAR UINT i;
VAR CHAR c1;
VAR BOOL ok;
  i = 0;
  ok = +TRUE; //   
  REPEAT { //    ,  
    //IF (s1[i] != s2[i]) { //       
    //  result = +FALSE;
    //  BREAK;
    //};
    c1 = s1[i];
    IF (c1 != s2[i]) {ok = +FALSE; BREAK; }; //       
    //IF (c1 == '\0') BREAK; //  
    INC i;
  }UNTIL (c1 == '\0'); //  
  //IF (s2[i] != '\0') result = +FALSE; //   
  RETURN ok;
}

/**
FUNC UINT strclear(PCHAR s)
{ //s = "";
  //s[_FIRST]='\0'; // (  -   strclose)
  RETURN 0; //  !
}
*/
FUNC UINT stradd(PCHAR s, UINT len, CHAR c) //  !
{ //s = s + c;
  IF (len < _STRMAX) {
    //POKE *(PCHAR)(+(POINTER)(s) + +(POINTER)(len) + +(POINTER)(_FIRST)) = c;
    s[len/**+_FIRST*/] = c;
    INC len;
    //s[len/**+_FIRST*/]='\0'; // (  -   strclose)
  };
  RETURN len;
}

//PROC strclose(PCHAR s, UINT len) //  strclear   stradd
//{
//  s[len/**+_FIRST*/] = '\0'; //
//}

//FUNC UINT strcopy(PCHAR from, UINT len, PCHAR to) //  !
//{
//  RETURN strjoin(to, 0/**strclear(to)*/, from); //tolen;
//}

/**
PROC stringdecapitalize(PCHAR s1, UINT s1len)
{
VAR UINT i;
VAR CHAR c;
  i = _FIRST;
  WHILE (+TRUE) {
    c = s1[i];
    IF (c == '\0') BREAK;
    IF ((c>='A') && (c<='Z')) {
      //POKE *(PCHAR)(+(POINTER)(s1) + +(POINTER)(i)) = c | +(CHAR)0x20;
      s1[i] = +(CHAR)(c | +(CHAR)0x20);
    };
    i = +(UINT)(i + 1);
  };
}
*/

FUNC BOOL strcplow(PCHAR s1/**, UINT s1len*/, PCHAR s2)
{
VAR UINT i;
VAR CHAR c1;
VAR CHAR c2;
VAR BOOL ok;
  i = 0;
  ok = +TRUE; //   
  REPEAT { //    ,  
    c1 = s1[i/**+_FIRST*/];
    c2 = s2[i/**+_FIRST*/];
    IF ((+(BYTE)c1>=+(BYTE)'A') && (+(BYTE)c1<=+(BYTE)'Z')) c1 = +(CHAR)(+(BYTE)c1 | 0x20);
    IF ((+(BYTE)c2>=+(BYTE)'A') && (+(BYTE)c2<=+(BYTE)'Z')) c2 = +(CHAR)(+(BYTE)c2 | 0x20);
    IF (c1 != c2) {ok = +FALSE; BREAK; }; //       
    //IF (c1 == '\0') BREAK; //  
    //IF (c2 == '\0') {result = +FALSE; BREAK; }; //   
    INC i;
  }UNTIL (c1 == '\0'); //  
  //IF (s2[i/**+_FIRST*/] != '\0') result = +FALSE; //   
  RETURN ok;
}

FUNC UINT hash(PBYTE pstr)
{
VAR UINT hash;
VAR BYTE c;
  hash = 0x0000;
  c = 0x00;
  REPEAT {
    c = c^(+(BYTE)hash);
    hash = hash + hash;
    c = c+(+(BYTE)hash);
    hash = (hash&0xff00) + +(UINT)c;
    c = *(PBYTE)(pstr); //    0x00
    INC pstr;
  }UNTIL (c == 0x00);
  RETURN hash;
};

FUNC UINT readfinstr(PBYTE pstr)
{
VAR UINT len;
VAR BYTE c;
  len = 0;
readfinstr0:
  c = readfin(); //EOF  '\n'
  IF (c==0x0d) goto readfinstr0; //skip 0x0d
  IF (c==+(BYTE)'\n') goto readfinstrq; //EOL or EOF
  POKE *(PBYTE)pstr = c;
  INC pstr;
  INC len;
  IF (len<_STRMAX) goto readfinstr0;
readfinstrq:
  POKE *(PBYTE)pstr = 0x00;
  INC len;
  RETURN len;
};
